<%=Indent(i, true)%>#region Data Access - Fetch
<% if(objInfo.UseTransactionalAttribute) {%>
<%=Indent(i)%>[Transactional(TransactionalTypes.<%=objInfo.TransactionType.ToString()%>)] 
<%}%>
<%=Indent(i)%>private void DataPortal_Fetch(Criteria criteria)
<%=Indent(i++)%>{
<%=Indent(i)%>Database db = DatabaseFactory.CreateDatabase();
<%=Indent(i)%>ExecuteFetch(db, criteria);
<%=Indent(--i)%>}

<%=Indent(i)%><%=objInfo.LocalMethodModifiers%> void ExecuteFetch(Database db, Criteria criteria)
<%=Indent(i++)%>{

<%=Indent(i)%>string sqlCommand = "<%=objInfo.FetchCommandText%>";

<%=Indent(i)%>using (DbCommand dbCommand = db.GetStoredProcCommand(sqlCommand))
<%=Indent(i++)%>{
<%=Indent(i)%>db.AddInParameter(dbCommand, "ID", DbType.Guid, criteria.Id);
<%=Indent(i)%>using (SafeDataReader dr = new SafeDataReader(db.ExecuteReader(dbCommand)))
<%=Indent(i++)%>{
<%=Indent(i)%>FetchObject(dr);
<%=Indent(i)%>ValidationRules.CheckRules();
<%=Indent(i)%>//load child object(s)
<%=Indent(i)%>FetchChildren(dr);
<%=Indent(--i)%>}
<%=Indent(--i)%>}
<%=Indent(--i)%>}


<% if(objInfo.CslaObjectType != ObjectType.EditableSwitchable) {%>
<%=Indent(i)%><%=objInfo.LocalMethodModifiers%> void FetchObject(SafeDataReader dr)
<%=Indent(i++)%>{
<%=Indent(i)%>dr.Read();
<% foreach(PropertyInfo prop in objInfo.Properties) { if (!prop.HasDbColumn) {continue;} %>
<%=Indent(i)%><%= GetReaderAssignmentStatement(prop) %>
<%}%>
<%if(objInfo.IsGeneratedPartial) {%>
<%=Indent(i)%>onFetchObjectComplete(dr);
<%}%>
<%=Indent(--i)%>}

<%=Indent(i)%><%=objInfo.LocalMethodModifiers%> void FetchChildren(SafeDataReader dr)
<%=Indent(i++)%>{
<% if(objInfo.HasChild) { %>
<% foreach(PropertyInfo prop in objInfo.ChildCollection) { %>
<%=Indent(i)%>dr.NextResult();
<%=Indent(i)%><%=string.Format("{0} = {1}.Get{1}(dr);", prop.MemberName, prop.Type)%>
<%}%>
<%}%>
<%if(objInfo.IsGeneratedPartial) {%>
<%=Indent(i)%>onFetchChildrenComplete(dr);
<%}%>
<%=Indent(--i)%>}
<%}%>
<%=Indent(i)%>#endregion //Data Access - Fetch
