﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;
using System.Data;
using System.Data.SqlClient;


namespace JMDCMS.BusinessObjects
{
    public class JmdSite : JMDCMS.BusinessObjects.JmdSiteBase<JmdSite>
    {

        #region Private Members

        private string _email;
        private string _userName;
        private string _passwordHash;
        private string _salt;


        #endregion

        #region Properties

        public string Email
        {
            get { return _email; }
            set { _email = value; }
        }

        public string UserName
        {
            get { return _userName; }
            set { _userName = value; }
        }

        public string PasswordHash
        {
            get { return _passwordHash; }
            set { _passwordHash = value; }
        }

        public string Salt
        {
            get { return _salt; }
            set { _salt = value; }
        }

        #endregion

        #region Legacy Methods

        public DataTable SaveLegacy()
        {
            this.SiteVersion = "4.0.0.1";
            this.SiteFolder = "SetSiteFolder";
            this.StyleSheet = "Userfiles/Style/JMDCMS/jmdcms.css";

            DataTable dt = new DataTable();

            using (SqlConnection cn = new SqlConnection(Database.JMDCMSConnection))
            {
                cn.Open();
                using (SqlCommand cm = cn.CreateCommand())
                {
                    cm.CommandType = CommandType.StoredProcedure;
                    cm.CommandText = "JMD_SITE_CREATE";

                    cm.Parameters.AddWithValue("@Site_URL",  this.SiteUrl);
                    cm.Parameters.AddWithValue("@Email", this.Email);
                    cm.Parameters.AddWithValue("@Style_Sheet", this.StyleSheet);
                    cm.Parameters.AddWithValue("@Site_Version",this.SiteVersion);
                    cm.Parameters.AddWithValue("@Site_Folder", this.SiteFolder);
                    cm.Parameters.AddWithValue("@User_Name", this.UserName);
                    cm.Parameters.AddWithValue("@Password_Hash", this.PasswordHash);
                    cm.Parameters.AddWithValue("@Salt", this.Salt);

                    using (SqlDataAdapter da = new SqlDataAdapter(cm))
                    {
                        da.Fill(dt);
                    }
                }
            }
            return dt;

            //DataSet ds = new DataSet();
            //return ds;
            //Database db = DatabaseFactory.CreateDatabase();

            //string sqlCommand = "JMD_SITE_CREATE";

            //using (DbCommand dbCommand = db.GetStoredProcCommand(sqlCommand))
            //{
            //    //@site_url nvarchar(255),
            //    //@email nvarchar(50),
            //    //@style_sheet nvarchar(255) = 'userfiles/style/jmdcms/jmdcms.css',
            //    //@site_version nvarchar(20) = '',
            //    //@site_folder nvarchar(255) = ''

            //    db.AddInParameter(dbCommand, "Site_URL", DbType.String, this.SiteUrl);
            //    db.AddInParameter(dbCommand, "Email", DbType.String, this.Email);
            //    db.AddInParameter(dbCommand, "Style_Sheet", DbType.String, this.StyleSheet);
            //    db.AddInParameter(dbCommand, "Site_Version", DbType.String, this.SiteVersion);
            //    db.AddInParameter(dbCommand, "Site_Folder", DbType.String, this.SiteFolder);
            //    db.AddInParameter(dbCommand, "User_Name", DbType.String, this.UserName);
            //    db.AddInParameter(dbCommand, "Password_Hash", DbType.String, this.PasswordHash);
            //    db.AddInParameter(dbCommand, "Salt", DbType.String, this.Salt);
            //    return db.ExecuteDataSet(dbCommand);
            //}
        }

        #endregion

        #region Exists

        public static bool Exists(string siteURL)
        {
            bool exists = false;

            using (SqlConnection cn = new SqlConnection(Database.JMDCMSConnection))
            {
                cn.Open();
                using (SqlCommand cm = cn.CreateCommand())
                {
                    cm.CommandType = CommandType.StoredProcedure;
                    cm.CommandText = "JMD_SITE_EXISTS_BY_NAME";
                    cm.Parameters.AddWithValue("@Site_URL", siteURL);

                    using (SqlDataAdapter da = new SqlDataAdapter(cm))
                    {
                        using (DataTable dt = new DataTable())
                        {
                            da.Fill(dt);
                            if (dt.Rows[0][0].ToString() != "0")
                            {
                                exists = true;
                            }
                        }
                    }
                }
            }
            return exists;
        }

        #endregion

    }
}
