

using System;
using System.Data;
using System.Data.SqlClient;
using Csla;
using Csla.Data;
using Csla.Validation;
using System.Data.Common;

namespace JMDCMS.BusinessObjects.WebHost
{
    [Serializable()]
    public class WebHostOSType : Csla.BusinessBase<WebHostOSType>
    {
        
        #region Business Properties and Methods

        //declare members
        private Guid _id = Guid.NewGuid();
        private string _osName = string.Empty;

        [System.ComponentModel.DataObjectField(true, false)]
        public Guid Id
        {
            get
            {
                CanReadProperty("Id", true);
                return _id;
            }
        }

        public string OsName
        {
            get
            {
                CanReadProperty("OsName", true);
                return _osName;
            }
            set
            {
                CanWriteProperty("OsName", true);
                if (value == null) value = string.Empty;
                if (!_osName.Equals(value))
                {
                    _osName = value;
                    PropertyHasChanged("OsName");
                }
            }
        }

        protected override object GetIdValue()
        {
            return _id;
        }

        #endregion //Business Properties and Methods


        #region Validation Rules
        private void AddCustomRules()
        {
            //add custom/non-generated rules here...
        }

        private void AddCommonRules()
        {
            //
            // OsName
            //
            ValidationRules.AddRule(CommonRules.StringRequired, "OsName");
            ValidationRules.AddRule(CommonRules.StringMaxLength, new CommonRules.MaxLengthRuleArgs("OsName", 50));
        }

        protected override void AddBusinessRules()
        {
            AddCommonRules();
            AddCustomRules();
        }
        #endregion //Validation Rules


        #region Authorization Rules
        protected override void AddAuthorizationRules()
        {
            //TODO: Define authorization rules in WebHostOSType
            //AuthorizationRules.AllowRead("Id", "WebHostOSTypeReadGroup");
            //AuthorizationRules.AllowRead("OsName", "WebHostOSTypeReadGroup");

            //AuthorizationRules.AllowWrite("OsName", "WebHostOSTypeWriteGroup");
        }


        public static bool CanGetObject()
        {
            //TODO: Define CanGetObject permission in WebHostOSType
            return true;
            //if (Csla.ApplicationContext.User.IsInRole("WebHostOSTypeViewGroup"))
            //	return true;
            //return false;
        }

        public static bool CanAddObject()
        {
            //TODO: Define CanAddObject permission in WebHostOSType
            return true;
            //if (Csla.ApplicationContext.User.IsInRole("WebHostOSTypeAddGroup"))
            //	return true;
            //return false;
        }

        public static bool CanEditObject()
        {
            //TODO: Define CanEditObject permission in WebHostOSType
            return true;
            //if (Csla.ApplicationContext.User.IsInRole("WebHostOSTypeEditGroup"))
            //	return true;
            //return false;
        }

        public static bool CanDeleteObject()
        {
            //TODO: Define CanDeleteObject permission in WebHostOSType
            return true;
            //if (Csla.ApplicationContext.User.IsInRole("WebHostOSTypeDeleteGroup"))
            //	return true;
            //return false;
        }
        #endregion //Authorization Rules


        #region Factory Methods_______________________________________________

        private WebHostOSType()
        { /* require use of factory method */ }

        public static WebHostOSType NewWebHostOSType()
        {
            if (!CanAddObject())
                throw new System.Security.SecurityException("User not authorized to add a WebHostOSType");
            return DataPortal.Create<WebHostOSType>();
        }

        public static WebHostOSType GetWebHostOSType(Guid id)
        {
            if (!CanGetObject())
                throw new System.Security.SecurityException("User not authorized to view a WebHostOSType");
            return DataPortal.Fetch<WebHostOSType>(new Criteria(id));
        }

        public static void DeleteWebHostOSType(Guid id)
        {
            if (!CanDeleteObject())
                throw new System.Security.SecurityException("User not authorized to remove a WebHostOSType");
            DataPortal.Delete(new Criteria(id));
        }

        public override WebHostOSType Save()
        {
            if (IsDeleted && !CanDeleteObject())
                throw new System.Security.SecurityException("User not authorized to remove a WebHostOSType");
            else if (IsNew && !CanAddObject())
                throw new System.Security.SecurityException("User not authorized to add a WebHostOSType");
            else if (!CanEditObject())
                throw new System.Security.SecurityException("User not authorized to update a WebHostOSType");

            return base.Save();
        }

        #endregion //Factory Methods ___________________________________________


        #region Data Access___________________________________________________


        #region Criteria

        [Serializable()]
        private class Criteria
        {
            public Guid Id;

            public Criteria(Guid id)
            {
                this.Id = id;
            }
        }

        #endregion //Criteria


        #region Data Access - Create
        [RunLocal]
        protected override void DataPortal_Create()
        {
            _id = Guid.NewGuid();
            ValidationRules.CheckRules();
        }

        #endregion //Data Access - Create


        #region Data Access - Fetch

        [Transactional(TransactionalTypes.TransactionScope)]
        private void DataPortal_Fetch(Criteria criteria)
        {
            //Database db = DatabaseFactory.CreateDatabase();
            //ExecuteFetch(db, criteria);
        }

        private void ExecuteFetch(Criteria criteria)
        {
            //string sqlCommand = "JMD_MOD_WEBHOST_OS_TYPE_Select";
            //using (DbCommand dbCommand = db.GetStoredProcCommand(sqlCommand))
            //{
            //    db.AddInParameter(dbCommand, "ID", DbType.Guid, criteria.Id);
            //    using (SafeDataReader dr = new SafeDataReader(db.ExecuteReader(dbCommand)))
            //    {

            //        FetchObject(dr);
            //        ValidationRules.CheckRules();
            //        //load child object(s)
            //        FetchChildren(dr);

            //    }
            //}

        }

        private void FetchObject(SafeDataReader dr)
        {
            dr.Read();
            _id = dr.GetGuid("ID");
            _osName = dr.GetString("OS_NAME");
        }

        private void FetchChildren(SafeDataReader dr)
        {
        }
        #endregion //Data Access - Fetch


        #region Data Access - Insert__________________________________________

        
        /// <summary>
        /// 
        /// </summary>
        [Transactional(TransactionalTypes.TransactionScope)]
        protected override void DataPortal_Insert()
        {
            //Database db = DatabaseFactory.CreateDatabase();
            //ExecuteInsert(db);

            //using (SqlConnection cn = new SqlConnection(Database.JMDCMSConnection))
            //{
            //    cn.Open();

            //    ExecuteInsert(cn);

            //    //update child object(s)
            //    UpdateChildren(cn);
            //}//using

        }


        /// <summary>
        /// 
        /// </summary>
        /// <param name="cn"></param>
        //private void ExecuteInsert(SqlConnection cn)
        private void ExecuteInsert()
        {
            //string sqlCommand = "JMD_MOD_WEBHOST_OS_TYPE_InsertUpdate";

            //using (DbCommand dbCommand = db.GetStoredProcCommand(sqlCommand))
            //{

            //    //db.AddInParameter(dbCommand, "ID", DbType.Guid, criteria.Id);

            //    AddUpdateParameters(db, dbCommand);
            //    db.ExecuteNonQuery(dbCommand);
            //}
            
            //using (SqlCommand cm = cn.CreateCommand())
            //{
            //    cm.CommandType = CommandType.StoredProcedure;
            //    cm.CommandText = "AddWebHostOSType";

            //    AddInsertParameters(cm);

            //    cm.ExecuteNonQuery();

            //}//using
        }


        /// <summary>
        /// 
        /// </summary>
        /// <param name="cm"></param>
        //private void AddInsertParameters(SqlCommand cm)
        private void AddInsertParameters(DbCommand dbCommand)
        {
            
            //db.AddInParameter(dbCommand, "ID", DbType.Guid, _id);
            //db.AddInParameter(dbCommand, "OS_NAME", DbType.String, _osName);

            //cm.Parameters.AddWithValue("@ID", _id);
            //cm.Parameters.AddWithValue("@OS_NAME", _osName);
        }


        #endregion //Data Access - Insert_____________________________________


        #region Data Access - Update__________________________________________

        [Transactional(TransactionalTypes.TransactionScope)]
        protected override void DataPortal_Update()
        {
            //Database db = DatabaseFactory.CreateDatabase();
            //ExecuteUpdate(db);

            //using (SqlConnection cn = new SqlConnection(Database.JMDCMSConnection))
            //{
            //    cn.Open();

            //    if (base.IsDirty)
            //    {
            //        ExecuteUpdate(cn);
            //    }

            //    //update child object(s)
            //    UpdateChildren(cn);
            //}//using

        }

        //private void ExecuteUpdate(SqlConnection cn)
        private void ExecuteUpdate()
        {
            //string sqlCommand = "JMD_MOD_WEBHOST_OS_TYPE_InsertUpdate";

            //using (DbCommand dbCommand = db.GetStoredProcCommand(sqlCommand))
            //{
                
            //    //db.AddInParameter(dbCommand, "ID", DbType.Guid, criteria.Id);

            //    AddUpdateParameters(db, dbCommand);
            //    db.ExecuteNonQuery(dbCommand);
            //}
            
            //using (SqlCommand cm = cn.CreateCommand())
            //{
            //    cm.CommandType = CommandType.StoredProcedure;
            //    cm.CommandText = "UpdateWebHostOSType";

            //    AddUpdateParameters(cm);

            //    cm.ExecuteNonQuery();

            //}//using
        }

        private void AddUpdateParameters(DbCommand dbCommand)
        {
            //db.AddInParameter(dbCommand, "ID", DbType.Guid, criteria.Id);
            //cm.Parameters.AddWithValue("@ID", _id);
            //cm.Parameters.AddWithValue("@OS_NAME", _osName);
            //db.AddInParameter(dbCommand, "ID", DbType.Guid, _id);
            //db.AddInParameter(dbCommand, "OS_NAME", DbType.String, _osName);
        }

        private void UpdateChildren(SqlConnection cn)
        {
        }
        
        #endregion //Data Access - Update_____________________________________


        #region Data Access - Delete__________________________________________

        [Transactional(TransactionalTypes.TransactionScope)]
        protected override void DataPortal_DeleteSelf()
        {
            DataPortal_Delete(new Criteria(_id));
        }


        [Transactional(TransactionalTypes.TransactionScope)]
        private void DataPortal_Delete(Criteria criteria)
        {
            //Database db = DatabaseFactory.CreateDatabase();
            //ExecuteDelete(db, criteria);
        }

        //private void ExecuteDelete(SqlConnection cn, Criteria criteria)
        private void ExecuteDelete(Criteria criteria)
        {
            //string sqlCommand = "JMD_MOD_WEBHOST_OS_TYPE_Delete";

            //using (DbCommand dbCommand = db.GetStoredProcCommand(sqlCommand))
            //{
            //    db.AddInParameter(dbCommand, "ID", DbType.Guid, criteria.Id); 
            //    db.ExecuteNonQuery(dbCommand);
            //}
        }


        #endregion //Data Access - Delete_____________________________________


        #endregion //Data Access______________________________________________

    }
}


