

using System;
using System.Data;
using System.Data.SqlClient;
using Csla;
using Csla.Data;
using Csla.Validation;
using System.Data.Common;


namespace JMDCMS.BusinessObjects.WebHost
{
    [Serializable()]
    public class WebHostOSTypeInfo : Csla.ReadOnlyBase<WebHostOSTypeInfo>
    {

        #region Constructors

        public WebHostOSTypeInfo(SafeDataReader dr)
        {
            this._id = dr.GetGuid("ID");
            this._osName = dr.GetString("OS_NAME");
        }
    
        #endregion


        #region Business Properties and Methods

        //declare members
        private Guid _id = Guid.NewGuid();
        private string _osName = string.Empty;

        [System.ComponentModel.DataObjectField(true, false)]
        public Guid Id
        {
            get
            {
                CanReadProperty("Id", true);
                return _id;
            }
        }

        public string OsName
        {
            get
            {
                CanReadProperty("OsName", true);
                return _osName;
            }
        }

        protected override object GetIdValue()
        {
            return _id;
        }

        #endregion //Business Properties and Methods


        #region Authorization Rules

        protected override void AddAuthorizationRules()
        {
            //TODO: Define authorization rules in WebHostOSTypeInfo
            //AuthorizationRules.AllowRead("Id", "WebHostOSTypeInfoReadGroup");
            //AuthorizationRules.AllowRead("OsName", "WebHostOSTypeInfoReadGroup");

        }
        
        public static bool CanGetObject()
        {
            //TODO: Define CanGetObject permission in WebHostOSTypeInfo
            return true;
            //if (Csla.ApplicationContext.User.IsInRole("WebHostOSTypeInfoViewGroup"))
            //	return true;
            //return false;
        }

        #endregion //Authorization Rules


        #region Factory Methods

        private WebHostOSTypeInfo()
        { /* require use of factory method */ }

        public static WebHostOSTypeInfo GetWebHostOSTypeInfo(Guid id)
        {
            if (!CanGetObject())
                throw new System.Security.SecurityException("User not authorized to view a WebHostOSTypeInfo");
            return DataPortal.Fetch<WebHostOSTypeInfo>(new Criteria(id));
        }

        #endregion //Factory Methods


        #region Data Access

        #region Criteria

        [Serializable()]
        private class Criteria
        {
            public Guid Id;

            public Criteria(Guid id)
            {
                this.Id = id;
            }
        }

        #endregion //Criteria


        #region Data Access - Fetch

        [Transactional(TransactionalTypes.TransactionScope)]
        private void DataPortal_Fetch(Criteria criteria)
        {
            //Database db = DatabaseFactory.CreateDatabase();
            //ExecuteFetch(db, criteria);
        }

        private void ExecuteFetch(Criteria criteria)
        {
            //string sqlCommand = "GetWebHostOSTypeInfo";
            //using (DbCommand dbCommand = db.GetStoredProcCommand(sqlCommand))
            //{
            //    db.AddInParameter(dbCommand, "ID", DbType.Guid, criteria.Id);
            //    using (SafeDataReader dr = new SafeDataReader(db.ExecuteReader(dbCommand)))
            //    {

            //        FetchObject(dr);
            //        //load child object(s)
            //        FetchChildren(dr);

            //    }
            //}

        }

        private void FetchObject(SafeDataReader dr)
        {
            dr.Read();
            _id = dr.GetGuid("ID");
            _osName = dr.GetString("OS_NAME");
        }

        private void FetchChildren(SafeDataReader dr)
        {
        }
        #endregion //Data Access - Fetch

        #endregion //Data Access

    }
}


