﻿/***************************************************************************** 
	Table: Person.Person
*/
IF  NOT EXISTS (SELECT * FROM sys.objects 
	WHERE object_id = OBJECT_ID(N'[Person].[Person]') AND type in (N'U'))
BEGIN

	CREATE TABLE [Person].[Person]
	(
		[PersonID] [int] identity(1,1) NOT NULL,
		[rowguid] [uniqueidentifier] ROWGUIDCOL  NOT NULL,
		[ModifiedDate] [datetime] NOT NULL,
	 CONSTRAINT [PK_Person_BusinessEntityID] PRIMARY KEY CLUSTERED 
	(
		[PersonID] ASC
	)
	)
	
	ALTER TABLE [Person].[Person] ADD  CONSTRAINT [DF_Person_rowguid]  DEFAULT (newid()) FOR [rowguid]
	ALTER TABLE [Person].[Person] ADD  CONSTRAINT [DF_Person_ModifiedDate]  DEFAULT (getdate()) FOR [ModifiedDate]

END /* Person.Person Table CREATE END */
ELSE
BEGIN
	ALTER TABLE [Person].[Person] ADD  [Title] [nvarchar](8) NULL
	ALTER TABLE [Person].[Person] ADD  [FirstName] [dbo].[Name] NOT NULL
	ALTER TABLE [Person].[Person] ADD  [MiddleName] [dbo].[Name] NULL
	ALTER TABLE [Person].[Person] ADD  [LastName] [dbo].[Name] NOT NULL
	ALTER TABLE [Person].[Person] ADD  [Suffix] [nvarchar](10) NULL
END
GO


/***************************************************************************** 
	Table: Person.Password
*/

IF  EXISTS (SELECT * FROM sys.objects 
	WHERE object_id = OBJECT_ID(N'[Person].[Password]') AND type in (N'U'))
BEGIN

	CREATE TABLE [Person].[Password]
	(
		[PersonID] [int] NOT NULL,
		[PasswordHash] [varchar](128) NOT NULL,
		[PasswordSalt] [varchar](10) NOT NULL,
		[rowguid] [uniqueidentifier] ROWGUIDCOL  NOT NULL,
		[ModifiedDate] [datetime] NOT NULL,
	 CONSTRAINT [PK_Password_PersonID] PRIMARY KEY CLUSTERED 
	(
		[PersonID] ASC
	)
	)
	
	ALTER TABLE [Person].[Password] ADD  CONSTRAINT [DF_Password_rowguid]  DEFAULT (newid()) FOR [rowguid]
	ALTER TABLE [Person].[Password] ADD  CONSTRAINT [DF_Password_ModifiedDate]  DEFAULT (getdate()) FOR [ModifiedDate]
	
	ALTER TABLE [Person].[Password]  WITH CHECK ADD  CONSTRAINT [FK_Password_Person_PersonID] FOREIGN KEY([PersonID])
	REFERENCES [Person].[Person] ([PersonID])
	

END /* Person.Password Table CREATE END */
GO