DROP PROCEDURE [dbo].[JMD_COL_SAVE]
go
CREATE PROCEDURE [dbo].[JMD_COL_SAVE]
  @JMD_COL_ID INT,
  @JMD_OBJ_ID INT,
  @JMD_COL_NAME NVARCHAR(50),
  @JMD_COL_CAPTION NVARCHAR(50),
  @JMD_COL_DESC Text,
  @JMD_COL_TYPE_ID INT,
  @COL_EXT_DATA Text
AS
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

  Declare
    @TableName nvarchar(100),
    @Col_Data_Type nvarchar(50),
    @Col_Id Int,
    @Jmd_Col_Ext_Id int

  Select
    @TableName = 'JMD_'+Convert(Varchar(50),Site_Id)+'_'++OBJ_NAME
  From
    JMD_OBJ
  Where
    ID = @JMD_OBJ_ID

  if not exists ( Select * From sysobjects where object_name(ID) = @TableName and Type = 'U' )
  begin
      Exec('Create Table '+@TableName+'(ID int identity(1,1) primary key not null)')
  end  

  if NOT exists ( select * from jmd_col where id = @JMD_COL_ID )
  begin 
    insert into jmd_col
    (
      jmd_obj_id, jmd_col_name, jmd_col_caption, jmd_col_desc, jmd_col_type_Id
    )
    values
    (
      @jmd_obj_id, @jmd_col_name, @jmd_col_caption, @jmd_col_desc, @jmd_col_type_Id
    )
    Select
      @Col_Id = SCOPE_IDENTITY() 

    if not exists ( 
      Select * From syscolumns 
        Where  object_name(id) = @TableName and 
              [Name] = @JMD_COL_NAME 
          )
    begin
      Select
        @Col_Data_Type = Col_Data_Type
      From
        JMD_Col_Type
      Where
        Id = @JMD_COL_TYPE_ID
        
      exec('Alter Table '+@TableName+' Add '+@JMD_COL_NAME+' '+@Col_Data_Type+' NULL ' )
    end

    Exec 
      JMD_COL_EXT_SAVE '0', @Col_Id, @COL_EXT_DATA

  end
  else
  begin
    Update
      JMD_COL
    Set
      jmd_obj_id = @jmd_obj_id,
      jmd_col_name = @jmd_col_name, 
      jmd_col_caption = @jmd_col_caption, 
      jmd_col_desc = @jmd_col_desc, 
      jmd_col_type_Id = @jmd_col_Type_Id
    Where
      Id = @Jmd_Col_Id

    Select
      @Jmd_Col_Ext_Id = ID
    From
      JMD_COL_EXT
    Where
      JMD_COL_ID = @Jmd_Col_Id

    Select
      @Jmd_Col_Ext_Id = Coalesce(@Jmd_Col_Ext_Id,0)

    Exec 
      JMD_COL_EXT_SAVE @Jmd_Col_Ext_Id , @Jmd_Col_Id, @COL_EXT_DATA

  end

go