DROP PROCEDURE [dbo].[JMD_COL_TYPE_SAVE]
GO
CREATE PROCEDURE [dbo].[JMD_COL_TYPE_SAVE]
  @JMD_COL_TYPE_ID INT ,
  @SITE_URL NVARCHAR(255),
  @COL_TYPE NVARCHAR(50),
  @COL_DATA_TYPE NVARCHAR(50)
As
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

  Declare
    @Site_Id int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)    

  if not exists ( Select * from JMD_COL_TYPE Where id = @JMD_COL_TYPE_ID )
  begin
    Insert into JMD_COL_TYPE
    (
      SITE_ID,
      COL_TYPE,
      COL_DATA_TYPE
    )
    values
    (
      @SITE_ID,
      @COL_TYPE,
      @COL_DATA_TYPE
    )
  end
  else
  begin
    Update
      JMD_COL_TYPE
    Set
      SITE_ID = @SITE_ID,
      COL_TYPE = @COL_TYPE,
      COL_DATA_TYPE = @COL_DATA_TYPE
    Where
      Id = @JMD_COL_TYPE_ID     
  end
GO