DROP PROCEDURE [dbo].[JMD_CONTENT_TEMPLATE_SAVE]
GO
/*****************************************************************************
  NAME: JMD_CONTENT_TEMPLATE_SAVE
  PURPOSE: User Insert
*****************************************************************************/
CREATE PROCEDURE [dbo].[JMD_CONTENT_TEMPLATE_SAVE]
  @Id int,
  @Site_URL nvarchar(255),
  @TEMPLATE_NAME NVARCHAR(255),
  @TEMPLATE_TEXT NVARCHAR(MAX)

As

/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

  Declare
    @Site_Id int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  

  if not exists ( Select * from JMD_CONTENT_TEMPLATE where ID = @ID)
  begin
    Insert into JMD_CONTENT_TEMPLATE
    (
      Site_Id,
      [TEMPLATE_NAME],
      TEMPLATE_TEXT
    )
    values
    (
      @Site_Id,
      @TEMPLATE_NAME,
      @TEMPLATE_TEXT
    )
  end
  else
  begin
      Update
        JMD_CONTENT_TEMPLATE
      Set
        [TEMPLATE_NAME] = @TEMPLATE_NAME,
        TEMPLATE_TEXT = @TEMPLATE_TEXT
      Where
        ID = @ID
  end

GO