DROP PROCEDURE [dbo].[JMD_DIV_SAVE]
GO
/*
  Select * From JMD_DIV
sp_help jmd_div
*/
CREATE PROCEDURE [dbo].[JMD_DIV_SAVE]
  @Div_Id int,
  @Site_URL nvarchar(255),
  @Div_Name nvarchar(50),
  @Div_Sort int,
  @Parent_Div_Id int,
  @Is_Internal int
AS
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

  Declare
    @Site_Id int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  

  if not exists ( Select * from JMD_DIV where id = @Div_Id)
  begin
    Insert into JMD_DIV
    (
      Site_Id, Div_Name, Div_Sort, Parent_Div_Id, Is_Internal
    )
    values
    (
      @Site_Id, @Div_Name, @Div_Sort, @Parent_Div_Id, @Is_Internal
    )
  end
  else
  begin
    Update
      JMD_DIV
    Set
      Site_Id = @Site_Id,
      Div_Name = @Div_Name,
      Div_Sort = @Div_Sort,
      Parent_Div_Id = @Parent_Div_Id,
      Is_Internal = @Is_Internal
    Where
      Id = @Div_Id
  end
GO