DROP PROCEDURE [dbo].[JMD_LOAD_MODS]
GO
CREATE PROCEDURE [dbo].[JMD_LOAD_MODS]
  @Site_URL nvarchar(255),
  @Page_Name nvarchar(255)
As
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

  Declare
    @Site_Id int,
    @Page_Id int,
    @Load_Shared_Modules int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  

  if ( Coalesce(@Site_Id,0) != 0 )
  begin

    Select
      @Load_Shared_Modules = Load_Shared_Modules
    From
      Jmd_Page
    Where
      Site_Id = @Site_Id and
      Page_Name = @Page_Name    

    if ( Coalesce(@Load_Shared_Modules,0) = 1 )
    begin
      Select
        *
      From
        JMD_PAGE_MOD_SELECT
      Where
        Site_Id = @Site_Id and
        ( Page_Name = @Page_Name OR Show_On_All_Pages = 1 ) 
      Order By
        Parent_Div_Id, Div_Sort, Mod_Sort
    end
    else
    begin
      Select
        *
      From
        JMD_PAGE_MOD_SELECT
      Where
        Site_Id = @Site_Id and
        Page_Name = @Page_Name
      Order By
        Parent_Div_Id, Div_Sort, Mod_Sort
    
      --Select
      --  *
      --From
      --  JMD_PAGE_MOD_SELECT
      --Where
      --  Site_Id = @Site_Id and
      --  ( Page_Name = @Page_Name OR Show_On_All_Pages = 1 ) and
      --  ( Div_Name not in ('Left','Right','Center') Or Page_Name = @Page_Name)
      --Order By
      --  Parent_Div_Id, Div_Sort, Mod_Sort
    end
  end
  else
  begin
    Select
      Error = 'No Site Defined for the URL'
  end

  Select
    @Page_Id = Id
  From
    JMD_Page
  Where
    Site_Id = @Site_Id and
    Page_Name = @Page_Name

  Exec 
    JMD_PAGE_MOD_EXCLUDE_Select @Page_Id

GO