DROP PROCEDURE [dbo].[JMD_MAIN_MENU]
GO
/*****************************************************************************
  NAME: JMD_MAIN_MENU
  PURPOSE: Main Menu
  Exec JMD_MAIN_MENU 'JMDCMS.Web'
  select * from jmd_site
  select * from jmd_page
*****************************************************************************/
CREATE PROCEDURE [dbo].[JMD_MAIN_MENU]
  @Site_URL nvarchar(255)
AS
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

  Declare
    @Site_Id Int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  

  if ( Coalesce(@Site_Id,0) != 0 )
  begin
    Select
      *
    From
      JMD_Page
    Where
      Site_Id = @Site_Id and
      Is_Root = 1
    Order By
      Page_Sort
  end
  else
  begin
    Select
      Error = 'No Site Defined for the URL'
  end

GO