DROP PROCEDURE DBO.JMD_MOD_ADMIN_INIT
GO
CREATE PROCEDURE DBO.JMD_MOD_ADMIN_INIT
	@SITE_URL nvarchar(255)
AS
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
	
	Author: Ajay Handa
	Purpose: Initialize default Admin Configuration Options
	
	WI: 650 - Admin Module
*/
  Declare
    @Site_Id int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  
  
/*******************************************************************
	PROP_TYPE Values
	1 = Text
	2 = CheckBox
	3 = CheckBoxList
	4 = Radio Buttons
	5 = Combo Box
	6 = List Box
*/
/*******************************************************************
   Module Admin Options
*/
Delete JMD_MOD_ADMIN
	
Insert Into JMD_MOD_ADMIN
(
	Site_Id, Prop_Tab, Prop_Tab_Sort, Prop_Group, Prop_Group_Sort,
	Prop_Code, Prop_Code_Sort, Prop_Caption, Prop_Desc, Prop_Type,
	Prop_Input_Values, Prop_Value
)
values
(
	@Site_Id, 'Options', 1, 'Modules', 1,
	'ShowDelMods', 1, 'Show Deleted Modules', 'Show Deleted Modules', 2,
	'False', 'False'
)

Insert Into JMD_MOD_ADMIN
(
	Site_Id, Prop_Tab, Prop_Tab_Sort, Prop_Group, Prop_Group_Sort,
	Prop_Code, Prop_Code_Sort, Prop_Caption, Prop_Desc, Prop_Type,
	Prop_Input_Values, Prop_Value
)
values
(
	@Site_Id, 'Options', 1, 'Modules', 1,
	'ShowUnPubMods', 1, 'Show Unpublished Modules', 'Show Unpublished Modules', 2,
	'False', 'False'
)

GO
