DROP PROCEDURE [dbo].[JMD_MOD_BreadCrumbs]
GO
/*
Select * from jmd_page
*/
CREATE PROCEDURE [dbo].[JMD_MOD_BreadCrumbs]
  @Site_URL nvarchar(255),
  @Page_Name nvarchar(255)
As

/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

  Declare
    @Site_Id int,
    @SeqCtr int,
    @Parent_Page_Id int,
    @Parent_Page_Name nvarchar(255),
    @Parent_Page_Caption nvarchar(255),
    @Page_Caption nvarchar(255)


  Select
    @SeqCtr = 1000

  
  
  Create table #BreadCrumbs
  (
    Seq int,
    Page_Name nvarchar(255),
    Page_Caption nvarchar(255)
  )
  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  
  
  if exists ( select * from JMD_PAGE 
              where 
               Site_id = @Site_Id and 
                Page_Name = @Page_Name and
                Coalesce(Parent_Page_Id,0) <> 0 )
  begin

    Select
      @Page_Caption = Page_Caption,
      @Parent_Page_Id = Parent_Page_Id, 
      @Parent_Page_Name = ( Select Page_Name From JMD_Page  b where b.Id = a.Parent_Page_Id ),
      @Parent_Page_Caption = ( Select Page_Caption From JMD_Page  b where b.Id = a.Parent_Page_Id ) 
    From
      JMD_Page a
    Where
       Site_id = @Site_Id and 
       Page_Name = @Page_Name

    Insert into #BreadCrumbs
    (
      Seq, Page_Name, Page_Caption
    )
    values
    (
      @SeqCtr, @Page_Name, @Page_Caption
    )

    while ( Coalesce(@Parent_Page_Id,0) <> 0 )
    begin

      Select
        @SeqCtr = @SeqCtr - 1

      Insert into #BreadCrumbs
      (
        Seq, Page_Name, Page_Caption
      )
      values
      (
        @SeqCtr,@Parent_Page_Name, @Parent_Page_Caption
      )

      Select
        @Parent_Page_Id = Parent_Page_Id, 
        @Parent_Page_Name = ( Select Page_Name From JMD_Page  b where b.Id = a.Parent_Page_Id ),
        @Parent_Page_Caption = ( Select Page_Caption From JMD_Page  b where b.Id = a.Parent_Page_Id )

      From
        JMD_Page a
      Where
         Site_id = @Site_Id and 
         Page_Name = @Parent_Page_Name
      
      if ( coalesce(@SeqCtr,0) <= 0 )
      begin
        break
      end

    end
  end
/*
  else
  begin
    
    Insert into #BreadCrumbs
    (
      Seq, Page_Name
    )
    values
    (
      10000, @Page_Name
    )
    
  end
*/
  Select
    *
  From
    #BreadCrumbs
  Order By
    Seq
GO    
