DROP PROCEDURE [dbo].[JMD_MOD_HTML_LEFT_MENU]
GO
/*****************************************************************************
  NAME: JMD_MOD_HTML_LEFT_MENU
  PURPOSE: Left Vertical Menu
*****************************************************************************/
CREATE PROCEDURE [dbo].[JMD_MOD_HTML_LEFT_MENU]
  @Site_URL nvarchar(255),
  @Page_Name nvarchar(255)
AS
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.

	WI:1436 - Filter out the deleted pages.

*/

  Declare
    @Site_Id int,
    @Page_Id int,
    @Page_Caption  nvarchar(50),
    @Parent_Page_Id int,
    @Parent_Page_Name nvarchar(50),
    @Parent_Page_Caption nvarchar(50),
    @View_Roles nvarchar(1000)

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  

  
  Select
    @Page_Id = Id, @Page_Caption = Page_Caption, 
    @Parent_Page_Id = Parent_Page_Id, @View_Roles = View_Roles
  From
    JMD_Page
  Where
    Site_Id = @Site_Id and
    Page_Name = @Page_Name

  if not exists 
    ( 
      Select * From JMD_PAGE
        Where
          Parent_Page_Id = @Page_Id and
          Is_Menu_Item = 1 and
          Is_Published = 1 and
		  Is_Deleted = 0	
    )
  begin
    Select
      @Page_Id = Id, @Page_Name = Page_Name, @Page_Caption = Page_Caption, 
      @Parent_Page_Id = Parent_Page_Id, @View_Roles = View_Roles
    From
      JMD_Page
    Where
      Site_Id = @Site_Id and
      Id = @Parent_Page_Id
  end
    


  if ( Coalesce(@Parent_Page_Id,-1) != -1 )
  begin
    Select
      @Parent_Page_Name = Page_Name, 
      @Parent_Page_Caption = Page_Caption, @View_Roles = View_Roles
    From
      JMD_PAGE
    Where
      Site_Id = @Site_Id and
      Id = @Parent_Page_Id and
	  Is_Deleted = 0
  end
  
  -- Current Page and Parent Page
  Select
    Page_Id = @Page_Id, Page_Name = @Page_Name, Page_Caption = @Page_Caption, 
    Parent_Page_Name = @Parent_Page_Name, Parent_Page_Caption = @Parent_Page_Caption,
    View_Roles = @View_Roles

  -- Child Pages
  Select
    Page_Name, Page_Caption, View_Roles, Page_Sort, 
    Is_Menu_Item, Is_Published, Is_Deleted
  From
    JMD_PAGE
  Where
    Parent_Page_Id = @Page_Id and
	Is_Deleted = 0
  Order By
    Page_Sort

GO
