DROP PROCEDURE [dbo].[JMD_MOD_HTML_SAVE]
GO
-- Select * from JMD_MOD_HTML

CREATE PROCEDURE [dbo].[JMD_MOD_HTML_SAVE]
  @Page_Mod_Id int,
  @Title nvarchar(255),
  @HTML_Text nvarchar(MAX),
  @Site_URL nvarchar(255) = null,  
  @Site_CSS nvarchar(MAX) = null
As
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
  Declare
    @Site_Id int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  

  If not exists ( Select * From JMD_MOD_HTML where page_mod_id = @Page_Mod_Id)
  begin
    Insert into JMD_MOD_HTML
    (
        Page_Mod_Id,
        Title,
        HTML_Text 
    )
    values
    (
        @Page_Mod_Id,
        @Title,
        @HTML_Text
    )
  end
  else
  begin
    Update
      JMD_MOD_HTML
    Set
        Title = @Title,
        HTML_Text = @HTML_Text
    Where
      Page_Mod_Id = @Page_Mod_Id
  end 
  
  if (@Site_CSS != null)
  begin
	  update 
		JMD_SITE 
	  Set
		Site_CSS = @Site_CSS
	  where ID = @Site_Id	
  end
GO  
