DROP PROCEDURE [dbo].[JMD_MOD_INIT]
GO
/*
  Select * From JMD_MOD
  Exec JMD_MOD_SAVE
    0, 'JMDCMS.Web', 'NewRecord.ascx', '\Modules\Forms\',Null, 'Dynamic Forms', 1, 0 
*/
CREATE PROCEDURE [dbo].[JMD_MOD_INIT]
  @SITE_URL nvarchar(255)
As
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

  /***************************************************************************
	Author: Ajay Handa
	Purpose: Initialized default modules at the time of new site creation

	WI:650:handaajay15:mar/18/2007 - Add Admin module
	WI:650:handaajay15:mar/18/2007 - Add File Manager Module
	JMDHTMLEdit module - Header controls removed
  */
  /***************************************************************************
   * PAGE MANAGEMENT MODULES
  */
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'Pages.ascx', '\Modules\Admin\',Null, 'Pages Admin', 1, 0 

  -- AddPage.ascx
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'AddPage.ascx', '\Modules\Admin\',Null, 'Add Page', 1, 0 

  -- DeletePage.ascx
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'DeletePage.ascx', '\Modules\Admin\',Null, 'Delete Page', 1, 0 


  -- Login.ascx
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'Login.ascx', '\Modules\Admin\',Null, 'Login', 1, 0 

  -- AddModule.ascx
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'AddModule.ascx', '\Modules\Admin\',Null, 'Add Module', 1, 0 

  -- JMDHTMLMenuLeft.ascx
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'JMDHTMLMenuLeft.ascx', '\Modules\JMDHTML\',Null, 'HTML Menu', 0, 0 

  -- JMDHTML.ascx
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'JMDHTML.ascx', '\Modules\JMDHTML\','JMDHTMLEdit.aspx', 'HTML Doc', 0, 1 

  -- JMDHTMLEdit.ascx
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'JMDHTMLEdit.ascx', '\Modules\JMDHTML\',Null, 'HTML Edit', 1, 0 

  -- MenuTop.ascx
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'MenuTop.ascx', '\Modules\Core\',Null, 'Top Menu', 1, 0 

  -- MenuTop.ascx
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'MenuMain.ascx', '\Modules\Core\',Null, 'Main Menu', 1, 0 

  -- BrowseForms.ascx
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'BrowseForms.ascx', '\Modules\Forms\',Null, 'Browse Forms', 1, 0 

  -- NewForm.ascx
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'NewForm.ascx', '\Modules\Forms\',Null, 'New Form', 1, 0 

  -- NewCol.ascx
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'BrowseCols.ascx', '\Modules\Forms\',Null, 'Browse Columns', 1, 0 

  -- NewCol.ascx
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'NewCol.ascx', '\Modules\Forms\',Null, 'New Column', 1, 0 

  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'NewRecord.ascx', '\Modules\Forms\',Null, 'Dynamic Forms', 1, 0 

  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'DynamicForms.ascx', '\Modules\Research\',Null, 'Dynamic Forms', 1, 0 

  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'LookupDialog.ascx', '\Modules\Forms\',Null, 'Lookup Dialog', 1, 0 

  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'DeletePageModule.ascx', '\Modules\Admin\',Null, 'Delete Page Module', 1, 0 

  /***************************************************************************
   * Administration  MODULES
  */

  -- WI: 650 - Add Admin module
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'Admin.ascx', '\Modules\Admin\',Null, 'Site Administration', 1, 0 

  -- WI:650:handaajay15:mar/18/2007 - Add File Manager Module
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'FileManager.ascx', '\Modules\Admin\',Null, 'File Manager', 1, 0 

  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'Users.ascx', '\Modules\Admin\',Null, 'Users Admin', 1, 0 

  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'NewUser.ascx', '\Modules\Admin\',Null, 'New User', 1, 0 

  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'UserRoles.ascx', '\Modules\Admin\',Null, 'New User', 1, 0 

  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'DeleteUser.ascx', '\Modules\Admin\',Null, 'New User', 1, 0 

  /***************************************************************************
   * ROLES MANAGEMENT MODULES
  */
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'Roles.ascx', '\Modules\Admin\',Null, 'Roles Admin', 1, 0 
 
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'AddRole.ascx', '\Modules\Admin\',Null, 'Add Role', 1, 0 

  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'DeleteRole.ascx', '\Modules\Admin\',Null, 'Delete Role', 1, 0 

  /***************************************************************************
   * MODULE MANAGEMENT MODULES
  */
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'Modules.ascx', '\Modules\Admin\',Null, 'Modules Admin', 1, 0 

  /***************************************************************************
   * SMO MANAGEMENT MODULES
  */
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'SMO.ascx', '\Modules\SMO\',Null, 'SQL Server Management', 1, 0 

  /***************************************************************************
   * BREADCRUMBS
  */
  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'BreadCrumbs.ascx', '\Modules\Core\',Null, 'Bread Crumbs', 1, 0 


  /***************************************************************************
   * JOBS PORTAL MODULES - Employee Registeration
		WI:650:Removed module, will be added in later versions.
  */


  /***************************************************************************
   * NEW SITE INSTALLATION
  */

  Exec JMD_MOD_SAVE
    0, @SITE_URL, 'Install.ascx', '\Modules\Admin\',Null, 'Installation', 1, 0 

GO