DROP PROCEDURE [dbo].[JMD_MOD_SAVE]
GO
CREATE PROCEDURE [dbo].[JMD_MOD_SAVE]
  @Mod_Id int,
  @Site_URL nvarchar(255),
  @Mod_Name nvarchar(255),
  @Mod_Path nvarchar(1000),
  @Mod_Edit_Form nvarchar(255),
  @Mod_Friendly_Name nvarchar(255),
  @Is_Admin int,
  @Can_Show_Mod_Header int  
As
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

  Declare
    @Site_Id int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  

  if not exists 
	( 
		Select * from JMD_MOD where ( Id = @Mod_Id ) OR 
		( Site_Id = @Site_Id and Mod_Name = @Mod_Name and Mod_Path = @Mod_Path ) 
	)
  begin
    Insert into JMD_MOD
    (
      Site_Id, Mod_Name, Mod_Path, Mod_Edit_Form, 
      Mod_Friendly_Name, Is_Admin, Can_Show_Mod_Header
    )
    values
    (
      @Site_Id, @Mod_Name, @Mod_Path, @Mod_Edit_Form, 
      @Mod_Friendly_Name, @Is_Admin, @Can_Show_Mod_Header
    )
  end
  else
  begin
	if @Mod_Id = 0
	begin
		Select
			@Mod_Id = Id 
		From
			JMD_MOD
		Where
			Site_Id = @Site_Id and 
			Mod_Name = @Mod_Name and 
			Mod_Path = @Mod_Path
	end
    Update
      JMD_MOD
    Set
      Site_Id = @Site_Id,
      Mod_Name = @Mod_Name,
      Mod_Path = @Mod_Path,
      Mod_Edit_Form = @Mod_Edit_Form,
      Mod_Friendly_Name = @Mod_Friendly_Name,
      Is_Admin = @Is_Admin,
      Can_Show_Mod_Header = @Can_Show_Mod_Header
    Where
      Id = @Mod_Id
  end
GO