--region Drop Existing Procedures

IF OBJECT_ID(N'[dbo].[JMD_MOD_WEBHOST_OS_TYPE_InsertUpdate]') IS NOT NULL
	DROP PROCEDURE [dbo].[JMD_MOD_WEBHOST_OS_TYPE_InsertUpdate]

IF OBJECT_ID(N'[dbo].[JMD_MOD_WEBHOST_OS_TYPE_Delete]') IS NOT NULL
	DROP PROCEDURE [dbo].[JMD_MOD_WEBHOST_OS_TYPE_Delete]

IF OBJECT_ID(N'[dbo].[JMD_MOD_WEBHOST_OS_TYPE_Select]') IS NOT NULL
	DROP PROCEDURE [dbo].[JMD_MOD_WEBHOST_OS_TYPE_Select]

IF OBJECT_ID(N'[dbo].[JMD_MOD_WEBHOST_OS_TYPE_SelectAll]') IS NOT NULL
	DROP PROCEDURE [dbo].[JMD_MOD_WEBHOST_OS_TYPE_SelectAll]

--endregion

GO

--region [dbo].[JMD_MOD_WEBHOST_OS_TYPE_InsertUpdate]


CREATE PROCEDURE [dbo].[JMD_MOD_WEBHOST_OS_TYPE_InsertUpdate]
	@ID uniqueidentifier,
	@OS_NAME nvarchar(50)
AS

/*
Copyright (C) 2007  Ajay Handa - jmdcms.com
This program is free software;
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
License for more details.
Some rights reserved. Please read License.txt for details.
Removing above copyright message is a violation of license terms.
*/

SET NOCOUNT ON

IF EXISTS(SELECT [ID] FROM [dbo].[JMD_MOD_WEBHOST_OS_TYPE] WHERE [ID] = @ID)
BEGIN
	UPDATE [dbo].[JMD_MOD_WEBHOST_OS_TYPE] SET
		[OS_NAME] = @OS_NAME
	WHERE
		[ID] = @ID
END
ELSE
BEGIN
	INSERT INTO [dbo].[JMD_MOD_WEBHOST_OS_TYPE] (
		[ID],
		[OS_NAME]
	) VALUES (
		@ID,
		@OS_NAME
	)
END

SELECT * FROM [dbo].[JMD_MOD_WEBHOST_OS_TYPE]

--endregion

GO

--region [dbo].[JMD_MOD_WEBHOST_OS_TYPE_Delete]


CREATE PROCEDURE [dbo].[JMD_MOD_WEBHOST_OS_TYPE_Delete]
	@ID uniqueidentifier
AS

/*
Copyright (C) 2007  Ajay Handa - jmdcms.com
This program is free software;
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
License for more details.
Some rights reserved. Please read License.txt for details.
Removing above copyright message is a violation of license terms.
*/

SET NOCOUNT ON

DELETE FROM [dbo].[JMD_MOD_WEBHOST_OS_TYPE]
WHERE
	[ID] = @ID

--endregion

GO

--region [dbo].[JMD_MOD_WEBHOST_OS_TYPE_Select]


CREATE PROCEDURE [dbo].[JMD_MOD_WEBHOST_OS_TYPE_Select]
	@ID uniqueidentifier
AS

/*
Copyright (C) 2007  Ajay Handa - jmdcms.com
This program is free software;
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
License for more details.
Some rights reserved. Please read License.txt for details.
Removing above copyright message is a violation of license terms.
*/

SET NOCOUNT ON
SET TRANSACTION ISOLATION LEVEL READ COMMITTED

SELECT
	[ID],
	[OS_NAME]
FROM
	[dbo].[JMD_MOD_WEBHOST_OS_TYPE]
WHERE
	[ID] = @ID

--endregion

GO

--region [dbo].[JMD_MOD_WEBHOST_OS_TYPE_SelectAll]


CREATE PROCEDURE [dbo].[JMD_MOD_WEBHOST_OS_TYPE_SelectAll]
AS

/*
Copyright (C) 2007  Ajay Handa - jmdcms.com
This program is free software;
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
License for more details.
Some rights reserved. Please read License.txt for details.
Removing above copyright message is a violation of license terms.
*/

SET NOCOUNT ON
SET TRANSACTION ISOLATION LEVEL READ COMMITTED

SELECT
	[ID],
	[OS_NAME]
FROM
	[dbo].[JMD_MOD_WEBHOST_OS_TYPE]

--endregion

GO

