DROP PROCEDURE [dbo].[JMD_OBJ_SAVE]
GO
CREATE PROCEDURE [dbo].[JMD_OBJ_SAVE]
  @JMD_OBJ_ID INT ,
  @SITE_URL nvarchar(255),
  @OBJ_NAME NVARCHAR(100),
  @OBJ_TYPE INT,
  @OBJ_DESC NVARCHAR(1000),
  @PARENT_OBJ_ID INT,
  @IS_INTERNAL INT
AS
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

  Declare
    @Site_Id int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL) 

  if not exists ( Select * From JMD_OBJ Where ID = @JMD_OBJ_ID )
  begin
    Insert into JMD_OBJ
    (
      Site_Id, Obj_Name, Obj_Type, Obj_Desc, Parent_Obj_Id, Is_Internal
    ) 
    values    
    (
      @Site_Id, @Obj_Name, @Obj_Type, @Obj_Desc, @Parent_Obj_Id, @Is_Internal
    )
  end
  else
  begin
    Update
      JMD_OBJ
    Set
      Site_Id = @Site_Id,
      Obj_Name = @Obj_Name,
      Obj_Type = @Obj_Type,
      Obj_Desc = @Obj_Desc,
      Parent_Obj_Id = @Parent_Obj_Id,
      Is_Internal = @Is_Internal
    Where
      Id = @Jmd_Obj_Id
  end
GO