DROP PROCEDURE [dbo].[JMD_PAGE_DELETE]
GO
/*
Exec
  JMD_PAGE_DELETE
  'JMDCMS.Web',
  'contact'
select * from jmd_page
update jmd_page set is_deleted = 0
*/
CREATE PROCEDURE [dbo].[JMD_PAGE_DELETE]
  @Site_URL nvarchar(255),
  @Page_Name nvarchar(255)
AS
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

  Declare
    @Site_Id int,
    @Is_Internal int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)    

  Select
    @Is_Internal = Is_Internal
  From
    JMD_Page
  Where
    Site_Id = @Site_Id and
    Page_Name = @Page_Name

  if ( Coalesce(@Is_Internal,0) = 1 )
  begin
    RaisError('You are trying to delete an Internal Page. Internal pages can not be deleted.', 16,-1)
    return -1
  end
  else
  begin
    if exists 
      ( 
      Select * From JMD_Page
      Where
        Site_Id = @Site_Id and
        Page_Name = @Page_Name and
        Coalesce(Is_Deleted,0) = 0
      )
    begin
      Update
        JMD_Page
      Set
        Is_Deleted = 1
      Where
        Site_Id = @Site_Id and
        Page_Name = @Page_Name 
    end
    else
    begin
      Update
        JMD_Page
      Set
        Is_Deleted = 0
      Where
        Site_Id = @Site_Id and
        Page_Name = @Page_Name 
    end
    return 0
  end

GO