DROP PROCEDURE [dbo].[JMD_PAGE_INIT]
GO
CREATE PROCEDURE [dbo].[JMD_PAGE_INIT]
  @Site_URL nvarchar(255)
AS

/*
	Copyright (C) 2012  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.

	Name: JMD_PAGE_INIT
	Author: Ajay Handa
	Purpose: Initializes the default pages on new site creation.
	Work Item ID: 783 - Resolved guests and registered users conflict.
	WI:650:handaajay15 - Mar/17/2007 Site Administration
		Page FileManager Added 
	WI:650:handaajay15 - Mar/17/2007 - Module Manager Page Removed.

*/
  Declare
    @Page_Id int

  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'default','Home','Home Page', 'Home Page', 'Home Page', 
    Null, 1, 1, 1, 'Admin;Guests;Registered;', 'Admin', 'Admin','Admin','Admin','Admin',1,1

  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'services','Services','services Page', 'services Page', 'services Page', 
    Null, 1, 1, 1, 'Admin;Guests;Registered;', 'Admin', 'Admin','Admin','Admin','Admin',1,1

  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'portfolio','Portfolio','portfolio Page', 'portfolio Page', 'portfolio Page', 
    Null, 1, 1, 1, 'Admin;Guests;Registered;', 'Admin', 'Admin','Admin','Admin','Admin',1,1

  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'About','About','About Page', 'About Page', 'About Page', 
    Null, 1, 1, 1, 'Admin;Guests;Registered;', 'Admin', 'Admin','Admin','Admin','Admin',1,1

  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'Contact','Contact','Contact Page', 'Contact Page', 'Contact Page', 
    Null, 1, 1, 1, 'Admin;Guests;Registered;', 'Admin', 'Admin','Admin','Admin','Admin',1,1


  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'login','Login','Login', 'Login', 'Login', 
    Null, 1, 0, 0, 'Admin;Guests;Registered;', 'Admin', 'Admin','Admin','Admin','Admin',1,0

  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'NewUser','New User','NewUser', 'NewUser', 'NewUser', 
    Null, 1, 0, 0, 'Admin;Guests;Registered;', 'Admin', 'Admin','Admin','Admin','Admin',1,0

  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'AddPage','Add Page','AddPage', 'AddPage', 'AddPage', 
    Null, 1, 0, 0, 'Admin;Registered;', 'Admin', 'Admin','Admin','Admin','Admin',1,0
  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'AddModule','Add Module','Add Module', 'Add Module', 'Add Module', 
    Null, 1, 0, 0, 'Admin;Registered;', 'Admin', 'Admin','Admin','Admin','Admin',1,0

  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'JMDHTMLEdit','Edit Module Contents','Edit Module Contents', 'Edit Module Contents', 'Edit Module Contents', 
    Null, 1, 0, 0, 'Admin;Registered;', 'Admin', 'Admin','Admin','Admin','Admin',1,0

-- Exec
--    JMD_PAGE_SAVE
--    0,  @Site_URL, 'BrowseForms','Browse Forms','Browse Forms', 'Browse Forms', 'Browse Forms', 
--    Null, 1, 0, 0, 'Admin', 'Admin', 'Admin','Admin','Admin','Admin',1,1

--Exec
--    JMD_PAGE_SAVE
--    0,  @Site_URL, 'NewForm','New Form','New Form', 'New Form', 'New Form', 
--    Null, 1, 0, 0, 'Admin', 'Admin', 'Admin','Admin','Admin','Admin',1,0

--Exec
--    JMD_PAGE_SAVE
--    0,  @Site_URL, 'NewCol','New Field','New Field', 'New Field', 'New Field', 
--    Null, 1, 0, 0, 'Admin', 'Admin', 'Admin','Admin','Admin','Admin',1,0

--Exec
--    JMD_PAGE_SAVE
--    0,  @Site_URL, 'BrowseCols','Browse Columns','Browse Columns', 'Browse Columns', 'Browse Columns', 
--    Null, 1, 0, 0, 'Admin', 'Admin', 'Admin','Admin','Admin','Admin',1,1

--Exec
--    JMD_PAGE_SAVE
--    0,  @Site_URL, 'DF','Dynamic Forms','DF', 'DF', 'DF', 
--    Null, 1, 0, 0, 'Admin', 'Admin', 'Admin','Admin','Admin','Admin',1,1

--Exec
--    JMD_PAGE_SAVE
--    0,  @Site_URL, 'NewRecord','New Record','New Record', 'New Record', 'New Record', 
--    Null, 1, 0, 0, 'Admin', 'Admin', 'Admin','Admin','Admin','Admin',1,0

--Exec
--    JMD_PAGE_SAVE
--    0,  @Site_URL, 'LookupDialog','LookupDialog','LookupDialog', 'LookupDialog', 'LookupDialog', 
--    Null, 1, 0, 0, 'Admin', 'Admin', 'Admin','Admin','Admin','Admin',1,0

  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'DeletePage','Delete Page','Delete Page', 'Delete Page', 'Delete Page', 
    Null, 1, 0, 0, 'Admin;Registered;', 'Admin', 'Admin','Admin','Admin','Admin',1,0

  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'DeletePageModule','Delete Page Module','Delete Page Module', 'Delete Page Module', 'Delete Page Module', 
    Null, 1, 0, 0, 'Admin;Registered;', 'Admin', 'Admin','Admin','Admin','Admin',1,0

  -- Admin Page
  Exec
    @Page_Id = JMD_PAGE_SAVE
    0,  @Site_URL, 'Admin','Admin','Site Administration', 'Site Administration', 'Site Administration', 
    Null, 1, 0, 1, 'Admin', 'Admin', 'Admin','Admin','Admin','Admin',1,1

  -- Admin Page Child: Users
  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'Users','Users','Users Administration', 'Users Administration', 'Users Administration', 
    'Admin', 1, 0, 1, 'Admin', 'Admin', 'Admin','Admin','Admin','Admin',1,1

  -- Admin Page Child: Roles
  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'Roles','Roles','Roles Administration', 'Roles Administration', 'Roles Administration', 
    'Admin', 1, 0, 1, 'Admin', 'Admin', 'Admin','Admin','Admin','Admin',1,1

  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'AddRole','AddRole','Manage Roles', 'Manage Roles', 'Manage Roles', 
    'Admin', 1, 0, 0, 'Admin', 'Admin', 'Admin','Admin','Admin','Admin',1,0

  Exec
    JMD_PAGE_SAVE
 0,  @Site_URL, 'DeleteRole','DeleteRole','Manage Roles', 'Manage Roles', 'Manage Roles', 
    'Admin', 1, 0, 0, 'Admin', 'Admin', 'Admin','Admin','Admin','Admin',1,0

  -- Admin Page Child: Pages
  --Exec
  --  JMD_PAGE_SAVE
  --  0,  @Site_URL, 'Pages','Pages','Pages Administration', 'Pages Administration', 'Pages Administration', 
  --  'Admin', 1, 0, 1, 'Admin', 'Admin', 'Admin','Admin','Admin','Admin',1,0

  -- WI:650:handaajay15 - File Manager Page 
  --Exec
  --  JMD_PAGE_SAVE
  --  0,  @Site_URL, 'FileManager','FileManager','File Manager', 'File Manager', 'File Manager', 
  --  'Admin', 1, 0, 1, 'Admin', 'Admin', 'Admin','Admin','Admin','Admin',1,0


/* WI:650:Module Manager will done after release 3.0.0.0
  -- Admin Page Child: Modules
  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'Modules','Modules','Modules Administration', 'Modules Administration', 'Modules Administration', 
    'Admin', 1, 0, 1, 'Admin', 'Admin', 'Admin','Admin','Admin','Admin',1,0
*/
  -- Admin Page Child: UserRoles
  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'UserRoles','User Roles','User Roles', 'User Roles', 'User Roles', 
    Null, 1, 0, 0, 'Admin', 'Admin', 'Admin','Admin','Admin','Admin',1,0

  -- Admin User Delete
  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'DeleteUser','Delete User','Delete User', 'Delete User', 'Delete User', 
    Null, 1, 0, 0, 'Admin;Registered', 'Admin', 'Admin','Admin','Admin','Admin',1,0

  -- SQL Server Management Page
  --Exec
  --  JMD_PAGE_SAVE
  --  0,  @Site_URL, 'SMO','SQL Server Management','SQL Server Management', 'SQL Server Management', 'SQL Server Management', 
  --  Null, 1, 0, 0, 'Admin;Registered', 'Admin', 'Admin','Admin','Admin','Admin',1,0

  -- Site Installation 	Pages
  Exec
    JMD_PAGE_SAVE
    0,  @Site_URL, 'Install','Install','Install', 'Install', 'Install', 
    Null, 1, 0, 0, 'Admin;Guests;Registered;', 'Admin', 'Admin','Admin','Admin','Admin',1,0
GO


