DROP PROCEDURE [dbo].[JMD_PAGE_MOD_SAVE]
GO
CREATE PROCEDURE [dbo].[JMD_PAGE_MOD_SAVE]
  @Page_Mod_Id int,
  @Site_URL nvarchar(255),
  @PAGE_Name nvarchar(255),
  @MOD_ID int,
  @MOD_TITLE nvarchar(50),
  @DIV_ID int,
  @IS_PUBLISHED int,
  @SHOW_ON_ALL_PAGES int,
  @VIEW_ROLE nvarchar(1000),
  @EDIT_ROLE nvarchar(1000),
  @DELETE_ROLE nvarchar(1000),
  @MOVE_ROLE nvarchar(1000),
  @EDIT_CONTENTS_ROLE nvarchar(1000),
  @Mod_Sort Int = null,
  @Install_Mod Int = 0
AS
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.

	WI:650: Procedure now returns a return value i.e. Page Mod ID
	WI:650:RaisError if the page does not exist
*/
			
  Declare
    @Page_Id int,
    @Site_Id int,
    @Sort int,
	@ReturnValue int
	
  Select
    @ReturnValue = 0	

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  

  
  Select
    @Page_Id = Id
  From
    JMD_Page
  Where
    Site_Id = @Site_Id and
    Page_Name = @Page_Name

  -- WI:650:RaisError if the page does not exist
  if (Coalesce(@Page_Id,0) = 0)
  begin
    RaisError('Page "%s" does not exist.', 16,-1,@Page_Name)
    Return -1
  end

 -- if ( @Install_Mod = 1 )
 -- begin
	--if exists ( Select 1 From JMD_PAGE_MOD where Page_Id = @Page_Id and Mod_Id = @Mod_Id and Mod_Title = @Mod_Title )
 --   begin
	--	--RaisError('Installation Mode: Page "%s", Module  "%s" already registerd.', 16,-1,@Page_Name, @Mod_Title)
	--	Return -1
	--end
 -- end

  if ( @Page_Mod_Id = 0 )
  begin
    
    if ( Coalesce(@Mod_Sort,0) = 0)
    begin
      Select
        @Sort = Max(Sort) 
      From
        JMD_PAGE_MOD
      Where
        Page_Id = @Page_Id and
        Div_Id = @Div_Id

      Select
        @Sort = Coalesce(@Sort,0)+5
    end
    else
    begin
      Select
        @Sort = @Mod_Sort
    end
      
    Insert into JMD_PAGE_MOD
    (
      PAGE_ID,
      MOD_ID,
      MOD_TITLE,
      DIV_ID,
      IS_PUBLISHED,
      SHOW_ON_ALL_PAGES,
      VIEW_ROLE,
      EDIT_ROLE,
      DELETE_ROLE,
      MOVE_ROLE,
      EDIT_CONTENTS_ROLE,
      SORT
    )
    values
    (
      @PAGE_ID,
      @MOD_ID,
      @MOD_TITLE,
      @DIV_ID,
      @IS_PUBLISHED,
      @SHOW_ON_ALL_PAGES,
      @VIEW_ROLE,
      @EDIT_ROLE,
      @DELETE_ROLE,
      @MOVE_ROLE,
      @EDIT_CONTENTS_ROLE,
      @SORT
    )
	print @@Identity
	
	Select
		@ReturnValue = @@Identity
  end
  else
  begin
    Update
      JMD_PAGE_MOD
      SET
        PAGE_ID = @PAGE_ID,
        MOD_ID = @MOD_ID,
        MOD_TITLE = @MOD_TITLE,
        DIV_ID = @DIV_ID,
        IS_PUBLISHED = @IS_PUBLISHED,
        SHOW_ON_ALL_PAGES = @SHOW_ON_ALL_PAGES,
        VIEW_ROLE = @VIEW_ROLE,
        EDIT_ROLE = @EDIT_ROLE,
        DELETE_ROLE = @DELETE_ROLE, 
        MOVE_ROLE = @MOVE_ROLE,
        EDIT_CONTENTS_ROLE = @EDIT_CONTENTS_ROLE,
        Sort = @Mod_Sort
    Where
      Id = @Page_Mod_Id

	Select
		@ReturnValue = @Page_Mod_Id

  end
Return @ReturnValue
GO