
Drop procedure [dbo].[JMD_PAGE_SELECT]
go
CREATE PROCEDURE [dbo].[JMD_PAGE_SELECT]
  @Site_URL nvarchar(255),
  @Page_Name nvarchar(255),
  @Filter nvarchar(1000) = null  
AS
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.

	Name: JMD_PAGE_SELECT
	Author: Ajay Handa
	Purpose: Returns result set of pages for given criteria
	Work Item ID: 651 - Page Manager to manage published, unpublished and deleted pages.
	
*/

  Declare
    @Site_Id int,
	@Sql nvarchar(4000)

  Set
    @Sql = ''
	
  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)    
  
  If (@Filter is not null)
  begin  	
  Set
	@Sql =
	'Select
		*, 
		Published = Case IS_PUBLISHED When 1 Then ''Y'' Else ''N'' End, 
		Deleted = Case IS_DELETED When 1 Then ''Y'' Else ''N'' End, 
		Parent_Page_Name = ( Select Page_Name From JMD_PAGE b where b.Id = a.Parent_Page_Id )
	From
		JMD_PAGE a
	Where
		a.Site_Id = '+Convert(varchar(50),@Site_Id)+' and Is_Internal = 0 '+ @Filter

	Exec(@Sql)
  end	
  else
  begin
	Select
		*, Parent_Page_Name = ( Select Page_Name From JMD_PAGE b where b.Id = a.Parent_Page_Id )
	From
		JMD_PAGE a
	Where
		a.Site_Id = @Site_Id and
		a.Page_Name = @Page_Name
  end		
GO
