DROP PROCEDURE [dbo].[JMD_ROLE_SAVE]
GO
CREATE PROCEDURE [dbo].[JMD_ROLE_SAVE]
  @Role_Id int,
  @Site_URL nvarchar(255),
  @Role_Name nvarchar(50),
  @Is_Internal int = 0,
  @Parent_Role int = NULL
AS
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

  Declare
    @Site_Id int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  

  if not exists ( Select * from JMD_ROLE where id = @Role_Id)
  begin
    Insert into JMD_ROLE
    (
      Site_Id, Role_Name, Is_Internal, Parent_Role
    )
    values
    (
      @Site_Id, @Role_Name, @Is_Internal, @Parent_Role
    )
  end
  else
  begin
    Update
      JMD_ROLE
    Set
      Site_Id = @Site_Id,
      Role_Name = @Role_Name,
      Is_Internal = @Is_Internal,
      Parent_Role = @Parent_Role
    Where
      Id = @Role_Id
  end
GO