DROP PROCEDURE dbo.JMD_SITE_ALIAS
GO
CREATE PROCEDURE dbo.JMD_SITE_ALIAS
	@JMD_SITE_URL nvarchar(255),
	@JMD_SITE_ALIAS_URL nvarchar(255)
As
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.

	Name: JMD_SITE_ALIAS
	Author: Ajay Handa
	Purpose: To create alias for an existing site
	Work Item ID: 591

*/
Declare
	@Site_Id Int

Select
	@Site_Id = dbo.JMD_GET_SITE_ID(@JMD_SITE_ALIAS_URL)


If Coalesce(@Site_Id,0) <> 0
Begin
	RaisError('Site [%s] already exists.',16,1,@JMD_SITE_ALIAS_URL)	
	Return -1
End

Set
	@Site_Id = null

Select
	@Site_Id = dbo.JMD_GET_SITE_ID(@JMD_SITE_URL)

If Coalesce(@Site_Id,0) <> 0
Begin
  Execute JMD_SITE_INSERT 
		@JMD_SITE_ALIAS_URL, 
		@Site_Id, 
		'', 
		'', 
		''
End
Else
Begin
	RaisError('Site [%s] does not exists.',16,1,@JMD_SITE_URL)
	Return -1
End	
	Return 0
GO

