drop procedure dbo.JMD_SITE_CREATE_CONTENT
GO
Create procedure dbo.JMD_SITE_CREATE_CONTENT
	@Target_Site_Id int,
	@Source_Page_Name nvarchar(255),
	@Target_Page_Name nvarchar(255)
As
/*
	Copyright (C) 2012  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

Declare 
	@Source_Site_Id int,
	@Target_Page_Id Int,
	@Source_Page_Id Int,
	@Target_Mod_Id int,
	@Source_Mod_Id int,
	@NewPageModId int

Set @Source_Site_Id = 10

  	
Select @Source_Page_Id = id from jmd_page where site_id = @Source_Site_Id and page_name = @Source_Page_Name
Select @Target_Page_Id = id from jmd_page where site_id = @Target_Site_Id and page_name = @Target_Page_Name
Select @Source_Mod_Id = id from jmd_mod where site_id = @Source_Site_Id and mod_name = 'JMDHTML.ascx'
Select @Target_Mod_Id = id from jmd_mod where site_id = @Target_Site_Id and mod_name = 'JMDHTML.ascx'

Select @NewPageModId = MAX(ID) from jmd_page_mod
Select * into #jmd_page_mod from jmd_page_mod where page_id = @Source_Page_Id
ALTER TABLE #jmd_page_mod ADD content nvarchar(max)

update
   #jmd_page_mod
Set
  content =  HTML_TEXT, Page_id = @Target_Page_Id, Mod_id = @Target_Mod_Id
From     
   #jmd_page_mod a
Inner join jmd_mod_html b On a.id = b.page_mod_id

ALTER TABLE #jmd_page_mod DROP column ID
ALTER TABLE #jmd_page_mod ADD ID int

Update 
	#jmd_page_mod
Set  @NewPageModId = ID = Coalesce(ID,0) +	@NewPageModId +1

SET IDENTITY_INSERT dbo.jmd_page_mod ON
Insert into JMD_PAGE_MOD 
(
	ID,
	PAGE_ID,
	MOD_ID,
	MOD_TITLE,
	DIV_ID,
	SORT,
	IS_PUBLISHED,
	SHOW_ON_ALL_PAGES,
	VIEW_ROLE,
	EDIT_ROLE,
	DELETE_ROLE,
	MOVE_ROLE,
	EDIT_CONTENTS_ROLE,
	IS_DELETED
)
Select 
	ID,
	PAGE_ID,
	MOD_ID,
	MOD_TITLE,
	DIV_ID,
	SORT,
	IS_PUBLISHED,
	SHOW_ON_ALL_PAGES,
	VIEW_ROLE,
	EDIT_ROLE,
	DELETE_ROLE,
	MOVE_ROLE,
	EDIT_CONTENTS_ROLE,
	IS_DELETED
From	
	#jmd_page_mod

SET IDENTITY_INSERT dbo.jmd_page_mod OFF

insert into jmd_mod_html ( Page_Mod_Id, html_text, Title ) Select ID, content, '' from #jmd_page_mod
drop table  #jmd_page_mod  

GO
