DROP PROCEDURE [dbo].[JMD_USER_AUTH]
GO
CREATE PROCEDURE [dbo].[JMD_USER_AUTH]
  @Site_URL nvarchar(255),
  @User_Name nvarchar(50)
As
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
	
	WI:764: New user registeration, Activation mechanism.
*/

  -- AUTHENTICATION OF USER
  Declare
    @Site_Id int,
    @User_Id int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  
  
  Select
    @User_Id = Id
  From
    JMD_User
  Where
    Site_Id = @Site_Id and
    [User_Name] = @User_Name and
    IsNull(Activation_Key,'') = ''
  
  Select
    Password_Hash, Salt
  From
    JMD_USER
  Where
    Site_Id = @Site_Id and 
    [User_Name] = @User_Name  and
    IsNull(Activation_Key,'') = ''

  Select
    Roles
  From
    JMD_USER_ROLE
  Where
    [User_Id] = @User_Id

GO  
