DROP PROCEDURE [dbo].[JMD_USER_DELETE]
GO
CREATE PROCEDURE [dbo].[JMD_USER_DELETE]
  @Site_URL nvarchar(255),
  @User_Id int
AS
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

  Declare
    @Site_Id int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  

  if not exists ( Select * From JMD_USER
      where     
        Site_Id = @Site_Id and
        Id = @User_Id and
        Coalesce(Is_Internal,0) = 1 )
  begin
    Delete
      JMD_USER
    Where
      Site_Id = @Site_Id and
      Id = @User_Id
  end
  else
  begin
    RaisError('Internal User can not be deleted. Your User Id and IP will be banned for this action.',16, -1)
  end
GO
