DROP PROCEDURE [dbo].[JMD_USER_INSERT]
GO
/*****************************************************************************
  NAME: JMD_USER_INSERT
  PURPOSE: User Insert
*****************************************************************************/
CREATE PROCEDURE [dbo].[JMD_USER_INSERT]
  @User_Id int,
  @Site_URL nvarchar(255),
  @User_Name nvarchar(50),
  @User_Display_Name nvarchar(50),
  @Password_Hash nvarchar(50),
  @Salt nvarchar(50),
  @Email nvarchar(50)
As

/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

  Declare
    @Site_Id int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  

  if not exists ( Select * from JMD_USER where Id = @User_Id)
  begin
    Insert into JMD_USER
    (
      Site_Id,
      [User_Name],
      User_Display_Name,
      Password_Hash,
      Salt,
      Email
    )
    values
    (
      @Site_Id,
      @User_Name,
      @User_Display_Name,
      @Password_Hash,
      @Salt,
      @Email
    )
  end
  else
  begin
    if ( @Password_Hash != '0' )
    begin
      Update
        JMD_USER
      Set
        [User_Name] = @User_Name,
        User_Display_Name = @User_Display_Name,
        Password_Hash = @Password_Hash,
        Salt = @Salt,
        Email = @Email
      Where
        ID = @User_Id
    end
    else
    begin
      Update
        JMD_USER
      Set
        [User_Name] = @User_Name,
        User_Display_Name = @User_Display_Name,
        Email = @Email
      Where
        ID = @User_Id
    end
  end

GO