DROP PROCEDURE [dbo].[JMD_USER_PASSWORD_RESET]
GO
/*****************************************************************************
  NAME: JMD_USER_PASSWORD_RESET
  PURPOSE: Password reset...
*****************************************************************************/
CREATE PROCEDURE [dbo].[JMD_USER_PASSWORD_RESET]
  @User_Name nvarchar(50),
  @Site_URL nvarchar(255),
  @Password_Hash nvarchar(50),
  @Salt nvarchar(50)
As

/*
	Copyright (C) 2012  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

  Declare
    @Site_Id int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  

  if exists ( Select * from JMD_USER where SITE_ID = @Site_Id and [USER_NAME] = @User_Name)
  begin
    if ( @Password_Hash != '0' )
    begin
      Update
        JMD_USER
      Set
        Password_Hash = @Password_Hash,
        Salt = @Salt
      where 
		SITE_ID = @Site_Id and 
		[USER_NAME] = @User_Name
    end
  end

GO