DROP PROCEDURE [dbo].[JMD_USER_ROLE_INIT]
GO
/*
  Select * from jmd_user
  Select * from jmd_Role
  JMD_USER_ROLE_SAVE
    @User_Id int,
    @Roles nvarchar(1000)
*/
CREATE PROCEDURE [dbo].[JMD_USER_ROLE_INIT]
  @Site_URL nvarchar(255),  
  @User_Name nvarchar(50) = null
AS
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
  Declare
    @Admin_User_Id int,
    @Site_Id int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  

	if ( IsNull(@User_Name,'') <> '')
	begin	
		  Select
			@Admin_User_Id = Id
		  From
			JMD_USER
		  Where
			Site_Id = @Site_Id and
			[User_Name] = @User_Name 
	end
	else
	begin
		  Select
			@Admin_User_Id = Id
		  From
			JMD_USER
		  Where
			Site_Id = @Site_Id and
			[User_Name] = 'Admin' 
	end	
  
  Exec
    JMD_USER_ROLE_SAVE
      @Admin_User_Id, 'Admin'
GO