DROP PROCEDURE [dbo].[JMD_USER_SELECT]
GO
CREATE PROCEDURE [dbo].[JMD_USER_SELECT]
  @Site_URL nvarchar(255),
  @User_Id int = null
As
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
  Declare
    @Site_Id int

  Select
    @Site_Id = dbo.JMD_GET_SITE_ID(@Site_URL)  
  
  if ( Coalesce(@User_Id,0) = 0)
  begin
    Select
      a.*, 
      User_Role_Id = b.Id, b.Roles
    From
      JMD_User a
    Left Outer Join 
      JMD_USER_ROLE b On b.User_Id = a.Id
    Where
      Site_Id = @Site_Id
  end
  else
  begin
    Select
      a.*, 
      User_Role_Id = b.Id, b.Roles
    From
      JMD_User a
    Left Outer Join 
      JMD_USER_ROLE b On b.User_Id = a.Id
    Where
      Site_Id = @Site_Id and
      a.Id = @User_Id 
  end

GO