DROP VIEW [dbo].[JMD_PAGE_MOD_SELECT]
GO
CREATE VIEW [dbo].[JMD_PAGE_MOD_SELECT]
As
/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.

	Author: Ajay Handa
	NAME: JMD_PAGE_MOD_SELECT
	PURPOSE: Consolidated Select of Page Modules
	
	WI: 650 - Delete / Undelete Page Modules. Filter 
		IS_DELETED Flag can now have 3 values:
		0 = Not Deleted
		1 = Deleted			
		5 = Permanently Deleted :) Leaving the possibility of doing undo using SQL
	WI:979: Enable/Disable view state by module 	
*/
  Select
    a.*, 
    Page_Mod_Id = b.Id, b.Mod_Id, b.Mod_Title, b.Div_Id, Mod_Sort = b.Sort, 
    Mod_View_Role = b.View_Role,
    Mod_Edit_Role = b.Edit_Role, Mod_Delete_Role = b.Delete_Role, 
    Mod_Move_Role = b.Move_Role, Mod_Edit_Contents_Role = b.Edit_Contents_Role,
    Is_Mod_Published = b.Is_Published, b.Show_On_All_Pages,
	Is_Mod_Deleted = b.Is_Deleted, 
    c.Mod_Name, c.Mod_Path, c.Mod_Edit_Form, c.Mod_Friendly_Name, c.Is_Admin,
    c.CAN_SHOW_MOD_HEADER, MOD_IS_VIEWSTATE_ENABLED = c.IS_VIEWSTATE_ENABLED,
    d.Div_Name, d.Div_Sort, d.Parent_Div_Id
  From
    JMD_PAGE a
    Left Outer Join JMD_PAGE_MOD b on a.Id = b.Page_Id
    Left Outer Join JMD_MOD c on c.Id = b.Mod_Id
    Left Outer Join JMD_DIV d on d.Id = b.Div_Id  
  Where
    Coalesce(b.Is_Deleted,0) < 5
GO
