/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Data;

namespace JMD.Data.Common
{
    public enum TSql
    {
        Search,
        TablePaging,
        UI_Select_Sp,
        UI_Command_Select_Sp,
        UI_Save,
        GetNextNumber
    };


    public static class DbSql
    {
        #region Array of SQL Strings
  
        static string[] ASql = new string[] 
		{
            "Execute Search '{0}', '{1}', '{2}', '{3}' ",
            "WITH Table_Paging As (Select Row_Number() OVER ( Order By {0} ) as RowNumber, * From {1} )"+
            " Select {2} From Table_Paging Where RowNumber between {3} and {4} {5} ",
            "Execute UI_Select_Sp '{0}', '{1}', {2}",
			"Execute UI_Command_Select_Sp '{0}'",
            "Execute UI_Save {0}, '{1}',{2},'{3}'",
            "Execute GetNextNumber '{0}'"
        };
        #endregion Array of SQL Strings

        public static Database dbProvider
        = EnterpriseLibraryContainer.Current.GetInstance<Database>();

        public static DataSet TablePaging(string PagingID, string PagingTable, string PagingFields,
            string RowStart, string RowEnd, string WhereConditionExt)
        {
            return dbProvider.ExecuteDataSet(CommandType.Text,string.Format(ASql[(int)TSql.TablePaging], PagingID, PagingTable, PagingFields, RowStart, RowEnd, WhereConditionExt));
        }
        public static DataSet Open(TSql Sql, string[] param)
        {
            return dbProvider.ExecuteDataSet(CommandType.Text, string.Format(ASql[(int)Sql], param));
        }
        public static DataSet Open(string Sql)
        {
            return dbProvider.ExecuteDataSet(CommandType.Text, Sql);
        }
        public static DataTable OpenTable(TSql Sql, string[] param)
        {
            DataSet ds = dbProvider.ExecuteDataSet(CommandType.Text, string.Format(ASql[(int)Sql], param));
            return ds.Tables[0];
        }

        public static DataTable GetDataTable(string spName, params object[] parameters)
        {
            DataSet ds = dbProvider.ExecuteDataSet(spName, parameters);
            return ds.Tables[0];
        }

        public static void ExecuteSP(string spName, params object[] parameters)
        {
            dbProvider.ExecuteNonQuery(spName, parameters);
        }

        
        public static DataTable OpenTable(string Sql)
        {
            DataSet ds = dbProvider.ExecuteDataSet(CommandType.Text, Sql);

            return ds.Tables[0];
        }
        public static void Execute(string Sql)
        {
            dbProvider.ExecuteNonQuery(CommandType.Text,Sql);
        }

        public static string ToDbNull(string str)
        {
            if ((str == null) || (string.Compare(str, string.Empty) == 0))
            {
                return "NULL";
            }
            {
                return str;
            }
        }

    }
}
