/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text;
using System.Security.Cryptography;
using System.IO;
using System.Net.Mail;
using System.Net;
using CodeKicker.BBCode;

/// <summary>
/// Summary description for Util
/// </summary>
public class Util
{
    public Util()
    {
        //
        // TODO: Add constructor logic here
        //
    }
    public static string SiteURL(string URI)
    {

        string[] parts = URI.Split(new char[] { '/' });
        string Site_URL = string.Empty;
        if (parts.Length == 7 || parts.Length == 5)
        {
            //Virtual Directory
            //Literal1.Text += "Virtual Directory..." + "<BR />";
            Site_URL = parts[3].ToString();

        }
        else if (parts.Length == 4 || parts.Length == 6)
        {
            // Domain or SubDomain
            //Literal1.Text += "Domain or Sub Domain" + "<BR />";
            Site_URL = parts[2].ToString();
        }
        return Site_URL;
    }
    public static string PageName(string URI)
    {
        string[] Site = URI.Split(new char[] { '?' });
        //string[] parts = URI.Split(new char[] { '/' });
        string[] parts = Site[0].Split(new char[] { '/' });
        string FullPageName = parts[parts.Length - 1].ToString();
        string[] PageName = FullPageName.Split(new char[] { '.' });

        return PageName[0];
    }
    public static string PageParams(string URI)
    {
        string[] Site = URI.Split(new char[] { '?' });

        //string[] parts = URI.Split(new char[] { '/' });
        if (Site.Length > 1)
        {
            return Site[1].ToString();

            /*            
                        //string[] parts = Site[1].Split(new char[] { '/' });
                        //string FullPageName = parts[parts.Length - 1].ToString();
                        //string[] PageParam = FullPageName.Split(new char[] { '?' });
                        if (PageParam.Length > 1)
                        {
                            return Site[1].ToString();
                        }
                        else
                        {
                            return String.Empty;
                        }
  
             */
        }
        else
        {
            return String.Empty;
        }
    }
    public static string CreateSalt(int size)
    {
        // Generate a cryptographic random number using the cryptographic
        // service provider
        RNGCryptoServiceProvider rng = new RNGCryptoServiceProvider();
        byte[] buff = new byte[size];
        rng.GetBytes(buff);
        // Return a Base64 string representation of the random number
        return Convert.ToBase64String(buff);
    }
    public static string CreatePasswordHash(string pwd, string salt)
    {
        string saltAndPwd = String.Concat(pwd, salt);
        string hashedPwd =
               FormsAuthentication.HashPasswordForStoringInConfigFile(
                                                    saltAndPwd, "SHA1");
        return hashedPwd;
    }
    public static string SqlConnectionString()
    {
        return string.Empty;

        //HttpContext incoming = HttpContext.Current;
        //string site = Util.SiteURL(incoming.Request.QueryString["Pg"].ToString());

        //if (ConfigurationManager.ConnectionStrings[site] != null)
        //{
        //    return ConfigurationManager.ConnectionStrings[site].ConnectionString;
        //}
        //else
        //{
        //    return ConfigurationManager.ConnectionStrings["JMDCMS"].ConnectionString;
        //}

    }


    public static string SingleLineOptionsToDb(bool SLRequired,
        string SLMaxLength)
    {
        string Options = string.Empty;
        string Required = "Required={0}";
        string MaxLength = "|MaxLength={0}";

        if (SLRequired == true)
        {
            Options = String.Format(Required, "true");
        }
        else
        {
            Options = String.Format(Required, "false");
        }
        Options += string.Format(MaxLength, SLMaxLength);
        return Options;
    }
    public static string MultiLineOptionsToDb(bool MLRequired,
        string MLTotalLines)
    {
        string Options = string.Empty;
        string Required = "Required={0}";
        string TotalLines = "|TotalLines={0}";

        if (MLRequired == true)
        {
            Options = String.Format(Required, "true");
        }
        else
        {
            Options = String.Format(Required, "false");
        }
        Options += string.Format(TotalLines, MLTotalLines);
        return Options;
    }
    public static string CheckBoxOptionsToDb(string DefaultValue)
    {
        string Options = string.Empty;
        string Default = "Default={0}";

        if (DefaultValue == "True")
        {
            Options = String.Format(Default, "True");
        }
        else
        {
            Options = String.Format(Default, "False");
        }
        return Options;
    }
    public static string LookupOptionsToDb(bool LookupRequired, string FormId,
        string FieldId)
    {
        string Options = string.Empty;
        string Required = "Required={0}";
        string Obj_Id = "|Obj_Id={0}";
        string Col_Id = "|Col_Id={0}";
        if (LookupRequired == true)
        {
            Options = String.Format(Required, "true");
        }
        else
        {
            Options = String.Format(Required, "false");
        }

        Options += String.Format(Obj_Id, FormId);
        Options += String.Format(Col_Id, FieldId);
        return Options;
    }
    public static string ListOptionsToDb(bool ListRequired,
        string ListItems, string ListDefaultValue)
    {
        string Options = string.Empty;
        string Required = "Required={0}";
        string Items = "|Items={0}";
        string Default = "|Default={0}";
        if (ListRequired == true)
        {
            Options = String.Format(Required, "true");
        }
        else
        {
            Options = String.Format(Required, "false");
        }

        Options += string.Format(Items, ListItems);
        Options += string.Format(Default, ListDefaultValue);
        return Options;

    }
    public static bool IsRequired(string Options)
    {
        string[] OptionParts = Options.Split(new char[] { '|' });
        bool Required = false;

        if (OptionParts.Length > 0)
        {
            foreach (string str in OptionParts)
            {
                string[] strParts = str.Split(new char[] { '=' });
                if (strParts.Length > 1)
                {
                    if (strParts[0] == "Required")
                    {
                        if (strParts[1] == "true")
                        {
                            Required = true;
                        }
                        else
                        {
                            Required = false;
                        }
                    }
                }
            }
        }
        return Required;
    }
    public static string TextMaxLength(string Options)
    {
        string[] OptionParts = Options.Split(new char[] { '|' });
        string MaxLength = "0";

        if (OptionParts.Length > 0)
        {
            foreach (string str in OptionParts)
            {
                string[] strParts = str.Split(new char[] { '=' });
                if (strParts.Length > 1)
                {
                    if (strParts[0] == "MaxLength")
                    {
                        MaxLength = strParts[1];
                    }
                }
            }
        }
        return MaxLength;
    }
    public static string TextTotalLines(string Options)
    {
        string[] OptionParts = Options.Split(new char[] { '|' });
        string TotalLines = "0";

        if (OptionParts.Length > 0)
        {
            foreach (string str in OptionParts)
            {
                string[] strParts = str.Split(new char[] { '=' });
                if (strParts.Length > 1)
                {
                    if (strParts[0] == "TotalLines")
                    {
                        TotalLines = strParts[1];
                    }
                }
            }
        }
        return TotalLines;
    }
    public static string CheckBoxDefault(string Options)
    {
        string[] OptionParts = Options.Split(new char[] { '|' });
        string Default = "False";

        if (OptionParts.Length > 0)
        {
            foreach (string str in OptionParts)
            {
                string[] strParts = str.Split(new char[] { '=' });
                if (strParts.Length > 1)
                {
                    if (strParts[0] == "Default")
                    {
                        Default = strParts[1];
                    }
                }
            }
        }
        return Default;

    }
    public static string ListItems(string Options)
    {
        string[] OptionParts = Options.Split(new char[] { '|' });
        string Items = string.Empty;

        if (OptionParts.Length > 0)
        {
            foreach (string str in OptionParts)
            {
                string[] strParts = str.Split(new char[] { '=' });
                if (strParts.Length > 1)
                {
                    if (strParts[0] == "Items")
                    {
                        Items = strParts[1];
                    }
                }
            }
        }
        return Items;
    }
    public static string ListDefault(string Options)
    {
        string[] OptionParts = Options.Split(new char[] { '|' });
        string Default = string.Empty;

        if (OptionParts.Length > 0)
        {
            foreach (string str in OptionParts)
            {
                string[] strParts = str.Split(new char[] { '=' });
                if (strParts.Length > 1)
                {
                    if (strParts[0] == "Default")
                    {
                        Default = strParts[1];
                    }
                }
            }
        }
        return Default;
    }
    public static string LookupSource(string Options)
    {
        string[] OptionParts = Options.Split(new char[] { '|' });
        string Source = string.Empty;

        if (OptionParts.Length > 0)
        {
            foreach (string str in OptionParts)
            {
                string[] strParts = str.Split(new char[] { '=' });
                if (strParts.Length > 1)
                {
                    if (strParts[0] == "Obj_Id")
                    {
                        Source = strParts[1];
                    }
                }
            }
        }
        return Source;
    }
    public static string LookupField(string Options)
    {
        string[] OptionParts = Options.Split(new char[] { '|' });
        string Field = string.Empty;

        if (OptionParts.Length > 0)
        {
            foreach (string str in OptionParts)
            {
                string[] strParts = str.Split(new char[] { '=' });
                if (strParts.Length > 1)
                {
                    if (strParts[0] == "Col_Id")
                    {
                        Field = strParts[1];
                    }
                }
            }
        }
        return Field;
    }

    public static TextBox TextBoxCtl(string Name, string DefaultValue,
        string CSSClass)
    {
        TextBox tx = new TextBox();
        tx.ID = string.Format("{0}", Name);
        tx.Text = DefaultValue;
        tx.Attributes.Add("name", Name);
        tx.Attributes.Add("runat", "Server");
        tx.Attributes.Add("class", CSSClass);
        return tx;
    }
    public static Button ButtonCtl(string Name, string Caption, string CSSClass)
    {
        Button btn = new Button();
        btn.ID = string.Format("{0}", Name);
        btn.Text = Caption;
        btn.Attributes.Add("name", Name);
        btn.Attributes.Add("runat", "Server");
        btn.Attributes.Add("class", CSSClass);
        return btn;
    }
    public static HtmlTableCell HtmlTableCellCtl(string tag, string CSSClass)
    {
        HtmlTableCell htc = new HtmlTableCell(tag);
        htc.Attributes.Add("runat", "Server");
        htc.Attributes.Add("class", "TableFormTdLeft");
        return htc;
    }
    public static Literal LiteralCtl(string Caption)
    {
        Literal lt = new Literal();
        lt.Text = Caption;
        return lt;
    }

    // TODO: WI-1150 Returns a string of ; delimited file names in the 
    // given directory and given extensions.
    /// <summary>
    /// WI-1150 Returns a string of ; delimited file names in the 
    /// given directory and given extensions.
    /// </summary>
    /// <param name="dir">Directory to scan</param>
    /// <param name="Ext">; delimited file extensions</param>
    /// <returns></returns>
    public static string GetFileNames(string dir, string[] GetExt,
        string SearchText)
    {
        StringBuilder sb = new StringBuilder();
        DirectoryInfo mainDir = new DirectoryInfo(dir);
        FileSystemInfo[] items;
        if (SearchText.Trim() == string.Empty)
        {
            items = mainDir.GetFileSystemInfos();
        }
        else
        {
            items = mainDir.GetFileSystemInfos(string.Format("*{0}*", SearchText));
        }

        foreach (FileSystemInfo item in items)
        {
            if (item is FileInfo)
            {
                FileInfo fileInfo = item as FileInfo;
                for (int i = 0; i < GetExt.Length; i++)
                {
                    if (fileInfo.Extension.ToUpper().CompareTo(GetExt[i].ToUpper()) == 0)
                    {
                        sb.Append(fileInfo.Name + ";");
                    }
                }
            }
        }
        return sb.ToString();
    }

    public static string GetGUID()
    {
        return System.Guid.NewGuid().ToString();
    }


    /// <summary>
    /// Generates a random password.
    /// </summary>
    /// <param name="minLength">
    /// Minimum password length.
    /// </param>
    /// <param name="maxLength">
    /// Maximum password length.
    /// </param>
    /// <returns>
    /// Randomly generated password.
    /// </returns>
    /// <remarks>
    /// The length of the generated password will be determined at
    /// random and it will fall with the range determined by the
    /// function parameters.
    /// </remarks>
    public static string RandomPassword(int   minLength,
                                  int   maxLength)
    {
        // Define supported password characters divided into groups.
        // You can add (or remove) characters to (from) these groups.
        string PASSWORD_CHARS_LCASE  = "abcdefgijkmnopqrstwxyz";
        string PASSWORD_CHARS_UCASE  = "ABCDEFGHJKLMNPQRSTWXYZ";
        string PASSWORD_CHARS_NUMERIC= "23456789";
        string PASSWORD_CHARS_SPECIAL= "*$-+?_&=!%{}/";

        // Make sure that input parameters are valid.
        if (minLength <= 0 || maxLength <= 0 || minLength > maxLength)
            return null;

        // Create a local array containing supported password characters
        // grouped by types. You can remove character groups from this
        // array, but doing so will weaken the password strength.
        char[][] charGroups = new char[][] 
        {
            PASSWORD_CHARS_LCASE.ToCharArray(),
            PASSWORD_CHARS_UCASE.ToCharArray(),
            PASSWORD_CHARS_NUMERIC.ToCharArray(),
            PASSWORD_CHARS_SPECIAL.ToCharArray()
        };

        // Use this array to track the number of unused characters in each
        // character group.
        int[] charsLeftInGroup = new int[charGroups.Length];

        // Initially, all characters in each group are not used.
        for (int i=0; i<charsLeftInGroup.Length; i++)
            charsLeftInGroup[i] = charGroups[i].Length;
        
        // Use this array to track (iterate through) unused character groups.
        int[] leftGroupsOrder = new int[charGroups.Length];

        // Initially, all character groups are not used.
        for (int i=0; i<leftGroupsOrder.Length; i++)
            leftGroupsOrder[i] = i;

        // Because we cannot use the default randomizer, which is based on the
        // current time (it will produce the same "random" number within a
        // second), we will use a random number generator to seed the
        // randomizer.
        
        // Use a 4-byte array to fill it with random bytes and convert it then
        // to an integer value.
        byte[] randomBytes = new byte[4];

        // Generate 4 random bytes.
        RNGCryptoServiceProvider rng = new RNGCryptoServiceProvider();
        rng.GetBytes(randomBytes);

        // Convert 4 bytes into a 32-bit integer value.
        int seed = (randomBytes[0] & 0x7f) << 24 |
                    randomBytes[1]         << 16 |
                    randomBytes[2]         <<  8 |
                    randomBytes[3];

        // Now, this is real randomization.
        Random  random  = new Random(seed);

        // This array will hold password characters.
        char[] password = null;

        // Allocate appropriate memory for the password.
        if (minLength < maxLength)
            password = new char[random.Next(minLength, maxLength+1)];
        else
            password = new char[minLength];

        // Index of the next character to be added to password.
        int nextCharIdx;
        
        // Index of the next character group to be processed.
        int nextGroupIdx;

        // Index which will be used to track not processed character groups.
        int nextLeftGroupsOrderIdx;
        
        // Index of the last non-processed character in a group.
        int lastCharIdx;

        // Index of the last non-processed group.
        int lastLeftGroupsOrderIdx = leftGroupsOrder.Length - 1;
        
        // Generate password characters one at a time.
        for (int i=0; i<password.Length; i++)
        {
            // If only one character group remained unprocessed, process it;
            // otherwise, pick a random character group from the unprocessed
            // group list. To allow a special character to appear in the
            // first position, increment the second parameter of the Next
            // function call by one, i.e. lastLeftGroupsOrderIdx + 1.
            if (lastLeftGroupsOrderIdx == 0)
                nextLeftGroupsOrderIdx = 0;
            else
                nextLeftGroupsOrderIdx = random.Next(0, 
                                                     lastLeftGroupsOrderIdx);

            // Get the actual index of the character group, from which we will
            // pick the next character.
            nextGroupIdx = leftGroupsOrder[nextLeftGroupsOrderIdx];

            // Get the index of the last unprocessed characters in this group.
            lastCharIdx = charsLeftInGroup[nextGroupIdx] - 1;
            
            // If only one unprocessed character is left, pick it; otherwise,
            // get a random character from the unused character list.
            if (lastCharIdx == 0)
                nextCharIdx = 0;
            else
                nextCharIdx = random.Next(0, lastCharIdx+1);

            // Add this character to the password.
            password[i] = charGroups[nextGroupIdx][nextCharIdx];
            
            // If we processed the last character in this group, start over.
            if (lastCharIdx == 0)
                charsLeftInGroup[nextGroupIdx] = 
                                          charGroups[nextGroupIdx].Length;
            // There are more unprocessed characters left.
            else
            {
                // Swap processed character with the last unprocessed character
                // so that we don't pick it until we process all characters in
                // this group.
                if (lastCharIdx != nextCharIdx)
                {
                    char temp = charGroups[nextGroupIdx][lastCharIdx];
                    charGroups[nextGroupIdx][lastCharIdx] = 
                                charGroups[nextGroupIdx][nextCharIdx];
                    charGroups[nextGroupIdx][nextCharIdx] = temp;
                }
                // Decrement the number of unprocessed characters in
                // this group.
                charsLeftInGroup[nextGroupIdx]--;
            }

            // If we processed the last group, start all over.
            if (lastLeftGroupsOrderIdx == 0)
                lastLeftGroupsOrderIdx = leftGroupsOrder.Length - 1;
            // There are more unprocessed groups left.
            else
            {
                // Swap processed group with the last unprocessed group
                // so that we don't pick it until we process all groups.
                if (lastLeftGroupsOrderIdx != nextLeftGroupsOrderIdx)
                {
                    int temp = leftGroupsOrder[lastLeftGroupsOrderIdx];
                    leftGroupsOrder[lastLeftGroupsOrderIdx] = 
                                leftGroupsOrder[nextLeftGroupsOrderIdx];
                    leftGroupsOrder[nextLeftGroupsOrderIdx] = temp;
                }
                // Decrement the number of unprocessed groups.
                lastLeftGroupsOrderIdx--;
            }
        }

        // Convert password characters into a string and return the result.
        return new string(password);
     }

    public static void SendEmail(string toEmailAddress, string newPassword)
    {
        SmtpClient client = new SmtpClient("smtp.gmail.com", 587);
        client.EnableSsl = true;
        MailAddress from = new MailAddress("webmaster@ajayhanda.com", "Webmaste");
        MailAddress to = new MailAddress(toEmailAddress, toEmailAddress);
        MailMessage message = new MailMessage(from, to);
        message.Body = "You new password is " + newPassword;
        message.Subject = "You have requested to reset your password. Here is your new password";
        NetworkCredential myCreds = new NetworkCredential("webmaster@gmail.com", "", "");
        client.Credentials = myCreds;
        client.Send(message);
    }

    public static void NewSendEmail(string toEmailAddress, string newPassword)
    {
        var fromAddress = new MailAddress("webmaster@ajayhanda.com", "Ajay Handa");
        var toAddress = new MailAddress(toEmailAddress, toEmailAddress);
        const string fromPassword = "";
        const string subject = "You have requested to reset your password. Here is your new password";
        string body = "You new password is " + newPassword;

        var smtp = new SmtpClient
        {
            Host = "smtp.gmail.com",
            Port = 587,
            EnableSsl = true,
            DeliveryMethod = SmtpDeliveryMethod.Network,
            UseDefaultCredentials = false,
            Credentials = new NetworkCredential(fromAddress.Address, fromPassword)
        };
        using (var message = new MailMessage(fromAddress, toAddress)
        {
            Subject = subject,
            Body = body
        })
        {
            smtp.Send(message);
        } 

    }

    public static BBCodeParser GetBBCodeParser()
    {
        var parser = new BBCodeParser(new[]
                {

                    new BBTag("h1", "<h1 class=\"${class}\">${content}", "</h1>", false, true, new BBAttribute("class", ""), new BBAttribute("class", "class")), 
                    new BBTag("h2", "<h2 class=\"${class}\">${content}", "</h2>", false, true, new BBAttribute("class", ""), new BBAttribute("class", "class")), 
                    new BBTag("h3", "<h3>", "</h3>"),                     
                    new BBTag("h4", "<h4>", "</h4>"),                     
                    new BBTag("h5", "<h5>", "</h5>"),                     
                    new BBTag("h6", "<h6>", "</h6>"),                     
                    new BBTag("b", "<b>", "</b>"), 
                    new BBTag("p", "<p>", "</p>"), 
                    new BBTag("pre", "<pre>", "</pre>"), 
                    new BBTag("address", "<address>", "</address>"), 
                    new BBTag("br", "<br />", " ",true,false), 
                    new BBTag("br /", "<br />", " "), 
                    new BBTag("hr", "<hr />", " ",true,false), 
                    new BBTag("table", "<table class=\"${class}\">${content}", "</table>", false, true, new BBAttribute("class", ""), new BBAttribute("class", "class")), 
                    new BBTag("thead", "<thead class=\"${class}\">${content}", "</thead>", false, true, new BBAttribute("class", ""), new BBAttribute("class", "class")), 
                    new BBTag("tbody", "<tbody class=\"${class}\">${content}", "</tbody>", false, true, new BBAttribute("class", ""), new BBAttribute("class", "class")), 
                    new BBTag("tr", "<tr class=\"${class}\">${content}", "</tr>", false, true, new BBAttribute("class", ""), new BBAttribute("class", "class")), 
                    new BBTag("td", "<td class=\"${class}\">${content}", "</td>", false, true, new BBAttribute("class", ""), new BBAttribute("class", "class")), 
                    new BBTag("i", "<span style=\"font-style:italic;\">", "</span>"), 
                    new BBTag("u", "<span style=\"text-decoration:underline;\">", "</span>"), 
                    new BBTag("code", "<pre class=\"prettyprint\">", "</pre>"), 
                    new BBTag("img", "<img src=\"${content}\" class=\"${class}\"  width=\"${width}\"  height=\"${height}\" />", "", false, true, new BBAttribute("class", ""), new BBAttribute("class", "class"),new BBAttribute("width", "width"),new BBAttribute("height", "height")), 
                    new BBTag("quote", "<blockquote class=\"${class}\" >", "</blockquote>",new BBAttribute("class", ""), new BBAttribute("class", "class")), 
                    new BBTag("list", "<ul class=\"${class}\" >", "</ul>", new BBAttribute("class", ""), new BBAttribute("class", "class")), 
                    new BBTag("ol", "<ol class=\"${class}\" >", "</ol>", new BBAttribute("class", ""), new BBAttribute("class", "class")), 
                    new BBTag("*", "<li>", "</li>", true, false), 
                    new BBTag("slideshow", "<ul class=\"${class}\"  width=\"${width}\"  height=\"${height}\" >", "</ul>", true, false,new BBAttribute("class", "class"),new BBAttribute("width", "width"),new BBAttribute("height", "height")), 
                    new BBTag("slide", "<li><img src=\"${src}\"  width=\"${width}\"  height=\"${height}\" >", "</img></li>", true, false,new BBAttribute("src", "src"),new BBAttribute("width", "width"),new BBAttribute("height", "height")), 
                    new BBTag("url", "<a href=\"${href}\" rel=\"${rel}\" >", "</a>", new BBAttribute("href", ""), new BBAttribute("href", "href"),new BBAttribute("rel", "rel")), 
                    new BBTag("div", "<div class=\"${class}\">", "</div>", new BBAttribute("class", ""), new BBAttribute("class", "class")), 
                    new BBTag("Tab", "<ul class=\"tabs left\">", "</ul>"),
                    new BBTag("TabItem", "<li><a href=\"#${href}\">", "</a></li>", new BBAttribute("href", ""), new BBAttribute("href", "href")), 
                    new BBTag("TabContent", "<div id=\"${id}\" class=\"tab-content\" >", "</div>", new BBAttribute("id", ""), new BBAttribute("id", "id")), 
                    new BBTag("youtube", "<iframe src=\"${content}\" class=\"youytube-player\" frameborder=\"0\" allowfullscreen  width=\"${w}\" height=\"${h}\" >",
                        "</iframe>", false, true, 
                        new BBAttribute("class", ""), new BBAttribute("class", "class"),
                        new BBAttribute("w", "w"), new BBAttribute("h", "h")), 
                    new BBTag("iframe", "<iframe src=\"${content}\" frameborder=\"0\" width=\"${w}\" height=\"${h}\" >",
                        "</iframe>", false, true, 
                        new BBAttribute("class", ""), new BBAttribute("class", "class"),
                        new BBAttribute("w", "w"), new BBAttribute("h", "h")), 
                    new BBTag("adsense", 
                        @"<script type='text/javascript'><!--
                            google_ad_client = '${content}';
                            google_ad_slot = '${adslot}';
                            google_ad_width = '${w}';
                            google_ad_height = '${h}';
                            //-->
                            </script>
                            <script type='text/javascript'
                            src='http://pagead2.googlesyndication.com/pagead/show_ads.js'>",
                                                               "</script>",false,true,
                                                               new BBAttribute("adslot","adslot"),
                                                               new BBAttribute("w","w"),
                                                               new BBAttribute("h","h")),
                    new BBTag("analytics", 
                        @"<script type='text/javascript'>
                          var _gaq = _gaq || [];
                          _gaq.push(['_setAccount', '${content}']);
                          _gaq.push(['_trackPageview']);

                          (function() {
                            var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
                            ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
                            var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
                          })();","</script>",false,true,new BBAttribute("dummy","dummy")),

                    new BBTag("facebook", "<div class=\"fb-like\" data-href=\"${content}\" data-send=\"false\"  data-layout=\"button_count\"  data-show-faces=\"false\"   >", "</div>", false, true, new BBAttribute("class", ""), new BBAttribute("class", "class")),
                    new BBTag("twitter", "<a href=\"https://twitter.com/share\" class=\"twitter-share-button\" data-hashtags=\"${content}\" >", "</a>", false, true, new BBAttribute("class", ""), new BBAttribute("class", "class")),

                    new BBTag("uservoice", 
                        @"<script type='text/javascript'>
                          var uvOptions = {};
                          (function() {
                            var uv = document.createElement('script'); uv.type = 'text/javascript'; uv.async = true;
                            uv.src = ('https:' == document.location.protocol ? 'https://' : 'http://') + 'widget.uservoice.com/${content}.js';
                            var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(uv, s);
                          })();"
                        ,"</script>",false,true,new BBAttribute("dummy","dummy")),

                    new BBTag("zopim", 
                        @"<script type='text/javascript'>
                            window.$zopim||(function(d,s){var z=$zopim=function(c){z._.push(c)},$=z.s=
                            d.createElement(s),e=d.getElementsByTagName(s)[0];z.set=function(o){z.set.
                            _.push(o)};z._=[];z.set._=[];$.async=!0;$.setAttribute('charset','utf-8');
                            $.src='//cdn.zopim.com/?${content}';z.t=+new Date;$.
                            type='text/javascript';e.parentNode.insertBefore($,e)})(document,'script');"
                        ,"</script>",false,true,new BBAttribute("dummy","dummy")),

                });
        return parser;
    }

    private static string GetGoogleAnalytics(IAttributeRenderingContext context)
    {
        

        return "hello";
//        return string.Format(
//            @"<script type='text/javascript'>
//          var _gaq = _gaq || [];
//          _gaq.push(['_setAccount', '{0}']);
//          _gaq.push(['_trackPageview']);
//
//          (function() {
//            var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
//            ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
//            var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
//          })();
//        </script>",setAccount);
    }
}
