/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Security.Principal;
using JMDCMS.Web.Lib;

public partial class _Default : System.Web.UI.Page 
{
	protected void Page_Load(object sender, EventArgs e)
	{
		//Test();

		if (ProcessExternalLink() == false)
		{
		JMDSecurity jmdSecurity = new JMDSecurity();
		jmdSecurity.CheckPageAuth(Util.SqlConnectionString(),
			Util.SiteURL(Request.QueryString["Pg"].ToString()),
			Util.PageName(Request.QueryString["Pg"].ToString()));

		string Msg = string.Format("Page View access is denied. Site: {0} Page:{1}",
			Util.SiteURL(Request.QueryString["Pg"].ToString()),
			Util.PageName(Request.QueryString["Pg"].ToString()));

		if (!jmdSecurity.PageView)
		{
			throw new HttpException(403, Msg, 3);
		}
		else
		{
			FillMeta();
		}
		}
/*
		Util util = new Util();
		string PageName = util.PageName(Request.QueryString["Pg"].ToString());
		if (string.Compare(PageName, "Login.aspx") != 0)
		{
			//Response.Redirect("Login.aspx",true);
			throw new HttpException(403, "Access Denied Edit", 3);
			
		}
		//Request.Url	{http://localhost:1703/JMDCMS.Web/MyTest/Wizard.aspx?aspxerrorpath=/JMDCMS.Web/default.aspx}	System.Uri
*/        
	}

	private bool ProcessExternalLink()
	{
		bool External = false;

		if (Util.PageName(Request.QueryString["Pg"].ToString().ToUpper()) == "CLICK")
		{
			string PageParams = Util.PageParams(Request.QueryString["Pg"].ToString());
			string[] ParamParts = PageParams.Split(new char[] { ',' });
			string ExternalURL = ParamParts[0].Split(new char[] { '=' })[1].ToString();


			Response.Redirect(ExternalURL, true);
			External = true;
		}

		return External;
			
	}
	private void FillMeta()
	{
		DataTable dt;
		dt = SqlServer.JMD_PAGE_SELECT(Util.SiteURL(Request.QueryString["Pg"].ToString()), 
			Util.PageName(Request.QueryString["Pg"].ToString()));
		if (dt.Rows.Count > 0)
		{
			Literal_Title.Text = dt.Rows[0]["META_TITLE"].ToString();
			Literal_Meta.Text = string.Format("<Meta Name=\"Description\" Content=\"{0}\"/>", dt.Rows[0]["META_DESC"].ToString());
			Literal_Meta.Text += string.Format("<Meta Name=\"Keywords\" Content=\"{0}\"/>", dt.Rows[0]["META_KEYWORDS"].ToString());
			if (dt.Rows[0]["IS_VIEWSTATE_ENABLED"].ToString() == "1")
			{
				SetViewState(true);
			}
			else
			{
				SetViewState(false);
			}

		}
		dt.Dispose();
		dt = SqlServer.JMD_SITE_SELECT(Util.SiteURL(Request.QueryString["Pg"].ToString()));
		if (dt.Rows.Count > 0)
		{
			Literal_Style.Text = string.Format("<link href=\"{0}\" rel=\"stylesheet\" type=\"text/css\" />",
				dt.Rows[0]["STYLE_SHEET"].ToString());

            Literal_InLineCSS.Text = string.Format("<style type=\"text/css\">{0}</style>", dt.Rows[0]["SITE_CSS"].ToString());
		}
		dt.Dispose();
	}
	private void SetViewState(bool enableViewState)
	{
		this.Page.EnableViewState = enableViewState;
	}
	private void Test()
	{

		Literal Literal1 = new Literal();
		int i = 0;
		Literal1.Text = "Request.Url.AbsolutePath: " + Request.Url.AbsolutePath.ToString() + "<BR />";
		Literal1.Text += "Request.Url.AbsoluteUri: " + Request.Url.AbsoluteUri.ToString() + "<BR />";
		Literal1.Text += "Request.QueryString[\"Pg\"]: " + Request.QueryString["Pg"].ToString() + "<BR />";
		string[] parts = Request.QueryString["Pg"].ToString().Split(new char[] { '/' });
		Literal1.Text += "Request.QueryString[\"Pg\"]: " + Request.QueryString["Pg"].ToString() + "<BR />";

		Literal1.Text += string.Format("Parts Length...{0}<BR />", parts.Length.ToString());

		if (parts.Length == 7 || parts.Length == 5)
		{
			Literal1.Text += "Virtual Directory..." + "<BR />";

		}
		else
		{
			Literal1.Text += "Domain or Sub Domain" + "<BR />";
		}
		foreach (string str in parts)
		{
			Literal1.Text += i.ToString() + ": " + str + "<BR />";
			i += 1;
		}
		Literal1.Text += System.Web.HttpRuntime.AppDomainAppPath.ToString() + "<BR />";

		Literal1.Text += ConfigurationManager.ConnectionStrings["JMDCMS"].ConnectionString + "<BR />";
		Literal1.Text += SqlServer.Test() + "<BR />";

		//Util util = new Util();
		Literal1.Text += Util.SiteURL(Request.QueryString["Pg"].ToString());
		Page.Controls.Add(Literal1);

	}
	public bool CheckAuthorization()
	{
		DataTable dt;
		//Util util = new Util();
		string Site_Url = Util.SiteURL(Request.QueryString["Pg"].ToString());
		string Page_Name = Util.PageName(Request.QueryString["Pg"].ToString());

		IPrincipal p = HttpContext.Current.User;
		dt = SqlServer.JMD_PAGE_AUTH(Site_Url, Page_Name);
		bool Authorized = false;
		if (dt.Rows.Count > 0)
		{
			//string[] roles = authTicket.UserData.Split(new char[] { ';' });
			string[] PageRoles = dt.Rows[0]["VIEW_ROLES"].ToString().Split(new char[] { ';' });
			foreach (string Role in PageRoles)
			{
				if ( p.IsInRole(Role) || (String.Compare(Role,"Guests",true) == 0))
				{
					Authorized = true;
					break;
				}
				else if ((p.Identity.IsAuthenticated) && (String.Compare(Role,"Registered",true) == 0))
				{
					Authorized = true;
					break;
				}
			}
		}
		return Authorized;
	}
}
