/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using JMDCMS.Web.Lib;

public partial class Modules_Admin_AddModule : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            InitControls();
        }
    }
    private void InitControls()
    {
        InitModulesList();
        //Util util = new Util();
        Page_Mod_Id.Value = "0";
        Mod_Sort.Text = "0";
        string PageParams = Util.PageParams(Request.QueryString["Pg"].ToString());
        string[] ParamParts = PageParams.Split(new char[] { ',' });

        if (string.Compare(PageParams, String.Empty) != 0)
        {
            Page_Name.Text = ParamParts[0].Split(new char[] { '=' })[1].ToString();
        }


        DataTable dt;
        string Site_Url = Util.SiteURL(Request.QueryString["Pg"].ToString());
        dt = SqlServer.JMD_DIV_SELECT(Site_Url);
        Div_Id.Items.Clear();
        foreach (DataRow dr in dt.Rows)
        {
            ListItem li = new ListItem(dr["DIV_NAME"].ToString(),
                dr["ID"].ToString());
            Div_Id.Items.Add(li);
        }


        Edit_Role.Items.Clear();
        View_Role.Items.Clear();
        Move_Role.Items.Clear();
        Delete_Role.Items.Clear();
        Edit_Contents_Role.Items.Clear();

        dt = SqlServer.JMD_ROLE_SELECT(Site_Url);

        CBLAddItems(Edit_Role, dt,1);
        CBLAddItems(View_Role, dt,2);
        CBLAddItems(Move_Role, dt,3);
        CBLAddItems(Delete_Role, dt,4);
        CBLAddItems(Edit_Contents_Role, dt,5);

        /*
       foreach (DataRow dr in dt.Rows)
       {
       
           ListItem li = new ListItem(dr["ROLE_NAME"].ToString(),
               dr["ID"].ToString());
           if (string.Compare(dr["ROLE_NAME"].ToString(), "Admin", true) == 0)
           {
               li.Selected = true;
               li.Enabled = false;
           }
           Edit_Role.Items.Add(li);
           View_Role.Items.Add(li);
           Move_Role.Items.Add(li);
           Delete_Role.Items.Add(li);
           Edit_Contents_Role.Items.Add(li);
         
       }
       */ 
        // Initialization for module edit...
        if (ParamParts.Length > 1)
        {
            DataTable dtPageMod = SqlServer.JMD_PAGE_MOD_SELECT_Sp(ParamParts[1].Split(new char[] { '=' })[1].ToString());
            if (dtPageMod.Rows.Count > 0)
            {
                Page_Mod_Id.Value = dtPageMod.Rows[0]["PAGE_MOD_ID"].ToString();
                Mod_Id.SelectedValue = dtPageMod.Rows[0]["MOD_ID"].ToString();
                Mod_Title.Text = dtPageMod.Rows[0]["MOD_TITLE"].ToString();
                Mod_Sort.Text = dtPageMod.Rows[0]["MOD_SORT"].ToString();
                Div_Id.SelectedValue = dtPageMod.Rows[0]["DIV_ID"].ToString();
                Is_Published.Checked = false;
                if (dtPageMod.Rows[0]["IS_MOD_PUBLISHED"].ToString() == "1")
                {
                    Is_Published.Checked = true;
                }
                Show_On_All_Pages.Checked = false;
                if (dtPageMod.Rows[0]["Show_On_All_Pages"].ToString() == "1")
                {
                    Show_On_All_Pages.Checked = true;
                }

                StringToCBL(Edit_Role, dtPageMod.Rows[0]["MOD_EDIT_ROLE"].ToString());
                StringToCBL(View_Role, dtPageMod.Rows[0]["MOD_VIEW_ROLE"].ToString());
                StringToCBL(Move_Role, dtPageMod.Rows[0]["MOD_MOVE_ROLE"].ToString());
                StringToCBL(Delete_Role, dtPageMod.Rows[0]["MOD_DELETE_ROLE"].ToString());
                StringToCBL(Edit_Contents_Role, dtPageMod.Rows[0]["MOD_EDIT_CONTENTS_ROLE"].ToString());


            }
            dtPageMod.Dispose();
        }

        dt.Dispose();
        
    }
    private void InitModulesList()
    {
        Mod_Id.Items.Clear();
        //Util util = new Util();
        DataTable dt1;
        string Site_Url = Util.SiteURL(Request.QueryString["Pg"].ToString());
        int ShowAdmin;
        if (Show_Admin.Checked)
        {
            ShowAdmin = 1;
        }
        else
        {
            ShowAdmin = 0;
        }
        dt1 = SqlServer.JMD_MOD_SELECT(Site_Url, ShowAdmin.ToString());
        foreach (DataRow dr in dt1.Rows)
        {
            ListItem li = new ListItem(dr["MOD_FRIENDLY_NAME"].ToString(), 
                dr["ID"].ToString());
            Mod_Id.Items.Add(li);
        }

        dt1.Dispose();
    }
    private bool Save()
    {
        Mod_Sort_Validator.Validate();
        if (!Mod_Sort_Validator.IsValid)
        {
            ErrMsg.Text = "Display order must be a numeric value.";
            return false;
        }
        else
        {

            if (Mod_Sort.Text.Trim() == string.Empty)
            {
                Mod_Sort.Text = "0";
            }
            //Util util = new Util();
            string Site_URL = Util.SiteURL(Request.QueryString["Pg"].ToString());
            SqlServer.JMD_PAGE_MOD_SAVE(Page_Mod_Id.Value, Site_URL, Page_Name.Text, Mod_Id.SelectedItem.Value,
                Mod_Title.Text, Div_Id.SelectedItem.Value, BoolToString(Is_Published.Checked),
                BoolToString(Show_On_All_Pages.Checked), CBLToString(View_Role),
                CBLToString(Edit_Role), CBLToString(Delete_Role), CBLToString(Move_Role),
                CBLToString(Edit_Contents_Role), Mod_Sort.Text);
            //util = null;
        }
        return true;

    }

    private string BoolToString(bool Checked)
    {
        if ( Checked )
        {
            return "1";
        }
        else
        {
            return "0";
        }
    }
    private string CBLToString(CheckBoxList cbl)
    {
        string ListToString = string.Empty;
        foreach (ListItem li in cbl.Items)
        {
            if (li.Selected)
            {
                ListToString += li.Text+";";
            }
        }
        return ListToString;
    }
    private void StringToCBL(CheckBoxList cbl, string Roles)
    {
        string[] RolesArr = Roles.Split(new char[] { ';' });
        foreach (ListItem li in cbl.Items)
        {
            if (li.Enabled)
            {
                li.Selected = false;
                foreach (string str in RolesArr)
                {
                    if (li.Text == str)
                    {
                        li.Selected = true;
                        break;
                    }
                }
            }
        }
    }

    public void CBLAddItems(CheckBoxList cbl, DataTable dt, int RoleType)
    {
        foreach (DataRow dr in dt.Rows)
        {
            ListItem li = new ListItem(dr["ROLE_NAME"].ToString(),
                dr["ID"].ToString());
            if (string.Compare(dr["ROLE_NAME"].ToString(), "Admin", true) == 0)
            {
                li.Selected = true;
                li.Enabled = false;
            }
            else if (((string.Compare(dr["ROLE_NAME"].ToString(), "Guests", true) == 0) ||
                (string.Compare(dr["ROLE_NAME"].ToString(), "Registered", true) == 0)) &&
                (RoleType == 2)) // Guests and registered users are set to true by default             
            {
                li.Selected = true;
                li.Enabled = true;
            }
            else
            {
                li.Selected = false;
            }
            cbl.Items.Add(li);
        }

    }
    protected void Show_Admin_CheckedChanged(object sender, EventArgs e)
    {
        InitModulesList();
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        if (Save())
        {
            Response.Redirect(string.Format("{0}.aspx", Page_Name.Text));
        }
    }
    protected void Button2_Click(object sender, EventArgs e)
    {
      Response.Redirect(string.Format("{0}.aspx",Page_Name.Text));
    }
}
