/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
 * WI:979: Enable/Disable view state by Page option
 * 
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using JMDCMS.Web.Lib;

public partial class Modules_Admin_AddPage : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            InitPage(Request.QueryString["Pg"].ToString());
        }

    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        SavePage(Request.QueryString["Pg"].ToString());
    }
    protected void Button2_Click(object sender, EventArgs e)
    {
        if (Parent_Page_Name.Text.Trim() != string.Empty)
        {
            Response.Redirect(string.Format("{0}.aspx", Parent_Page_Name.Text));
        }
        else
        {
            Response.Redirect(string.Format("{0}.aspx", "Default"));
        }
    }
    public void InitPage(string URI)
    {
        //util.SiteURL(URI);
        //Util util = new Util();
        string PageParams = Util.PageParams(URI);
        string Page_Edit = string.Empty;
        Page_Id.Value = "0";
        string IsRoot = string.Empty;
        if (string.Compare(PageParams, String.Empty) != 0)
        {
            DataTable dt;
            string[] ParamParts = PageParams.Split(new char[] { ',' });
            Parent_Page_Name.Text = ParamParts[0].Split(new char[] { '=' })[1].ToString();
            if (ParamParts.Length > 1)
            {
                Page_Edit = ParamParts[1].Split(new char[] { '=' })[1].ToString();
            }

            if (ParamParts.Length > 2)
            {
                IsRoot = ParamParts[2].Split(new char[] { '=' })[1].ToString();
            }

            if (IsRoot == "True")
            {
                Is_Root.Checked = true;
            }

            JMDSecurity jmdSecurity = new JMDSecurity();
            jmdSecurity.CheckPageAuth(Util.SqlConnectionString(),
                Util.SiteURL(Request.QueryString["Pg"].ToString()),
                Util.PageName(Parent_Page_Name.Text));

            if (Page_Edit == "True")
            {
                if (!jmdSecurity.PageEdit)
                {
                    throw new HttpException(415, "Page Edit Not Allowed!", 3);
                }
                Page_Sort.Enabled = true;
                Page_Sort.BackColor = System.Drawing.Color.White;
                ContentTemplateList.Enabled = false;

            }
            else
            {
                if (!jmdSecurity.PageAdd)
                {
                    throw new HttpException(414, "Page Add Not Allowed", 3);
                }
                Page_Sort.Enabled = false;
                Page_Sort.Text = "0";
                Page_Sort.BackColor = System.Drawing.Color.DarkGray;
                ContentTemplateList.Enabled = true;
            }

            string Site_Url = Util.SiteURL(Request.QueryString["Pg"].ToString());

            dt = SqlServer.JMD_ROLE_SELECT(Site_Url);
            View_Roles.Items.Clear();
            Edit_Roles.Items.Clear();
            Add_Roles.Items.Clear();
            Move_Roles.Items.Clear();
            Delete_Roles.Items.Clear();
            Add_Module_Roles.Items.Clear();

            CBLAddItems(Add_Roles, dt, 1);
            CBLAddItems(View_Roles, dt, 2);
            CBLAddItems(Edit_Roles, dt, 3);
            CBLAddItems(Move_Roles, dt, 4);
            CBLAddItems(Delete_Roles, dt, 5);
            CBLAddItems(Add_Module_Roles, dt, 6);

            //Caption.Text = "New Page";

            if (Page_Edit == "True")
            {
                dt = SqlServer.JMD_PAGE_SELECT(Util.SiteURL(Request.QueryString["Pg"].ToString()),
                    ParamParts[0].Split(new char[] { '=' })[1].ToString());
                if (dt.Rows.Count > 0)
                {
                    foreach (DataRow dr in dt.Rows)
                    {
                        Page_Id.Value = dr["ID"].ToString();
                        Page_Name.Text = ParamParts[0].Split(new char[] { '=' })[1].ToString();
                        Parent_Page_Name.Text = dr["PARENT_PAGE_NAME"].ToString();
                        Page_Caption.Text = dr["PAGE_CAPTION"].ToString();
                        Page_Sort.Text = dr["PAGE_SORT"].ToString();
                        Meta_Title.Text = dr["META_TITLE"].ToString();
                        Meta_Desc.Text = dr["META_DESC"].ToString();
                        Meta_Keywords.Text = dr["META_KEYWORDS"].ToString();

                        if (dr["IS_PUBLISHED"].ToString() == "1")
                        {
                            Is_Published.Checked = true;
                        }
                        else
                        {
                            Is_Published.Checked = false;
                        }

                        if (dr["LOAD_SHARED_MODULES"].ToString() == "1")
                        {
                            Load_Shared_Modules.Checked = true;
                        }
                        else
                        {
                            Load_Shared_Modules.Checked = false;
                        }

                        if (dr["IS_ROOT"].ToString() == "1")
                        {
                            Is_Root.Checked = true;
                        }
                        else
                        {
                            Is_Root.Checked = false;
                        }

                        if (dr["IS_MENU_ITEM"].ToString() == "1")
                        {
                            Is_Menu_Item.Checked = true;
                        }
                        else
                        {
                            Is_Menu_Item.Checked = false;
                        }

                        if (dr["IS_VIEWSTATE_ENABLED"].ToString() == "1")
                        {
                            Is_ViewState_Enabled.Checked = true;
                        }
                        else
                        {
                            Is_ViewState_Enabled.Checked = false;
                        }

                        StringToCBL(View_Roles, dr["VIEW_ROLES"].ToString());
                        StringToCBL(Add_Roles, dr["ADD_ROLES"].ToString());
                        StringToCBL(Edit_Roles, dr["EDIT_ROLES"].ToString());
                        StringToCBL(Delete_Roles, dr["DELETE_ROLES"].ToString());
                        StringToCBL(Move_Roles, dr["MOVE_ROLES"].ToString());
                        StringToCBL(Add_Module_Roles, dr["ADD_MODULE_ROLES"].ToString());
                        break;
                    }
                }
                //Caption.Text = string.Format("Edit Page: {0}",Page_Caption.Text);
            }
            dt.Dispose();
            InitContentTemplateList();
        }
        else
        {
            Is_Root.Checked = true;
        }
    }

    private void InitContentTemplateList()
    {
        ContentTemplateList.Items.Clear();
        //Util util = new Util();
        DataTable dt1;
        string Site_Url = Util.SiteURL(Request.QueryString["Pg"].ToString());

        dt1 = SqlServer.JMD_CONTENT_TEMPLATE_SELECT(Site_Url);
        foreach (DataRow dr in dt1.Rows)
        {
            ListItem li = new ListItem(dr["TEMPLATE_NAME"].ToString(),
                dr["TEMPLATE_NAME"].ToString());
            ContentTemplateList.Items.Add(li);
        }
        dt1.Dispose();
    }


    public void CBLAddItems(CheckBoxList cbl, DataTable dt, int RoleType)
    {
        foreach (DataRow dr in dt.Rows)
        {
            ListItem li = new ListItem(dr["ROLE_NAME"].ToString(),
                dr["ID"].ToString());
            if (string.Compare(dr["ROLE_NAME"].ToString(), "Admin", true) == 0)
            {
                li.Selected = true;
                li.Enabled = false;
            }
            else if (((string.Compare(dr["ROLE_NAME"].ToString(), "Guests", true) == 0) ||
                (string.Compare(dr["ROLE_NAME"].ToString(), "Registered", true) == 0)) &&
                (RoleType == 2)) // Guests and registered users are set to true by default             
            {
                li.Selected = true;
                li.Enabled = true;
            }
            else
            {
                li.Selected = false;
            }
            cbl.Items.Add(li);
        }
        
    }
    public void SavePage(string URI)
    {
        if (Validate())
        {
            //Util util = new Util();
            string is_Published = "0";
            string is_Root = "0";
            string is_Menu_Item = "0";
            string load_Shared_Modules = "1";
            string is_ViewState_Enabled = "0";

            if (Is_Published.Checked)
            {
                is_Published = "1";
            }
            if (Is_Root.Checked)
            {
                is_Root = "1";
            }
            if (Is_Menu_Item.Checked)
            {
                is_Menu_Item = "1";
            }
            if (Is_Menu_Item.Checked)
            {
                is_Menu_Item = "1";
            }
            if (!Load_Shared_Modules.Checked)
            {
                load_Shared_Modules = "0";
            }
            if (Is_ViewState_Enabled.Checked)
            {
                is_ViewState_Enabled = "1";
            }


            Page_Name.Text = Page_Name.Text.Replace("<", "-");
            Page_Name.Text = Page_Name.Text.Replace(" ", "-");
            Page_Name.Text = Page_Name.Text.Replace(">", "-");
            Page_Name.Text = Page_Name.Text.Replace("/", "-");
            Page_Name.Text = Page_Name.Text.Replace("\\", "-");
            Page_Name.Text = Page_Name.Text.Replace("<", "-");
            Page_Name.Text = Page_Name.Text.Replace(",", "-");
            Page_Name.Text = Page_Name.Text.Replace("&", "-");
            Page_Name.Text = Page_Name.Text.Replace("|", "-");
            Page_Name.Text = Page_Name.Text.Replace(";", "-");
            Page_Name.Text = Page_Name.Text.Replace(":", "-");
            Page_Name.Text = Page_Name.Text.Replace("~", "-");

            try
            {
                DataTable dt = SqlServer.JMD_PAGE_SAVE(Page_Id.Value, Util.SiteURL(URI), Page_Name.Text, Page_Caption.Text,
                   Meta_Title.Text, Meta_Desc.Text, Meta_Keywords.Text, Parent_Page_Name.Text,
                   is_Published, is_Root, is_Menu_Item,
                   CBLToString(View_Roles), CBLToString(Add_Roles), CBLToString(Edit_Roles),
                   CBLToString(Delete_Roles), CBLToString(Move_Roles), CBLToString(Add_Module_Roles),
                   "0", load_Shared_Modules, Page_Sort.Text, is_ViewState_Enabled);

                if (Convert.ToInt32(Page_Id.Value) <= 0)
                {
                    SqlServer.JMD_PAGE_MOD_CONTENT_TEMPLATE_INSERT(Util.SiteURL(URI), Page_Name.Text, ContentTemplateList.SelectedValue);
                }

                Response.Redirect(string.Format("{0}.aspx", Page_Name.Text));
            }
            catch ( System.Data.SqlClient.SqlException Ex )
            {
                ErrorMessage.Text = "<ul class=\"TableFormErrorMessage\">";
                if (Ex.Number == 2601) 
                {
                    ErrorMessage.Text += string.Format("<li>Page with the given name already exists. Page name must be unique.</li>");
                }
                else
                {
                    ErrorMessage.Text += string.Format("<li>{0}</li>", Ex.Message);
                }
                ErrorMessage.Text += "</ul>";

            }
            finally
            {
            }
            
            //util = null;
            
        }
    }
    private string CBLToString(CheckBoxList cbl)
    {
        string ListToString = string.Empty;
        foreach (ListItem li in cbl.Items)
        {
            if (li.Selected)
            {
                ListToString += li.Text + ";";
            }
        }
        return ListToString;
    }
    private void StringToCBL(CheckBoxList cbl, string Roles)
    {
        string[] RolesArr = Roles.Split(new char[] { ';' });
        foreach (ListItem li in cbl.Items)
        {
            if (li.Enabled)
            {
                li.Selected = false;
                foreach (string str in RolesArr)
                {
                    if (li.Text == str)
                    {
                        li.Selected = true;
                        break;
                    }
                }
            }
        }
    }
    private bool Validate()
    {
        bool IsValid = true;
        string ErrMsg = string.Empty;
        if (Page_Name.Text.Trim() == String.Empty)
        {
            ErrMsg = "<li>Page Name is required.</li>";
            IsValid = false;
        }
        if (Page_Caption.Text.Trim() == String.Empty)
        {
            ErrMsg += "<li>Page Caption is required.</li>";
            IsValid = false;
        }
        Page_Sort_Validator.Validate();
        if (!Page_Sort_Validator.IsValid)
        {
            ErrMsg += "<li>Page Order must be a numeric value.</li>";
            IsValid = false;
        }

        if (Meta_Title.Text.Trim() == String.Empty)
        {
            Meta_Title.Text = Page_Caption.Text;
            //ErrMsg += "<li>Meta Title is required.</li>";
            //IsValid = false;
        }

        if (Meta_Desc.Text.Trim() == String.Empty)
        {
            Meta_Desc.Text = Page_Caption.Text;
            //ErrMsg += "<li>Meta Description is required.</li>";
            //IsValid = false;
        }
        if (Meta_Keywords.Text.Trim() == String.Empty)
        {
            Meta_Keywords.Text = Page_Caption.Text;
            //ErrMsg += "<li>Meta Keywords is required.</li>";
            //IsValid = false;
        }
        if (!IsValid)
        {
            ErrorMessage.Text = "<ul class=\"TableFormErrorMessage\">";
            ErrorMessage.Text += ErrMsg;
            ErrorMessage.Text += "</ul>";

        }
        return IsValid;
    }
}
