/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using JMDCMS.Web.Lib;

public partial class Modules_Admin_DeletePage : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            InitPage(Request.QueryString["Pg"].ToString());
        }
    }

    private void InitPage(string URI)
    {
        string PageParams = Util.PageParams(URI);
        if (string.Compare(PageParams, String.Empty) != 0)
        {
            string[] ParamParts = PageParams.Split(new char[] { ',' });
            Page_Name.Text = ParamParts[0].Split(new char[] { '=' })[1].ToString();
            //Caption.Text = string.Format("Delete Page: {0}", Page_Name.Text);
        }

        JMDSecurity jmdSecurity = new JMDSecurity();
        jmdSecurity.CheckPageAuth(Util.SqlConnectionString(),
            Util.SiteURL(Request.QueryString["Pg"].ToString()),
            Util.PageName(Page_Name.Text));

        if (!jmdSecurity.PageDelete)
        {
            throw new HttpException(416, "You do not have sufficient rights to delete this page!", 3);
        }
        jmdSecurity = null;
    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        try
        {
            SqlServer.JMD_PAGE_DELETE(Util.SiteURL(Request.QueryString["Pg"].ToString()),
                Page_Name.Text);
            Response.Redirect(string.Format("{0}.aspx", "Default"));

        }
        catch (System.Data.SqlClient.SqlException Ex)
        {
            ErrorMessage.Text = "<ul class=\"TableFormErrorMessage\">";
            ErrorMessage.Text += string.Format("<li>{0}</li>", Ex.Message);
            ErrorMessage.Text += "</ul>";
        }
        finally
        {
        }
    }
    protected void Button2_Click(object sender, EventArgs e)
    {
        Response.Redirect(string.Format("{0}.aspx", Page_Name.Text));
    }
}
