/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using JMDCMS.Web.Lib;
using System.Text;

public partial class Modules_Admin_DeleteRole : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            InitPage();
        }
    }
    private void InitPage()
    {
        Caption.Text = "Delete Role";
        Role_Id.Value = "0";
        ErrMsg.Text = string.Empty;
        string PageParams = Util.PageParams(Request.QueryString["Pg"].ToString());
        string[] ParamParts = PageParams.Split(new char[] { ',' });

        if (string.Compare(PageParams, String.Empty) != 0)
        {
             
            DataTable dt;

            Role_Id.Value = ParamParts[0].Split(new char[] { '=' })[1].ToString();

            dt = SqlServer.JMD_ROLE_SELECT(Util.SiteURL(Request.QueryString["Pg"].ToString()),
                Role_Id.Value);
            if (dt.Rows.Count > 0)
            {
                Role_Name.Text = dt.Rows[0]["ROLE_NAME"].ToString();
                Caption.Text = string.Format("Delete Role:{0}", Role_Name.Text);

            }
            dt.Dispose();
        }
    }
    private bool Delete()
    {
        bool Deleted = true;
         
        try
        {
            SqlServer.JMD_ROLE_DELETE(Util.SiteURL(Request.QueryString["Pg"].ToString()),
                Role_Id.Value);
        }
        catch (System.Data.SqlClient.SqlException Ex)
        {
            ErrMsg.Text = string.Format("{0}", Ex.Message);
            Deleted = false;
        }
        finally
        {
        }
        return Deleted;
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        if (Delete())
        {
            Response.Redirect("Roles.aspx");
        }
    }
    protected void Button2_Click(object sender, EventArgs e)
    {
        Response.Redirect("Roles.aspx");

    }
}
