/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/

using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text;
using System.Drawing;
using System.IO;

public partial class Modules_Admin_FileManager : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        BrowseFiles();
    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        // TODO: 1155 - Ability to upload files in images directory 
        Boolean fileOK = false;
        String path = Server.MapPath("~/UserFiles/Images/");

        if (FileUpload1.HasFile) 
        {
            String fileExtension = 
                System.IO.Path.GetExtension(FileUpload1.FileName).ToLower();
            String[] allowedExtensions = 
                {".gif", ".bmp", ".png", ".jpeg", ".jpg", ".pdf"};
          for (int i = 0; i < allowedExtensions.Length; i++)
          {
               if (fileExtension == allowedExtensions[i])
               {
                    fileOK = true;
               }
          }
        }

        if (fileOK)
        {
            try
            {
                FileUpload1.PostedFile.SaveAs(path 
                    + FileUpload1.FileName);
                lblPath.Text = string.Format("File {0} is uploaded!",FileUpload1.FileName);
                BrowseFiles();
            }
            catch (Exception ex)
            {
                lblPath.Text = ex.Message;
            }
        }
        else
        {
            lblPath.Text = "Cannot accept files of this type.";
        }
    }
    private void BrowseFiles()
    {
        string Site_URL = Util.SiteURL(Request.QueryString["Pg"].ToString());
        // NEW
        //ASPxFileManager1.Settings.RootFolder = 

        string folder = Site_URL.Replace('.', '_');
        folder = Site_URL.Replace(':', '_');
        folder = string.Format("~/UserFiles/{0}/",folder);
        string thumbFolder = string.Format("{0}/Thumb", folder);

        string fullPath = Server.MapPath(folder);
        if (!Directory.Exists(fullPath))
        {
            Directory.CreateDirectory(fullPath);
        }

        if (!Directory.Exists(thumbFolder))
        {
            Directory.CreateDirectory(thumbFolder);
        }

        ASPxFileManager1.Settings.RootFolder = folder;
        ASPxFileManager1.Settings.ThumbnailFolder = thumbFolder;
        ASPxFileManager1.SettingsUpload.Enabled = true;
        ASPxFileManager1.SettingsUpload.ValidationSettings.MaxFileSize = 2000000;

        //ASPxFileManager1.SettingsUpload.ValidationSettings.AllowedFileExtensions = new string[] { ".jpg,.jpeg,.gif,.rtf,.txt,.avi,.png,.mp3,.xml,.doc,.docx.pdf" };


        // OLD
        StringBuilder sb = new StringBuilder();
        string AltRowClass = "";
        string strFiles;
        String[] allowedExtensions = 
                { ".gif", ".bmp", ".png", ".jpeg", ".jpg", ".pdf" };

        strFiles = Util.GetFileNames(Server.MapPath("~/UserFiles/Images/"), allowedExtensions, 
            txtSearch.Text);
        string[] Files = strFiles.Split(new char[] { ';' });

        sb.AppendFormat("<Table class=\"Browse\">").AppendLine();
        sb.AppendFormat("<Tr>").AppendLine();

        sb.AppendFormat("<Th>{0}", "File Name").AppendLine();
        sb.AppendFormat("</Th>").AppendLine();

        sb.AppendFormat("<Th>{0}", "HTML").AppendLine();
        sb.AppendFormat("</Th>").AppendLine();

        sb.AppendFormat("</Tr>").AppendLine();

        foreach (string str in Files)
        {
            if (str.Trim() != string.Empty)
            {
                if (AltRowClass == "")
                {
                    AltRowClass = "AltRow";
                }
                else
                {
                    AltRowClass = "";
                }
                sb.AppendFormat("<Tr class=\"{0}\">",
                    AltRowClass).AppendLine();

                sb.AppendFormat("<Td><a href=\"UserFiles/Images/{0}\" target=\"_BLANK\">{0}</a></Td> ",
                    str).AppendLine();

                sb.AppendFormat("<Td><pre>&lt;img src=&quot;UserFiles/Images/{0}&quot; alt=&quot;&quot;&gt;</pre></Td> ",
                     str).AppendLine();
                sb.AppendFormat("</Tr>").AppendLine();
            }
        }
        sb.AppendFormat("</Table>").AppendLine();
        Literal1.Text = sb.ToString();
    
    }
    protected void Button2_Click(object sender, EventArgs e)
    {
        BrowseFiles();
    }
}
