/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Security.Principal;
using System.Text;
using JMDCMS.Web.Lib;

public partial class Modules_Core_Login : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        IPrincipal p = HttpContext.Current.User;
        if (p.Identity.IsAuthenticated)
        {
            FormsAuthentication.SignOut();
            Response.Redirect("Default.aspx");
        }
    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        //VerifyPassword(User_Name.Text, Password.Text);
    }
    public void VerifyPassword(string UserName, string Password)
    {
         
        //Util util = new Util();
        string Site_Url = Util.SiteURL(Request.QueryString["Pg"].ToString());

        DataSet ds;
        ds = SqlServer.JMD_USER_AUTH(Site_Url, UserName);
        if (ds.Tables.Count > 0)
        {
            if (ds.Tables[0].Rows.Count > 0)
            {
                string passwordAndSalt = String.Concat(Password,
                    ds.Tables[0].Rows[0]["SALT"].ToString());
                // Now hash them
                string hashedPasswordAndSalt =
                           FormsAuthentication.HashPasswordForStoringInConfigFile(
                                                           passwordAndSalt, "SHA1");
                // Now verify them.
                bool passwordMatch = hashedPasswordAndSalt.Equals(ds.Tables[0].Rows[0]["PASSWORD_HASH"].ToString());
                if (passwordMatch)
                {
                    //Label3.Text = "Success...";
                    if (ds.Tables.Count > 1)
                    {
                        if (ds.Tables[1].Rows.Count > 0)
                        {
                            CreateAuthCookie(ds.Tables[1].Rows[0]["ROLES"].ToString(), UserName);
                        }
                        else
                        {
                            CreateAuthCookie(string.Empty, UserName);
                        }
                    }
                }
                else
                {
                    Label1.Text = "Invalid ID or Password. Please try again.";
                }

            }
            else
            {
                Label1.Text = "Invalid ID or Password. Please try again.";
            }
        }
    }

    private void UserPasswordReset(string UserName)
    {
        string Site_Url = Util.SiteURL(Request.QueryString["Pg"].ToString());
        DataSet ds;
        ds = SqlServer.JMD_USER_AUTH(Site_Url, UserName);
        if (ds.Tables.Count > 0)
        {
            if (ds.Tables[0].Rows.Count > 0)
            {
                string password = Util.RandomPassword(6, 6);
                 string PasswordSalt = Util.CreateSalt(5);
                 string PasswordHash = Util.CreatePasswordHash(password, PasswordSalt);

                 SqlServer.JMD_USER_PASSWORD_RESET(
                        UserName, 
                        Util.SiteURL(Request.QueryString["Pg"].ToString()),
                        PasswordHash, 
                        PasswordSalt
                     );

                 Util.NewSendEmail(UserName, password);
                Label1.Text = "A new password is emailed to you.";

            }
            else
            {
                Label1.Text = "Email ID does not exist.";
            }
        }
    }

    public void CreateAuthCookie(string roles, string UserName)
    {
        //string roles = "Ajay;Vijay;Sanjay;Vikas";

        FormsAuthenticationTicket authTicket = new
            FormsAuthenticationTicket(1,                          // version
                               UserName,           // user name
                               DateTime.Now,               // creation
                               DateTime.Now.AddMinutes(60),// Expiration
                               false,                      // Persistent
                               roles);                    // User data

        // Now encrypt the ticket.
        string encryptedTicket = FormsAuthentication.Encrypt(authTicket);
        // Create a cookie and add the encrypted ticket to the
        // cookie as data.
        HttpCookie authCookie =
                     new HttpCookie(FormsAuthentication.FormsCookieName,
                                    encryptedTicket);

        // Add the cookie to the outgoing cookies collection.
        Response.Cookies.Add(authCookie);
        Response.Redirect(FormsAuthentication.GetRedirectUrl(
                               UserName,
                               false));

    }

    public void LoginForm()
    {
        StringBuilder sb = new StringBuilder();
        sb.Append("<Table>").AppendLine();

        sb.Append("<Tr>").AppendLine();
        sb.Append("<Td>").AppendLine();
        sb.Append("User ID:").AppendLine();
        sb.Append("</Td>").AppendLine();

        sb.Append("<Td>").AppendLine();
        sb.Append("Text Box").AppendLine();
        sb.Append("</Td>").AppendLine();
        sb.Append("</Tr>").AppendLine();

        sb.Append("<Tr>").AppendLine();
        sb.Append("<Td>").AppendLine();
        sb.Append("Password:").AppendLine();
        sb.Append("</Td>").AppendLine();

        sb.Append("<Td>").AppendLine();
        sb.Append("Text Box").AppendLine();
        sb.Append("</Td>").AppendLine();
        sb.Append("</Tr>").AppendLine();

        sb.Append("</Table>").AppendLine();
        
    }
    protected void Button1_Click1(object sender, EventArgs e)
    {
        VerifyPassword(User_Name.Text, Password.Text);
    }

    protected void Button2_Click(object sender, EventArgs e)
    {
        UserPasswordReset(User_Name.Text);
    }

}
