/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using JMDCMS.Web.Lib;
using System.Security.Principal;

public partial class Modules_Core_NewUser : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            //WI:764: New user registeration, Activation mechanism.
            if (Request.QueryString["Activate"] != null)
            {
                // TODO: code to do activation here.
            }
            else
            {
                InitPage();
            }
        }
    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        IPrincipal p = HttpContext.Current.User;
        if (IsValid())
        {
            if (SaveUser())
            {
                if (p.Identity.IsAuthenticated)
                {
                    Response.Redirect("Users.aspx");
                }
                else
                {
                    Response.Redirect("Default.aspx");
                }
            }
        }
    }
    public void InitPage()
    {
        User_Id.Value = "0";
        IPrincipal p = HttpContext.Current.User;
        string PageParams = Util.PageParams(Request.QueryString["Pg"].ToString());
        //Caption.Text = string.Format("New User");
        if (string.Compare(PageParams, String.Empty) != 0)
        {
             
            DataTable dt;
            string[] ParamParts = PageParams.Split(new char[] { ',' });
            User_Id.Value = ParamParts[0].Split(new char[] { '=' })[1].ToString();

            dt = SqlServer.JMD_USER_SELECT(Util.SiteURL(Request.QueryString["Pg"].ToString()), 
                User_Id.Value);
            if (dt.Rows.Count > 0)
            {
                //Caption.Text = string.Format("Edit User: {0}",
                //    dt.Rows[0]["USER_NAME"].ToString());
                User_Name.Text = dt.Rows[0]["USER_NAME"].ToString();
                if (User_Name.Text == "Admin")
                {
                    User_Name.ReadOnly = true;
                    User_Name.Enabled = false;
                }
                User_Display_Name.Text = dt.Rows[0]["USER_NAME"].ToString();
                Email.Text = dt.Rows[0]["EMAIL"].ToString();
                if (p.Identity.IsAuthenticated)
                {
                    Literal1.Text = "Leave password fields as blank, if you do not wish to change the password";
                }
                else
                {
                    Literal1.Text = string.Empty;
                }
                //Password.Enabled = false;
                //PasswordConfirm.Enabled = false;
                //Password.BackColor = System.Drawing.Color.Gray;
                //PasswordConfirm.BackColor = System.Drawing.Color.Gray;

            }
            else
            {
                //Caption.Text = string.Format("New User");
            }
        }
    }
    public bool SaveUser()
    {
         
        string PasswordHash = string.Empty;
        string PasswordSalt = string.Empty;
        bool Saved = false;

        if (Password.Text.Trim() != string.Empty)
        {
            PasswordSalt = Util.CreateSalt(5);
            PasswordHash = Util.CreatePasswordHash(Password.Text, PasswordSalt);
        }
        else
        {
            PasswordSalt = "0";
            PasswordHash = "0";
        }

        try
        {
            SqlServer.JMD_USER_INSERT(User_Id.Value, Util.SiteURL(Request.QueryString["Pg"].ToString()),
                User_Name.Text,
                User_Display_Name.Text, PasswordHash, PasswordSalt,
                Email.Text);
            Saved = true;
        }
        catch (System.Data.SqlClient.SqlException Ex)
        {
            if (Ex.Number.ToString() == "2627")
            {
                ErrMsg.Text = string.Format("{0}: This user name is already taken. <br /> Server Message: {1}", Ex.Number, Ex.Message);
            }
            else
            {
                ErrMsg.Text = string.Format("{0}: {1}", Ex.Number, Ex.Message);
            }
            Saved = false;
        }
        finally
        {
        }
        return Saved;

        
    }

    private bool IsValid()
    {
        IPrincipal p = HttpContext.Current.User;
        bool bValid = true;
        if (p.Identity.IsAuthenticated)
        {
            if (Password.Text.Trim() != string.Empty)
            {
                if (Password.Text.Trim() != PasswordConfirm.Text.Trim())
                {
                    ErrMsg.Text = "Password does not match with confirm password.";
                    bValid = false;
                }
            }
        }
        else
        {
            if (Password.Text.Trim() != string.Empty)
            {
                if (Password.Text.Trim() != PasswordConfirm.Text.Trim())
                {
                    ErrMsg.Text = "Password does not match with confirm password.";
                    bValid = false;
                }
            }
            else
            {
                ErrMsg.Text = "Password is required.";
                bValid = false;
            }
        }

        if (User_Name.Text.Trim() == string.Empty)
        {
            ErrMsg.Text = "User Name is required.";
            bValid = false;
        }
        if (User_Display_Name.Text.Trim() == string.Empty)
        {
            ErrMsg.Text = "User Display Name is required.";
            bValid = false;
        }
        if (Email.Text.Trim() == string.Empty)
        {
            ErrMsg.Text = "Email is required.";
            bValid = false;
        }

        return bValid;
    }
    protected void Button2_Click(object sender, EventArgs e)
    {
        IPrincipal p = HttpContext.Current.User;
        if (p.Identity.IsAuthenticated)
        {
            Response.Redirect("Users.aspx");
        }
        else
        {
            Response.Redirect("Default.aspx");
        }
    }
}
