/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using JMDCMS.Web.Lib;
using System.Text;


public partial class Modules_Admin_Pages : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            BrowsePages("");
        }
    }
    public void BrowsePages(string Filter)
    {
         
        DataTable dt;
        StringBuilder sb = new StringBuilder();
        string AltRowClass = "";
        dt = SqlServer.JMD_PAGE_SELECT(Util.SiteURL(Request.QueryString["Pg"].ToString())," ", Filter);


        sb.AppendFormat("<Table class=\"Browse\">").AppendLine();
        sb.AppendFormat("<Tr>").AppendLine();

        sb.AppendFormat("<Th>{0}", "Page Name").AppendLine();
        sb.AppendFormat("</Th>").AppendLine();

        sb.AppendFormat("<Th>{0}", "Caption").AppendLine();
        sb.AppendFormat("</Th>").AppendLine();

        sb.AppendFormat("<Th>{0}", "Published").AppendLine();
        sb.AppendFormat("</Th>").AppendLine();

        sb.AppendFormat("<Th>{0}", "Deleted").AppendLine();
        sb.AppendFormat("</Th>").AppendLine();

        sb.AppendFormat("<Th>{0}", "Actions").AppendLine();
        sb.AppendFormat("</Th>").AppendLine();


        sb.AppendFormat("</Tr>").AppendLine();

        foreach (DataRow dr in dt.Rows)
        {
            if (AltRowClass == "")
            {
                AltRowClass = "AltRow";
            }
            else
            {
                AltRowClass = "";
            }
            sb.AppendFormat("<Tr class=\"{0}\">",
                AltRowClass).AppendLine();

            sb.AppendFormat("<Td><a href=\"{0}.aspx\" target=\"_BLANK\">{0}</a></Td> ",
                dr["PAGE_NAME"].ToString()).AppendLine();

            sb.AppendFormat("<Td>{0}</Td> ",
                dr["PAGE_CAPTION"].ToString()).AppendLine();

            sb.AppendFormat("<Td>{0}</Td> ",
                dr["PUBLISHED"].ToString()).AppendLine();

            sb.AppendFormat("<Td>{0}</Td> ",
                dr["DELETED"].ToString()).AppendLine();

            sb.AppendFormat("<Td>{0}{1}</Td> ",
                string.Format("<a href=\"addPage.aspx?Parent_Page={0},Page_Edit=True\" Target=\"_Blank\" ><img src=\"Images/JMDCMS/pencil-wi0062-16.png\" alt=\"Edit Page\" /></a>", dr["PAGE_NAME"].ToString()),
                string.Format("<a href=\"DeletePage.aspx?Page_Name={0}\" Target=\"_Blank\"><img src=\"Images/JMDCMS/del-16.png\" alt=\"Delete/UnDelete Page\" /></a>", dr["PAGE_NAME"].ToString()));
            sb.AppendFormat("</Tr>").AppendLine();

        }
        sb.AppendFormat("</Table>").AppendLine();
        Literal1.Text = sb.ToString();
        dt.Dispose();
    }
    protected void DropDownList1_SelectedIndexChanged(object sender, EventArgs e)
    {
        txtSearch.Text = "";
        BrowsePages(GetFilter());
    }
    private string GetFilter()
    {
        string strFilter = "";
        if (DropDownList1.SelectedValue == "P")
        {
            strFilter = " and IS_PUBLISHED = 1 ";
        }
        else if (DropDownList1.SelectedValue == "U")
        {
            strFilter = " and IS_PUBLISHED = 0 ";
        }
        else if (DropDownList1.SelectedValue == "D")
        {
            strFilter = " and IS_DELETED =  1 ";
        }
        if (txtSearch.Text != "")
        {
            strFilter += string.Format(" and  ( PAGE_NAME LIKE ''%{0}%'' OR PAGE_CAPTION LIKE ''%{0}%'' ) ",
                txtSearch.Text);
        }

        return strFilter;
    }
    protected void Button2_Click(object sender, EventArgs e)
    {
        BrowsePages(GetFilter()); 
    }
}
