/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using JMDCMS.Web.Lib;
using System.Text;


public partial class Modules_Admin_SignUp : System.Web.UI.UserControl
{
    //Recaptcha.RecaptchaControl recaptcha;
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            InitPage();
        }
    }

    private void InitPage()
    {

        //Recaptcha.RecaptchaControl recaptcha = new Recaptcha.RecaptchaControl();
        //recaptcha.ClientIDMode = System.Web.UI.ClientIDMode.Static;
        //recaptcha.PrivateKey = ConfigurationManager.AppSettings["recaptcha-private"].ToString();
        //recaptcha.PublicKey = ConfigurationManager.AppSettings["recaptcha-public"].ToString();
        //repatchaPC.Controls.Add(recaptcha);
    }
    private bool Save()
    {
        return true;
        //if (Role_Name.Text.Trim() == string.Empty)
        //{
        //    ErrMsg.Text = "Role Name is required.";
        //    return false;
        //}
        //SqlServer.JMD_ROLE_SAVE(Role_Id.Value,
        //    Util.SiteURL(Request.QueryString["Pg"].ToString()), Role_Name.Text);
        //return true;

    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        ErrorMessage.Text = string.Empty;
        this.Validate();
        if (!Page.IsValid)
        {
            string msg = "";
            // Loop through all validation controls to see which
            // generated the errors.
            foreach (IValidator aValidator in Page.Validators)
            {
                if (!aValidator.IsValid)
                {
                    if (!string.IsNullOrEmpty(msg))
                    {
                        msg += "<br />";
                    }
                    msg += aValidator.ErrorMessage;
                }
            }
            ErrorMessage.Text = msg;

        }
        else if (Validate())
        {
            Button1.Enabled = false;
            try
            {
                string PasswordSalt = Util.CreateSalt(5);
                string PasswordHash = Util.CreatePasswordHash(Password.Text.Trim(), PasswordSalt);
                string newSiteURL = string.Format("{0}.{1}", txtSiteName.Text.Trim(), "FreeSiteFor.Me");
                SqlServer.JMD_SITE_CREATE(txtSiteName.Text.Trim(), newSiteURL, txtUserName.Text.Trim(), txtName.Text, PasswordHash, PasswordSalt);
                Response.Redirect(string.Format("http://{0}", newSiteURL));
            }
            finally
            {
                Button1.Enabled = true;
            }
        }
    }
    protected void Button2_Click(object sender, EventArgs e)
    {
        Response.Redirect("Roles.aspx");
    }

    private bool Validate()
    {
        bool IsValid = true;
        string ErrMsg = string.Empty;
        ErrorMessage.Text = string.Empty;
        if (txtSiteName.Text.Trim() == String.Empty)
        {
            ErrMsg = "<li>Site Name is required.</li>";
            IsValid = false;
        }
        if (txtUserName.Text.Trim() == String.Empty)
        {
            ErrMsg += "<li>Email is required.</li>";
            IsValid = false;
        }
        if (txtName.Text.Trim() == String.Empty)
        {
            ErrMsg += "<li>Full name is required.</li>";
            IsValid = false;
        }
        if (Password.Text.Trim() == String.Empty)
        {
            ErrMsg += "<li>Password is required.</li>";
            IsValid = false;
        }
        if (PasswordConfirm.Text.Trim() == String.Empty)
        {
            ErrMsg += "<li>Confirm Password is required.</li>";
            IsValid = false;
        }
        if (Password.Text.Trim() != PasswordConfirm.Text.Trim())
        {
            ErrMsg += "<li>Password and Confirm Password do not match.</li>";
            IsValid = false;
        }

        if (IsValid)
        {
            string newSiteURL = string.Format("{0}.{1}", txtSiteName.Text.Trim(), "FreeSiteFor.Me");

            DataTable dt = SqlServer.JMD_SITE_SELECT(newSiteURL);
            if (dt.Rows.Count > 0)
            {
                ErrMsg += "<li>Site Name is already taken. Please enter a new Site Name.</li>";
                IsValid = false;
            }
        }

        if (!IsValid)
        {
            ErrorMessage.Text = "<ul class=\"TableFormErrorMessage\">";
            ErrorMessage.Text += ErrMsg;
            ErrorMessage.Text += "</ul>";
        }


        //if (Page_Caption.Text.Trim() == String.Empty)
        //{
        //    ErrMsg += "<li>Page Caption is required.</li>";
        //    IsValid = false;
        //}
        //Page_Sort_Validator.Validate();
        //if (!Page_Sort_Validator.IsValid)
        //{
        //    ErrMsg += "<li>Page Order must be a numeric value.</li>";
        //    IsValid = false;
        //}

        //if (Meta_Title.Text.Trim() == String.Empty)
        //{
        //    Meta_Title.Text = Page_Caption.Text;
        //    //ErrMsg += "<li>Meta Title is required.</li>";
        //    //IsValid = false;
        //}

        //if (Meta_Desc.Text.Trim() == String.Empty)
        //{
        //    Meta_Desc.Text = Page_Caption.Text;
        //    //ErrMsg += "<li>Meta Description is required.</li>";
        //    //IsValid = false;
        //}
        //if (Meta_Keywords.Text.Trim() == String.Empty)
        //{
        //    Meta_Keywords.Text = Page_Caption.Text;
        //    //ErrMsg += "<li>Meta Keywords is required.</li>";
        //    //IsValid = false;
        //}
        //if (!IsValid)
        //{
        //    ErrorMessage.Text = "<ul class=\"TableFormErrorMessage\">";
        //    ErrorMessage.Text += ErrMsg;
        //    ErrorMessage.Text += "</ul>";

        //}
        return IsValid;
    }


}
