/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using JMDCMS.Web.Lib;

public partial class Modules_Admin_UserRoles : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            InitPage();
        }
    }
    private void InitPage()
    {
        User_Id.Value = "0";
        string PageParams = Util.PageParams(Request.QueryString["Pg"].ToString());
        if (string.Compare(PageParams, String.Empty) != 0)
        {
             
            DataTable dt, dt1;

            dt1 = SqlServer.JMD_ROLE_SELECT(Util.SiteURL(Request.QueryString["Pg"].ToString()));
            User_Roles.Items.Clear();
            CBLAddItems(User_Roles, dt1);

            string[] ParamParts = PageParams.Split(new char[] { ',' });
            User_Id.Value = ParamParts[0].Split(new char[] { '=' })[1].ToString();

            dt = SqlServer.JMD_USER_SELECT(Util.SiteURL(Request.QueryString["Pg"].ToString()),
                User_Id.Value);
            if (dt.Rows.Count > 0)
            {
                if (dt.Rows[0]["USER_NAME"].ToString() != "Admin")
                {
                    User_Name.Text = dt.Rows[0]["USER_NAME"].ToString();
                    StringToCBL(User_Roles, dt.Rows[0]["ROLES"].ToString());
                }
                else
                {
                    Response.Redirect("Users.aspx");
                }
            }
            dt.Dispose();
            dt1.Dispose();
        }
    }
    private bool Save()
    {
         
        SqlServer.JMD_USER_ROLE_SAVE(User_Id.Value,
            CBLToString(User_Roles));
        return true;
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        Save();
        Response.Redirect("Users.aspx");
    }
    protected void Button2_Click(object sender, EventArgs e)
    {
        Response.Redirect("Users.aspx");
    }
    public void CBLAddItems(CheckBoxList cbl, DataTable dt)
    {
        foreach (DataRow dr in dt.Rows)
        {
            if ((dr["ROLE_NAME"].ToString() != "Guests") &&
               (dr["ROLE_NAME"].ToString() != "Registered"))
            {
                ListItem li = new ListItem(dr["ROLE_NAME"].ToString(),
                    dr["ID"].ToString());
                li.Selected = false;
                cbl.Items.Add(li);
            }
        }

    }

    private string CBLToString(CheckBoxList cbl)
    {
        string ListToString = string.Empty;
        foreach (ListItem li in cbl.Items)
        {
            if (li.Selected)
            {
                ListToString += li.Text + ";";
            }
        }
        return ListToString;
    }
    private void StringToCBL(CheckBoxList cbl, string Roles)
    {
        string[] RolesArr = Roles.Split(new char[] { ';' });
        foreach (ListItem li in cbl.Items)
        {
            if (li.Enabled)
            {
                li.Selected = false;
                foreach (string str in RolesArr)
                {
                    if (li.Text == str)
                    {
                        li.Selected = true;
                        break;
                    }
                }
            }
        }
    }

}
