/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text;
using System.Security.Principal;
using JMDCMS.Web.Lib;


public partial class Modules_Core_MenuMain : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        LtMainMenu.Text = MainMenu();
    }

    public string MainMenu()
    {
/*
<div id="navitabs">
<h2 class="hide">Site menu:</h2>
<a class="activenavitab" href="index.html">Welcome</a>
 <span class="hide"> | </span>
<a class="navitab" href="#">Bio</a>
<span class="hide"> | </span>
<a class="navitab" href="#">Discography</a><span class="hide"> | </span>
<a class="navitab" href="#">Downloads</a><span class="hide"> | </span>
<a class="navitab" href="#">Photos</a><span class="hide"> | </span>
<a class="navitab" href="#">Tour</a><span class="hide"> | </span>
<a class="navitab" href="#">Merchandise</a><span class="hide"> | </span>
<a class="navitab" href="#">Interviews</a>
</div>  
 */       
        
        StringBuilder sb = new StringBuilder();
        string ActiveTag = "activenavitab";
        string MenuLink = "<li><a class=\"{2}\" href=\"{0}.aspx\"><span>{1}</span></a></li>";
         
        DataTable dt;
        IPrincipal p = HttpContext.Current.User;
        string Legends = string.Empty;
        
        dt = SqlServer.JMD_MAIN_MENU(Util.SiteURL(Request.QueryString["Pg"].ToString()));

        if (dt.Rows.Count > 0)
        {
            sb.AppendFormat("<ul>").AppendLine();

            foreach (DataRow dr in dt.Rows)
            {
                string[] PageRoles = dr["View_Roles"].ToString().Split(new char[] { ';' });
                foreach (string Role in PageRoles)
                {
                    // handaajay15:WI:783
                    //  if ((p.IsInRole(Role) && (string.Compare(Role.Trim(), string.Empty) != 0)) ||
                    //    (String.Compare(Role, "Guests", true) == 0))
                    if (
                        (p.IsInRole(Role) && (string.Compare(Role.Trim(),string.Empty) != 0 )) || 
                        (!(p.Identity.IsAuthenticated) && (String.Compare(Role, "Guests", true) == 0)) ||
                        ((p.Identity.IsAuthenticated) && (String.Compare(Role, "Registered", true) == 0))
                        )
                    {
                        if (string.Compare(Util.PageName(Request.QueryString["Pg"].ToString()),
                            dr["PAGE_NAME"].ToString(), true) == 0)
                        {
                            ActiveTag = "activenavitab";
                        }
                        else
                        {
                            ActiveTag = "navitab";
                        }

                        if (
                            (dr["IS_PUBLISHED"].ToString() == "1") &&
                            (dr["IS_MENU_ITEM"].ToString() == "1") &&
                            (dr["IS_DELETED"].ToString() == "0")
                            )
                        {
                            sb.AppendFormat(MenuLink,
                                dr["PAGE_NAME"].ToString(),
                                dr["PAGE_CAPTION"].ToString(),
                                ActiveTag).AppendLine();
                        }
                        #region Deleted and unpublished pages can now be handled by Page Manager
/*
                        else
                        {
                            if (p.IsInRole("Admin"))
                            {
                                #region Legends
                                Legends = string.Empty;
                                if (dr["IS_PUBLISHED"].ToString() == "0")
                                {
                                    Legends += "*";
                                }
                                if (dr["IS_DELETED"].ToString() == "1")
                                {
                                    if (Legends != string.Empty)
                                    {
                                        Legends += "-";
                                    }
                                    else
                                    {
                                        Legends += "-";
                                    }
                                }
                                if (dr["IS_MENU_ITEM"].ToString() == "0")
                                {
                                    if (Legends != string.Empty)
                                    {
                                        Legends += "!";
                                    }
                                    else
                                    {
                                        Legends += "!";
                                    }
                                }
                                #endregion Legends

                                if (Legends != string.Empty)
                                {
                                    //Legends
                                    sb.AppendFormat(MenuLink,
                                        dr["PAGE_NAME"].ToString(),
                                        dr["PAGE_CAPTION"].ToString()+" "+ Legends).AppendLine();
                                }
                                else
                                {
                                    sb.AppendFormat(MenuLink,
                                        dr["PAGE_NAME"].ToString(),
                                        dr["PAGE_CAPTION"].ToString()).AppendLine();
                                }

                            }
                        }
  
 */ 
                        #endregion
                        break;
                    }
                }
            }
            sb.AppendFormat("</ul>").AppendLine();
        }
        else
        {
            sb.AppendFormat("<td> No Menu Found...").AppendLine();
            sb.AppendFormat("</td>").AppendLine();
        }


        dt.Dispose();
        return sb.ToString();
    }
}
