/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Security.Principal;
using System.Text;
using JMDCMS.Web.Lib;

public partial class Modules_Core_MenuTop : System.Web.UI.UserControl
{
    bool CanView = false;
    bool CanAdd = false;
    bool CanEdit = false;
    bool CanMove = false;
    bool CanDelete = false;
    bool CanAddModules = false;
    bool IsAdmin = false;

    protected void Page_Load(object sender, EventArgs e)
    {
        IPrincipal p = HttpContext.Current.User;
        if (p.Identity.IsAuthenticated)
        {
            Literal1.Text = MenuSignOut(p.Identity.Name);
        }
        else
        {
            Literal1.Text = MenuSignIn();
        }

        Literal1.Text = string.Format("<div class=\"col_12\">{0}</div><div class=\"clear\"></div>", Literal1.Text); 
    }
    public string MenuSignOut(string UserName)
    {
        JMDSecurity jmdSecurity = new JMDSecurity();
        jmdSecurity.CheckPageAuth(Util.SqlConnectionString(),
            Util.SiteURL(Request.QueryString["Pg"].ToString()),
            Util.PageName(Request.QueryString["Pg"].ToString()));

        //CheckAuthorization();
        StringBuilder sb = new StringBuilder();
        //Util util = new Util();
        string ParentPage = Util.PageName(Request.QueryString["Pg"].ToString());
        sb.AppendFormat("[&nbsp;&nbsp;Page:").AppendLine();

        if (jmdSecurity.PageAdd)
        {
            
    //            <h4>Button Bar</h4>
    //<ul class="button-bar">
    //<li><a href=""><span class="icon" data-icon="7"></span> Edit</a></li>
    //<li><a href=""><span class="icon" data-icon="B"></span> Tag</a></li>
    //<li><a href=""><span class="icon" data-icon=")"></span> Upload</a></li>
    //<li><a href=""><span class="icon" data-icon="p"></span></a></li>
    //</ul>&nbsp;&nbsp;

            //sb.AppendFormat("<ul class=\"button-bar\">");

            //sb.AppendFormat("<li><a href=\"addPage.aspx?Parent_Page={0},Page_Edit=False,Is_Root=True\"><img align=\"middle\" src=\"UserFiles/Images/page_add.png\" alt=\"Add Root\" /></a></li>", ParentPage);

            //sb.AppendFormat("<li><a href=\"addPage.aspx?Parent_Page={0},Page_Edit=False,Is_Root=False\"><img align=\"middle\" src=\"UserFiles/Images/page_copy.png\" alt=\"Add Child\" /></a></li>", ParentPage);
            //sb.AppendFormat("</ul>&nbsp;&nbsp;");
            
            sb.AppendFormat("<a align=\"middle\" href=\"addPage.aspx?Parent_Page={0},Page_Edit=False,Is_Root=True\">Add Root</a>",
                ParentPage).AppendLine();

            sb.AppendFormat(" | <a align=\"middle\" href=\"addPage.aspx?Parent_Page={0},Page_Edit=False,Is_Root=False\">Add Child</a>",
                ParentPage).AppendLine();

        }
        if (jmdSecurity.PageEdit)
        {
            sb.AppendFormat(" | <a align=\"middle\" href=\"addPage.aspx?Parent_Page={0},Page_Edit=True,Is_Root=False\">Edit</a>",
                ParentPage).AppendLine();
        }
        if (jmdSecurity.PageDelete)
        {
            sb.AppendFormat(" | <a align=\"middle\" href=\"DeletePage.aspx?Page_Name={0}\">Delete</a>",
                ParentPage).AppendLine();
        }
        /*
        if (jmdSecurity.PageMove)
        {
            sb.AppendFormat(" | <a href=\"addPage.aspx?Parent_Page={0}\">Move</a>",
                ParentPage).AppendLine();
        }
         */ 
        if (jmdSecurity.PageAddModules)
        {
            sb.AppendFormat(" | <a align=\"middle\" href=\"AddModule.aspx?Page_Name={0}\">Add Module</a>",
                ParentPage).AppendLine();
        }

        if (jmdSecurity.IsAdmin)
        {
            sb.Append("]&nbsp;&nbsp;&nbsp;[&nbsp;&nbsp;Site: &nbsp;<a href=\"Admin.aspx\">Admin</a>").AppendLine();
        }

        sb.AppendFormat("]&nbsp;&nbsp;&nbsp;<a href=\"Login.aspx\">Sign out ({0})&nbsp;</a>", UserName).AppendLine();
        sb.AppendFormat(" IP:{0}", Request.UserHostAddress.ToString()).AppendLine();

        
        //addPage.aspx?Pp=Default
        //util = null;
        jmdSecurity = null;
        return sb.ToString();
    }
    public string MenuSignIn()
    {
         StringBuilder sb = new StringBuilder();
         sb.AppendFormat("<a align=\"middle\" href=\"Login.aspx\">Sign In</a>");
         sb.AppendFormat("&nbsp;|&nbsp;<a align=\"middle\" href=\"NewUser.aspx\">Register</a>").AppendLine();
         sb.AppendFormat("&nbsp;|&nbsp;IP:{0}", Request.UserHostAddress.ToString()).AppendLine();

         return sb.ToString();
    }
    public void CheckAuthorization()
    {
         
        DataTable dt;
        //Util util = new Util();
        string Site_Url = Util.SiteURL(Request.QueryString["Pg"].ToString());
        string Page_Name = Util.PageName(Request.QueryString["Pg"].ToString());

        IPrincipal p = HttpContext.Current.User;
        dt = SqlServer.JMD_PAGE_AUTH(Site_Url, Page_Name);

        if (p.IsInRole("Admin"))
        {
            IsAdmin = true;
            CanView = true;
            CanAdd = true;
            CanEdit = true;
            CanMove = true;
            CanAddModules = true;
        }
        if (dt.Rows.Count > 0)
        {
            //string[] roles = authTicket.UserData.Split(new char[] { ';' });
            string[] ViewRoles = dt.Rows[0]["VIEW_ROLES"].ToString().Split(new char[] { ';' });
            string[] AddRoles = dt.Rows[0]["ADD_ROLES"].ToString().Split(new char[] { ';' });
            string[] EditRoles = dt.Rows[0]["EDIT_ROLES"].ToString().Split(new char[] { ';' });
            string[] MoveRoles = dt.Rows[0]["MOVE_ROLES"].ToString().Split(new char[] { ';' });
            string[] DeleteRoles = dt.Rows[0]["DELETE_ROLES"].ToString().Split(new char[] { ';' });
            string[] AddModuleRoles = dt.Rows[0]["ADD_MODULE_ROLES"].ToString().Split(new char[] { ';' });
            foreach (string Role in ViewRoles)
            {
                if (p.IsInRole(Role) || (String.Compare(Role, "Guests", true) == 0))
                {
                    CanView = true;
                    break;
                }
                else if ((p.Identity.IsAuthenticated) && (String.Compare(Role, "Registered", true) == 0))
                {
                    CanView = true;
                    break;
                }
            }
            foreach (string Role in AddRoles)
            {
                if (p.IsInRole(Role))
                {
                    CanAdd = true;
                    break;
                }
            }

            foreach (string Role in EditRoles)
            {
                if (p.IsInRole(Role))
                {
                    CanEdit = true;
                    break;
                }

            }
            foreach (string Role in DeleteRoles)
            {
                if (p.IsInRole(Role))
                {
                    CanDelete = true;
                    break;
                }

            }
            foreach (string Role in MoveRoles)
            {
                if (p.IsInRole(Role))
                {
                    CanMove = true;
                    break;
                }

            }
            foreach (string Role in AddModuleRoles)
            {
                if (p.IsInRole(Role))
                {
                    CanAddModules = true;
                    break;
                }
            }
        }

        //return Authorized;
    }

}
