/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
 * WI:979: Enable/Disable view state by Module option
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text;
using System.Security.Principal;
using JMDCMS.Web.Lib;

public partial class Modules_Core_ModuleContainer : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        LoadModules(Request.QueryString["Pg"].ToString());
    }

    public void LoadModules(string URI)
    {
         
        //Util util = new Util();
        DataSet ds;
        Control wc;
        #region SECURITY
        IPrincipal p = HttpContext.Current.User;
        string[] ModViewRole;
        string[] ModEditRole;
        string[] ModDeleteRole;
        string[] ModEditContentsRole;
        bool CanModView = false;
        bool CanModEdit = false;
        bool CanModDelete = false;
        bool CanModEditContents = false;

        #endregion

        string ModulePathName = "{0}{1}{2}";
        bool bExcluded = false;
        string ModHeaderDiv;
        string ModContainterDiv;
        string ModFooterDiv;
        bool loadBigModWrapper = true;
       
        ds = SqlServer.JMD_LOAD_MODS(Util.SiteURL(URI), Util.PageName(URI));

        string DivName = string.Empty;
        int LeftCtr = 0;
        int RightCtr = 0;
        int FirstTime = 0;

        if (ds.Tables[0].Rows.Count > 0)
        {

            ModHeaderDiv = "ModHeaderDiv";
            ModContainterDiv = "ModContainerDiv";
            ModFooterDiv = "ModFooterDiv";
            foreach (DataRow dr in ds.Tables[0].Rows)
            {

                #region SECURITY
                ModViewRole = dr["MOD_VIEW_ROLE"].ToString().Split(new char[] { ';' });
                ModEditRole = dr["MOD_EDIT_ROLE"].ToString().Split(new char[] { ';' });
                ModDeleteRole = dr["MOD_DELETE_ROLE"].ToString().Split(new char[] { ';' });
                ModEditContentsRole = dr["MOD_EDIT_CONTENTS_ROLE"].ToString().Split(new char[] { ';' });
                
                CanModView = false;
                CanModEdit = false;
                CanModDelete = false;
                CanModEditContents = false;

                if (p.IsInRole("Admin"))
                {
                    CanModView = true;
                    CanModEdit = true;
                    CanModDelete = true;
                    CanModEditContents = true;
                }
                else
                {
                    // MODULE VIEW ROLE
                    foreach (string Role in ModViewRole)
                    {
                        // handaajay15:WI:783
                        // if ((p.IsInRole(Role) && (string.Compare(Role.Trim(), string.Empty) != 0)) ||
                        //   (String.Compare(Role, "Guests", true) == 0))
                        // Other than Admin, all modules should only visible to authorized role.
                        if ((p.IsInRole(Role) &&
                            (string.Compare(Role.Trim(), string.Empty) != 0))) 
                        {
                            CanModView = true;
                            break;
                        }
                        // handaajay15:WI:783 New Condition Added 
                        else if (!(p.Identity.IsAuthenticated) && 
                            (String.Compare(Role, "Guests", true) == 0) &&
                             (dr["IS_MOD_DELETED"].ToString() == "0"))
                        {
                            CanModView = true;
                            break;
                        }
                        else if ((p.Identity.IsAuthenticated) && (String.Compare(Role, "Registered", true) == 0))
                        {
                            CanModView = true;
                            break;
                        }
                    }
                    // MODULE EDIT ROLE
                    // handaajay15:WI:783
                    foreach (string Role in ModEditRole)
                    {
                        if ((p.IsInRole(Role) && (string.Compare(Role.Trim(), string.Empty) != 0)))
                        {
                            CanModEdit = true;
                            break;
                        }
                        // handaajay15:WI:783 New Condition Added 
                        else if (!(p.Identity.IsAuthenticated) && (String.Compare(Role, "Guests", true) == 0))
                        {
                            CanModEdit = true;
                            break;
                        }
                        else if ((p.Identity.IsAuthenticated) && (String.Compare(Role, "Registered", true) == 0))
                        {
                            CanModEdit = true;
                            break;
                        }
                    }
                    // MODULE DELETE ROLE
                    // handaajay15:WI:783
                    foreach (string Role in ModDeleteRole)
                    {
                        if ((p.IsInRole(Role) && (string.Compare(Role.Trim(), string.Empty) != 0)))
                        {
                            CanModDelete = true;
                            break;
                        }
                        // handaajay15:WI:783 New Condition Added 
                        else if (!(p.Identity.IsAuthenticated) && (String.Compare(Role, "Guests", true) == 0))
                        {
                            CanModDelete = true;
                            break;
                        }
                        else if ((p.Identity.IsAuthenticated) && (String.Compare(Role, "Registered", true) == 0))
                        {
                            CanModDelete = true;
                            break;
                        }
                    }
                    // MODULE EDIT CONTENTS ROLE
                    // handaajay15:WI:783
                    foreach (string Role in ModEditContentsRole)
                    {
                        if ((p.IsInRole(Role) && (string.Compare(Role.Trim(), string.Empty) != 0)))
                        {
                            CanModEditContents = true;
                            break;
                        }
                        // handaajay15:WI:783 New Condition Added 
                        else if (!(p.Identity.IsAuthenticated) && (String.Compare(Role, "Guests", true) == 0))
                        {
                            CanModEditContents = true;
                            break;
                        }
                        else if ((p.Identity.IsAuthenticated) && (String.Compare(Role, "Registered", true) == 0))
                        {
                            CanModEditContents = true;
                            break;
                        }
                    }

                }

                #endregion

                if (CanModView) 
                {
                    if (dr["MOD_NAME"].ToString() != String.Empty)
                    {

                        bExcluded = false;

                        if (ds.Tables[1].Rows.Count > 0)
                        {
                            foreach (DataRow dr1 in ds.Tables[1].Rows)
                            {
                                if (dr["PAGE_MOD_ID"].ToString() == dr1["PAGE_MOD_ID"].ToString())
                                {
                                    bExcluded = true;
                                }
                            }
                        }
                        if (!bExcluded)
                        {
                            if (FirstTime == 0)
                            {
                                FirstTime = 1;
                            }
                            else
                            {
                                if (dr["DIV_NAME"].ToString() != DivName)
                                {
                                    Literal lt = new Literal();
                                    lt.Text = "</div> <!-- 1 -->";
                                    PlaceHolder1.Controls.Add(lt);
                                }
                            }

                            if (dr["DIV_NAME"].ToString() == "Left")
                            {
                                LeftCtr += 1;
                                ModHeaderDiv = "ModHeaderLeft";
                                ModContainterDiv = "ModContainerLeft";
                            }
                            else if (dr["DIV_NAME"].ToString() == "Right")
                            {
                                RightCtr += 1;
                                ModHeaderDiv = "ModHeaderRight";
                                ModContainterDiv = "ModContainerRight";
                            }
                            //LoadControl
                            Literal lt1 = new Literal();
                            lt1.Text = string.Empty;

                            if ((dr["DIV_NAME"].ToString() == "Left") ||
                                (dr["DIV_NAME"].ToString() == "Right") ||
                                (dr["DIV_NAME"].ToString() == "Center"))
                            {
                                if (loadBigModWrapper)
                                {
                                    lt1.Text += string.Format("<div class=\"{0}\">",
                                           "BigModWrapper");
                                    loadBigModWrapper = false;

                                }
                            }

                            if (dr["DIV_NAME"].ToString() != DivName)
                            {
                                DivName = dr["DIV_NAME"].ToString();

                                if (dr["DIV_NAME"].ToString() == "Center")
                                {
                                    if ((LeftCtr > 0) && (RightCtr > 0))
                                    {
                                        lt1.Text += string.Format("<div class=\"{0}\">",
                                           "Middle");
                                        ModHeaderDiv = "ModHeaderMiddle";
                                        ModContainterDiv = "ModContainerMiddle";

                                    }
                                    else if ((LeftCtr > 0) && (RightCtr == 0))
                                    {
                                        lt1.Text += string.Format("<div class=\"{0}\">",
                                           "Middle-Left");
                                        ModHeaderDiv = "ModHeaderMiddle-Left";
                                        ModContainterDiv = "ModContainerMiddle-Left";

                                    } if ((LeftCtr == 0) && (RightCtr > 0))
                                    {
                                        lt1.Text += string.Format("<div class=\"{0}\">",
                                           "Middle-Right");
                                        ModHeaderDiv = "ModHeaderMiddle-Right";
                                        ModContainterDiv = "ModContainerMiddle-Right";

                                    } if ((LeftCtr == 0) && (RightCtr == 0))
                                    {
                                        lt1.Text += string.Format("<div class=\"{0}\">",
                                           "Middle-Full");
                                        ModHeaderDiv = "ModHeaderMiddle-Full";
                                        ModContainterDiv = "ModContainerMiddle-Full";


                                    }
                                }
                                else
                                {
                                    lt1.Text += string.Format("<div class=\"{0}\">",
                                       dr["DIV_NAME"].ToString());

                                    if (dr["DIV_NAME"].ToString() == "Left")
                                    {
                                        ModHeaderDiv = "ModHeaderLeft";
                                        ModContainterDiv = "ModContainerLeft";
                                    }
                                    else if (dr["DIV_NAME"].ToString() == "Right")
                                    {
                                        ModHeaderDiv = "ModHeaderRight";
                                        ModContainterDiv = "ModContainerRight";
                                    }
                                    else
                                    {

                                        ModHeaderDiv = "ModHeaderDiv";
                                        ModContainterDiv = "ModContainerDiv";
                                        ModFooterDiv = "ModFooterDiv";
                                    }
                                }
                            }
                            if ((dr["DIV_NAME"].ToString() == "Left") ||
                                (dr["DIV_NAME"].ToString() == "Right") ||
                                (dr["DIV_NAME"].ToString() == "Center"))
                            {
                                lt1.Text += string.Format("<div class=\"{0}\">",
                                       "ModWrapper");
                            }


                            //PlaceHolder1.Controls.Add(lt1);
                            if ((dr["IS_MOD_PUBLISHED"].ToString() == "1" ) ||
                                p.IsInRole("Admin"))
                            {

                                if (p.Identity.IsAuthenticated)
                                {
                                    if (dr["CAN_SHOW_MOD_HEADER"].ToString() == "1")
                                    {

                                        lt1.Text += ModHeader(dr["PAGE_MOD_ID"].ToString(),
                                            dr["MOD_TITLE"].ToString(), true, ModHeaderDiv,
                                            CanModEdit, CanModDelete, CanModEditContents,
                                            dr["IS_MOD_PUBLISHED"].ToString(), p.IsInRole("Admin"),
                                            dr["MOD_SORT"].ToString(),
                                            dr["IS_ADMIN"].ToString(),
                                            dr["IS_MOD_DELETED"].ToString());
                                    }
                                    else
                                    {
                                        if ((dr["DIV_NAME"].ToString() == "Left") ||
                                            (dr["DIV_NAME"].ToString() == "Right") ||
                                            (dr["DIV_NAME"].ToString() == "Center"))
                                        {
                                            
                                            lt1.Text += ModHeader(dr["PAGE_MOD_ID"].ToString(),
                                                dr["MOD_TITLE"].ToString(), false, ModHeaderDiv,
                                                CanModEdit, CanModDelete, CanModEditContents,
                                            dr["IS_MOD_PUBLISHED"].ToString(), p.IsInRole("Admin"),
                                            dr["MOD_SORT"].ToString(),
                                            dr["IS_ADMIN"].ToString(),
                                             dr["IS_MOD_DELETED"].ToString());
                                        }
                                    }
                                }
                                else
                                {
                                    if ((dr["DIV_NAME"].ToString() == "Left") ||
                                        (dr["DIV_NAME"].ToString() == "Right") ||
                                        (dr["DIV_NAME"].ToString() == "Center"))
                                    {

                                        lt1.Text += ModHeader(dr["PAGE_MOD_ID"].ToString(),
                                            dr["MOD_TITLE"].ToString(), false, ModHeaderDiv,
                                            CanModEdit, CanModDelete, CanModEditContents,
                                            dr["IS_MOD_PUBLISHED"].ToString(), p.IsInRole("Admin"),
                                            dr["MOD_SORT"].ToString(),
                                            dr["IS_ADMIN"].ToString(),
                                             dr["IS_MOD_DELETED"].ToString());
                                    }
                                }



                                PlaceHolder1.Controls.Add(lt1);

                                Literal ltModContainer = new Literal();
                                ltModContainer.Text = string.Format("<div class={0}>", ModContainterDiv);
                                PlaceHolder1.Controls.Add(ltModContainer);

                                wc = LoadControl(String.Format(ModulePathName,
                                    Request.ApplicationPath,
                                    dr["MOD_PATH"].ToString(),
                                    dr["MOD_NAME"].ToString()));
                                wc.ID = string.Format("{0}_{1}_{2}",
                                    dr["DIV_NAME"].ToString(),
                                    dr["PAGE_MOD_ID"].ToString(),
                                    dr["MOD_TITLE"].ToString());
                                
                                //WI:979: Enable/Disable view state by Module option
                                if (dr["MOD_IS_VIEWSTATE_ENABLED"].ToString() == "0")
                                {
                                    wc.EnableViewState = false;
                                }
                                else
                                {
                                    wc.EnableViewState = true;
                                }
                                PlaceHolder1.Controls.Add(wc);
                                Literal ltModContainer1 = new Literal();
                                if ((dr["DIV_NAME"].ToString() == "Left") ||
                                    (dr["DIV_NAME"].ToString() == "Right") ||
                                    (dr["DIV_NAME"].ToString() == "Center"))
                                {
                                    ltModContainer1.Text = "</div></div> <!-- 2 -->";
                                }
                                else
                                {
                                    ltModContainer1.Text = "</div> <!-- 2 -->";
                                }


                                PlaceHolder1.Controls.Add(ltModContainer1);

                            }
                        }
                    }
                }
            }

            Literal lt2 = new Literal();
            if (!loadBigModWrapper)
            {
                lt2.Text = "</div></div> <!-- 3 -->";
            }
            else
            {
                lt2.Text = "</div> <!-- 3 -->";
            }
            PlaceHolder1.Controls.Add(lt2);
        }
        ds.Dispose();
        //util = null;
    }
    public void _LoadModules(string ModulePathWithName)
    {
        /*
        //Literal1.Text = Request.ApplicationPath.ToString();
        Control wc;
        wc = LoadControl(Request.ApplicationPath + "\\Modules\\Core\\ModuleHeader.ascx");
        PnlBase.Controls.Add(wc);
        wc = LoadControl(Request.ApplicationPath + "\\Modules\\JMDHTML\\JMDHTML.ascx");
        PnlBase.Controls.Add(wc);
        wc = LoadControl(Request.ApplicationPath + "\\Modules\\Core\\ModuleFooter.ascx");
        PnlBase.Controls.Add(wc);

        //PnlBase.Controls.A
        //myUC = LoadControl("pathToUserWebControl");
        //placehloader.control.add(myUc);
         */ 
    }
    public string ModHeader(string Page_Mod_Id, string Mod_Title, 
        bool IsEdit, string ModDivName,
        bool CanModEdit, bool CanModDelete, bool CanModEditContents, 
        string IsPublished, bool IsAdmin, string ModSort, 
        string IsAdminModule, string IsDeleted)

    {
        StringBuilder sb = new StringBuilder();
        string Edit = string.Empty;
        string Del = string.Empty;
        string Contents = string.Empty;
        string Published = string.Empty;
        if (IsEdit)
        {

            if (CanModEdit)
            {
                Edit = string.Format("<a href=\"AddModule.aspx?Page_Name={0},PageModId={1}\"><img src=\"Images/JMDCMS/pencil-wi0062-16.png\" alt=\"Edit\" /></a>",
                    Util.PageName(Request.QueryString["Pg"].ToString()),
                    Page_Mod_Id);
            }

            if (CanModDelete)
            {
                // WI: 650 - Admin function Module Delete / Undelete
                if (IsDeleted == "1")
                {
                    Del = string.Format("<a href=\"DeletePageModule.aspx?PageModId={0},Mod_Title={1},Page_Name={2},Action=0 \"><img src=\"Images/JMDCMS/recycle-bin-full.png\" alt=\"Undo Recycle Bin\" /></a>",
                        Page_Mod_Id,
                        Mod_Title,
                        Util.PageName(Request.QueryString["Pg"].ToString()));

                    Del += string.Format("<a href=\"DeletePageModule.aspx?PageModId={0},Mod_Title={1},Page_Name={2},Action=5 \"><img src=\"Images/JMDCMS/Del-16.png\" alt=\"Delete\" /></a>",
                        Page_Mod_Id,
                        Mod_Title,
                        Util.PageName(Request.QueryString["Pg"].ToString()));

                }
                else
                {
                    Del = string.Format("<a href=\"DeletePageModule.aspx?PageModId={0},Mod_Title={1},Page_Name={2},Action=1 \"><img src=\"Images/JMDCMS/recycle-bin-empty.png\" alt=\"Recycle Bin\" /></a>",
                        Page_Mod_Id,
                        Mod_Title,
                        Util.PageName(Request.QueryString["Pg"].ToString()));

                    Del += string.Format("<a href=\"DeletePageModule.aspx?PageModId={0},Mod_Title={1},Page_Name={2},Action=5 \"><img src=\"Images/JMDCMS/Del-16.png\" alt=\"Delete\" /></a>",
                        Page_Mod_Id,
                        Mod_Title,
                        Util.PageName(Request.QueryString["Pg"].ToString()));
                }
            }
            if (CanModEditContents)
            {
                Contents = string.Format("<a href=\"JMDHTMLEdit.aspx?PageModId={0},Page_Name={1}\"><img src=\"Images/JMDCMS/Content-16.png\" alt=\"Contents\" /></a>",
                    Page_Mod_Id,
                    Util.PageName(Request.QueryString["Pg"].ToString()));
            }

            if (IsPublished == "0")
            {
                Published = "[NP]";
            }

            if (IsAdmin)
            {
                sb.AppendFormat("<div class={0}>", ModDivName);
                sb.AppendFormat("{0} {1}{2}{3} ({4}) {5}",
                    Mod_Title,
                    Edit,
                    Del,
                    Contents,
                    ModSort,
                    Published);
                sb.AppendFormat("</div> <!-- 4 -->");
            }
            else
            {
                sb.AppendFormat("<div class={0}>", ModDivName);
                sb.AppendFormat("{0} {1}{2}{3}",
                    Mod_Title,
                    Edit,
                    Del,
                    Contents
                    );
                sb.AppendFormat("</div> <!-- 5 -->");
            }
        }
        else
        {
            if (IsAdmin)
            {

                if (IsAdminModule == "0")
                {
                    Del = string.Format("<a href=\"DeletePageModule.aspx?PageModId={0},Mod_Title={1},Page_Name={2},Action=5 \"><img src=\"Images/JMDCMS/del-16.png\" alt=\"Delete\" /></a>",
                        Page_Mod_Id,
                        Mod_Title,
                        Util.PageName(Request.QueryString["Pg"].ToString()));

                    sb.AppendFormat("<div class={0}>", ModDivName);
                    sb.AppendFormat("<div class=\"ModHeaderArrow\"></div> <!-- 6 --> {0} {1} ({2})",
                        Mod_Title,
                        Del,
                        ModSort);
                    sb.AppendFormat("</div> <!-- 7 -->");
                }
                else
                {
                    sb.AppendFormat("<div class={0}>", ModDivName);
                    sb.AppendFormat("<div class=\"ModHeaderArrow\"></div>  <!-- 8 -->{0}",
                        Mod_Title);
                    sb.AppendFormat("</div> <!-- 9 -->");
                }
            }
            else
            {
                sb.AppendFormat("<div class={0}>", ModDivName);
                sb.AppendFormat("<div class=\"ModHeaderArrow\"></div> <!-- 10 -->{0}",
                    Mod_Title);
                sb.AppendFormat("</div> <!-- 11 -->");
            }
        }
        return sb.ToString();
    }

}
