/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using JMDCMS.Web.Lib;
using System.Text;


public partial class Modules_Forms_BrowseCols : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        BrowseCols(Request.QueryString["Pg"].ToString());
    }
    public void BrowseCols(string URI)
    {
        string PageParams = Util.PageParams(URI);
        JMD_OBJ_ID.Value = "0";

        if (string.Compare(PageParams, String.Empty) != 0)
        {
            string[] ParamParts = PageParams.Split(new char[] { ',' });
            JMD_OBJ_ID.Value = ParamParts[0].Split(new char[] { '=' })[1].ToString();

             
            DataTable dt;
            StringBuilder sb = new StringBuilder();

            dt = SqlServer.JMD_COL_SELECT_COLUMNS(JMD_OBJ_ID.Value);

            sb.AppendFormat("<h1>Form - {0}</h1>",
                ParamParts[1].Split(new char[] { '=' })[1].ToString());

            sb.AppendFormat("<a href=\"NewCol.aspx?Obj_Id={0},Obj_Name={1},Col_Id={2} \">{3}</a>",
                JMD_OBJ_ID.Value,
                ParamParts[1].Split(new char[] { '=' })[1].ToString(),
                "0",
                "Add New Columns").AppendLine();

            sb.AppendFormat("<Table class=\"Browse\">").AppendLine();
            sb.AppendFormat("<Tr>").AppendLine();

            sb.AppendFormat("<Th>{0}</Th>", "Name").AppendLine();
            sb.AppendFormat("<Th>{0}</Th>", "Caption").AppendLine();
            sb.AppendFormat("<Th>{0}</Th>", "Description").AppendLine();
            sb.AppendFormat("<Th>{0}</Th>", "Type").AppendLine();

            sb.AppendFormat("</Tr>").AppendLine();

            foreach (DataRow dr in dt.Rows)
            {
                sb.AppendFormat("<Tr>").AppendLine();

                sb.AppendFormat("<Td><a href=\"NewCol.aspx?Obj_Id={0},Obj_Name={1},Col_Id={2} \">{3}</a></td>",
                                JMD_OBJ_ID.Value,
                                ParamParts[1].Split(new char[] { '=' })[1].ToString(),
                                dr["ID"].ToString(),
                                dr["JMD_COL_NAME"].ToString()).AppendLine();

                sb.AppendFormat("<Td><a href=\"NewCol.aspx?Obj_Id={0},Obj_Name={1},Col_Id={2} \">{3}</a></td>",
                                JMD_OBJ_ID.Value,
                                ParamParts[1].Split(new char[] { '=' })[1].ToString(),
                                dr["ID"].ToString(),
                                dr["JMD_COL_CAPTION"].ToString()).AppendLine();

                if (dr["JMD_COL_DESC"].ToString().Length > 100)
                {
                    sb.AppendFormat("<Td><a href=\"NewCol.aspx?Obj_Id={0},Obj_Name={1},Col_Id={2} \">{3}</a></td>",
                                    JMD_OBJ_ID.Value,
                                    ParamParts[1].Split(new char[] { '=' })[1].ToString(),
                                    dr["ID"].ToString(),
                                    dr["JMD_COL_DESC"].ToString().Substring(0,100)+"...").AppendLine();
                }
                else
                {

                    sb.AppendFormat("<Td><a href=\"NewCol.aspx?Obj_Id={0},Obj_Name={1},Col_Id={2} \">{3}</a></td>",
                                    JMD_OBJ_ID.Value,
                                    ParamParts[1].Split(new char[] { '=' })[1].ToString(),
                                    dr["ID"].ToString(),
                                    dr["JMD_COL_DESC"].ToString()).AppendLine();
                }

                sb.AppendFormat("<Td><a href=\"NewCol.aspx?Obj_Id={0},Obj_Name={1},Col_Id={2} \">{3}</a></td>",
                                JMD_OBJ_ID.Value,
                                ParamParts[1].Split(new char[] { '=' })[1].ToString(),
                                dr["ID"].ToString(),
                                dr["COL_TYPE"].ToString()).AppendLine();


                sb.AppendFormat("</Tr>").AppendLine();

            }
            sb.AppendFormat("</Table>").AppendLine();
            Literal1.Text = sb.ToString();
            dt.Dispose();
        }
    }
}
