/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using JMDCMS.Web.Lib;

public partial class Modules_Forms_NewCol : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            InitPage();
        }
    }
    private void InitPage()
    {
        JMD_OBJ_ID.Value = "0";
        JMD_COL_ID.Value = "0";

        string PageParams = Util.PageParams(Request.QueryString["Pg"].ToString());
        string[] ParamParts = PageParams.Split(new char[] { ',' });
        string Col_Type_Id = string.Empty;
        string Col_Ext_Data = string.Empty;

        JMD_OBJ_ID.Value = ParamParts[0].Split(new char[] { '=' })[1].ToString();
        lblJMD_OBJ_NAME.Text = ParamParts[1].Split(new char[] { '=' })[1].ToString();
        JMD_COL_ID.Value = ParamParts[2].Split(new char[] { '=' })[1].ToString();

         

        if (JMD_COL_ID.Value != "0")
        {
            DataTable dt1;
            dt1 = SqlServer.JMD_COL_SELECT_COL(JMD_COL_ID.Value);
            if (dt1.Rows.Count > 0)
            {
                JMD_COL_NAME.Text = dt1.Rows[0]["JMD_COL_NAME"].ToString();
                JMD_COL_CAPTION.Text = dt1.Rows[0]["JMD_COL_CAPTION"].ToString();
                JMD_COL_DESC.Text = dt1.Rows[0]["JMD_COL_DESC"].ToString();
                Col_Type_Id = dt1.Rows[0]["JMD_COL_TYPE_ID"].ToString();
                Col_Ext_Data = dt1.Rows[0]["COL_EXT_DATA"].ToString();
            }
            dt1.Dispose();
        }
        DataTable dt;
        dt = SqlServer.JMD_COL_TYPE_SELECT(Util.SiteURL(Request.QueryString["Pg"].ToString()));
        JMD_COL_TYPE_ID.Items.Clear();
        if (dt.Rows.Count > 0)
        {
            foreach (DataRow dr in dt.Rows)
            {
                ListItem li = new ListItem(dr["COL_TYPE"].ToString(), dr["ID"].ToString());
                if (dr["ID"].ToString() == Col_Type_Id)
                {
                    li.Selected = true;
                }
                JMD_COL_TYPE_ID.Items.Add(li);
            }
        }
        if (JMD_COL_TYPE_ID.SelectedItem != null)
        {
            ShowPanel(JMD_COL_TYPE_ID.SelectedItem.Text);
        }
        else
        {
            ShowPanel("Blank");
        }

        DbToOptions(Col_Ext_Data);
        dt.Dispose();
    }
    private void Save()
    {
         
        String COL_EXT_DATA = string.Empty;
        SqlServer.JMD_COL_SAVE(JMD_COL_ID.Value, JMD_OBJ_ID.Value,
            JMD_COL_NAME.Text, JMD_COL_CAPTION.Text, JMD_COL_DESC.Text.Replace("'","''"),
            JMD_COL_TYPE_ID.Text, OptionsToDb());
    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        Save();
        Response.Redirect(string.Format("BrowseCols.aspx?Obj_Id={0},Obj_Name={1}",
            JMD_OBJ_ID.Value,
            lblJMD_OBJ_NAME.Text));
    }
    protected void Button2_Click(object sender, EventArgs e)
    {
        Response.Redirect(string.Format("BrowseCols.aspx?Obj_Id={0},Obj_Name={1}",
                    JMD_OBJ_ID.Value,
                    lblJMD_OBJ_NAME.Text));
    }
    private void ShowPanel(string ColType)
    {
        PnlSingleLine.Visible = false;
        PnlMultiLine.Visible = false;
        PnlCheckBox.Visible = false;
        PnlList.Visible = false;
        PnlLookup.Visible = false;
        if (ColType == "SingleLine")
        {
            PnlSingleLine.Visible =true;
        }
        else if (ColType == "MultiLine")
        {
            PnlMultiLine.Visible = true;
        }
        else if (ColType == "CheckBox")
        {
            PnlCheckBox.Visible = true;
        }
        else if ((ColType == "CheckBoxList") || 
            (ColType == "ListBox") ||
            (ColType == "ComboBox") ||
            (ColType == "RadioButton")
            )
        {
            PnlList.Visible = true;
        }
        else if (ColType == "Lookup")
        {
            PnlLookup.Visible = true;
            InitLookup();
        }
            
    }
    public void InitLookup()
    {
         
        DataTable dt;
        dt = SqlServer.JMD_OBJ_SELECT_TABLES(Util.SiteURL(Request.QueryString["Pg"].ToString()));
        LookupTable.Items.Clear();
        foreach (DataRow dr in dt.Rows)
        {
            ListItem li = new ListItem();
            //li.Attributes.Add(dr["OBJ_NAME"].ToString(), dr["ID"].ToString());
            li.Text = dr["OBJ_NAME"].ToString();
            li.Value = dr["ID"].ToString();
            LookupTable.Items.Add(li);
        }
        
        if ( LookupTable.Items.Count > 0)
        {
            LookupTable.SelectedIndex = 0;
            InitLookupFields(LookupTable.SelectedValue);
        }
        dt.Dispose();
    }
    public void InitLookupFields(string Obj_Id)
    {
         
        DataTable dt;
        dt = SqlServer.JMD_COL_SELECT_COLUMNS(Obj_Id);
        LookupField.Items.Clear();
        foreach (DataRow dr in dt.Rows)
        {
            ListItem li = new ListItem();
            //li.Attributes.Add(dr["JMD_COL_CAPTION"].ToString(), dr["ID"].ToString());
            li.Text = dr["JMD_COL_CAPTION"].ToString();
            li.Value = dr["JMD_COL_NAME"].ToString();

            LookupField.Items.Add(li);
        }

        dt.Dispose();
    }
    /* 
     * GET EXTENDED COLUMN VALUES FROM GUI AND CREATE
     * STRING TO SEND BACK TO DATABASE
     */ 
    private string OptionsToDb()
    {
        if (JMD_COL_TYPE_ID.SelectedItem.Text == "SingleLine")
        {
            return Util.SingleLineOptionsToDb(SLRequired.Checked, SLMaxLength.Text);
        }
        else if (JMD_COL_TYPE_ID.SelectedItem.Text == "MultiLine")
        {
            return Util.MultiLineOptionsToDb(MLRequired.Checked, MLTotalLines.Text);
        }
        else if (JMD_COL_TYPE_ID.SelectedItem.Text == "CheckBox")
        {
            return Util.CheckBoxOptionsToDb(chkDefault.SelectedValue);
        }
        else if ((JMD_COL_TYPE_ID.SelectedItem.Text == "CheckBoxList") ||
              (JMD_COL_TYPE_ID.SelectedItem.Text == "ListBox") ||
              (JMD_COL_TYPE_ID.SelectedItem.Text == "ComboBox") ||
              (JMD_COL_TYPE_ID.SelectedItem.Text == "RadioButton")
           )
        {
            return Util.ListOptionsToDb(ListRequired.Checked, 
                ListOptions.Text, ListDefault.Text);
        }
        else if (JMD_COL_TYPE_ID.SelectedItem.Text == "Lookup")
        {
            return Util.LookupOptionsToDb(LookupRequired.Checked, 
                LookupTable.SelectedValue, 
                LookupField.SelectedValue);
        }
        else 
        {
            return "Extended Options not defined yet.";
        }

    }
    /*
     * GET EXTENDED COLUMN VALUES FROM DATABASE AND INITIALIZE
     * THE GUI FIELDS
     */ 
    private void DbToOptions(string Options)
    {
        if (JMD_COL_TYPE_ID.SelectedItem != null)
        {
            if (JMD_COL_TYPE_ID.SelectedItem.Text == "SingleLine")
            {
                SLRequired.Checked = Util.IsRequired(Options);
                SLMaxLength.Text = Util.TextMaxLength(Options);
            }
            else if (JMD_COL_TYPE_ID.SelectedItem.Text == "MultiLine")
            {
                MLRequired.Checked = Util.IsRequired(Options);
                MLTotalLines.Text = Util.TextTotalLines(Options);
            }
            else if (JMD_COL_TYPE_ID.SelectedItem.Text == "CheckBox")
            {
                chkDefault.SelectedValue = Util.CheckBoxDefault(Options);
            }
            else if ((JMD_COL_TYPE_ID.SelectedItem.Text == "CheckBoxList") ||
                 (JMD_COL_TYPE_ID.SelectedItem.Text == "ListBox") ||
                 (JMD_COL_TYPE_ID.SelectedItem.Text == "ComboBox") ||
                 (JMD_COL_TYPE_ID.SelectedItem.Text == "RadioButton")
                  )
            {
                ListRequired.Checked = Util.IsRequired(Options);
                ListOptions.Text = Util.ListItems(Options);
                ListDefault.Text = Util.ListDefault(Options);
            }
            else if (JMD_COL_TYPE_ID.SelectedItem.Text == "Lookup")
            {
                LookupRequired.Checked = Util.IsRequired(Options);
                LookupTable.SelectedValue = Util.LookupSource(Options);
                InitLookupFields(LookupTable.SelectedValue);
                LookupField.SelectedValue = Util.LookupField(Options);
            }
        }
    }
    protected void JMD_COL_TYPE_ID_SelectedIndexChanged(object sender, EventArgs e)
    {
        ShowPanel(JMD_COL_TYPE_ID.SelectedItem.Text);
    }
    protected void LookupTable_SelectedIndexChanged(object sender, EventArgs e)
    {
        InitLookupFields(LookupTable.SelectedItem.Value);
    }
}
