/*
	Copyright (C) 2007  Ajay Handa - jmdcms.com 
	This program is free software; 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	License for more details.
	Some rights reserved. Please read License.txt for details.
	Removing above copyright message is a violation of license terms.
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using JMDCMS.Web.Lib;
using System.Text;

public partial class Modules_Forms_NewRecord : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        BuildForm();
        //if (!IsPostBack)
        //{
        //    BuildForm();
       // }
    }
    private void BuildForm()
    {
        string PageParams = Util.PageParams(Request.QueryString["Pg"].ToString());
        JMD_OBJ_ID.Value = "0";

        if (string.Compare(PageParams, String.Empty) != 0)
        {
            string[] ParamParts = PageParams.Split(new char[] { ',' });
            JMD_OBJ_ID.Value = ParamParts[0].Split(new char[] { '=' })[1].ToString();

             
            DataTable dt;

            dt = SqlServer.JMD_COL_SELECT_COLUMNS(JMD_OBJ_ID.Value);
            
            HtmlTable ht = new HtmlTable();
            ht.Attributes.Add("class","TableForm");
            bool TableHeader = true;
            
            foreach (DataRow dr in dt.Rows)
            {
                if (TableHeader)
                {
                    HtmlTableRow htr1 = new HtmlTableRow();
                    HtmlTableCell htc2 = new HtmlTableCell("th");
                    htc2.InnerHtml = string.Format("<h2 class=\"TableFormH2\">{0}</h2>",
                        dr["OBJ_NAME"].ToString());
                    htc2.ColSpan = 2;
                    htc2.Attributes.Add("class", "TableFormTdLeft");
                    htr1.Cells.Add(htc2);
                    ht.Rows.Add(htr1);

                    HtmlTableRow htr2 = new HtmlTableRow();
                    HtmlTableCell htc3 = new HtmlTableCell("td");
                    htc3.InnerHtml = string.Format("{0}",
                        dr["OBJ_DESC"].ToString());
                    htc3.ColSpan = 2;
                    htc3.Attributes.Add("class", "TableFormTdLeft");
                    htr2.Cells.Add(htc3);
                    ht.Rows.Add(htr2);

                    TableHeader = false;
                }

                HtmlTableRow htr = new HtmlTableRow();

                Literal lt = new Literal();
                HtmlTableCell htc1 = new HtmlTableCell();
                lt.Text = string.Format("<h2><a href=\"javascript:expandcollapse('{0}')\">{1}</a></h2>",
                    dr["JMD_COL_NAME"].ToString(),
                    dr["JMD_COL_CAPTION"].ToString());
                lt.Text += string.Format("<div  class=\"divhidden\" id=\"{0}\" name=\"{0}\">{1}</div>", 
                    dr["JMD_COL_NAME"].ToString(),
                    dr["JMD_COL_DESC"].ToString());

                htc1.Controls.Add(lt);
                htc1.Attributes.Add("runat", "Server");
                htc1.Attributes.Add("class","TableFormTdLeft");
                htr.Cells.Add(htc1);
                

                HtmlTableCell htc = new HtmlTableCell();
                if (dr["COL_TYPE"].ToString() == "CheckBox")
                {
                    CheckBox chk = new CheckBox();
                    chk.Text = dr["JMD_COL_CAPTION"].ToString();
                    //chk.ID = string.Format("CheckBox_{0}", dr["ID"].ToString());

                    chk.ID = string.Format("{0}_{1}",
                        dr["JMD_COL_NAME"].ToString(),
                        dr["ID"].ToString()
                        );
                    chk.Attributes.Add("name", chk.ID);

                    chk.Attributes.Add("class", "CheckBoxClass");
                    chk.Attributes.Add("runat", "Server");
                    if (Util.CheckBoxDefault(dr["COL_EXT_DATA"].ToString()) == "True")
                    {
                        chk.Checked = true;
                    }
                    else
                    {
                        chk.Checked = false;
                    }
                    htc.Controls.Add(chk);
                }
                if (dr["COL_TYPE"].ToString() == "CheckBoxList")
                {
                    CheckBoxList chkl = new CheckBoxList();
                    //chkl.ID = string.Format("CheckBox_{0}", dr["ID"].ToString());
                    chkl.ID = string.Format("{0}_{1}",
                        dr["JMD_COL_NAME"].ToString(),
                        dr["ID"].ToString()
                        );
                    chkl.Attributes.Add("name", chkl.ID);

                    string ListItems = Util.ListItems(dr["COL_EXT_DATA"].ToString());
                    string[] ListParts = ListItems.Split(new char[] { ';' });
                    foreach (string str in ListParts)
                    {
                        if (str.Trim() != string.Empty)
                        {
                            chkl.Items.Add(str.Trim());
                        }
                    }
                    chkl.RepeatLayout = RepeatLayout.Flow;
                    chkl.Attributes.Add("class", "CheckBoxClass");
                    chkl.Attributes.Add("runat", "Server");
                    htc.Controls.Add(chkl);
                }
                if (dr["COL_TYPE"].ToString() == "ComboBox")
                {
                    DropDownList ddl = new DropDownList();
                    //ddl.ID = string.Format("ComboBox_{0}", dr["ID"].ToString());

                    ddl.ID = string.Format("{0}_{1}",
                        dr["JMD_COL_NAME"].ToString(),
                        dr["ID"].ToString()
                        );
                    ddl.Attributes.Add("name", ddl.ID);


                    string ListItems = Util.ListItems(dr["COL_EXT_DATA"].ToString());
                    string[] ListParts = ListItems.Split(new char[] { ';' });
                    foreach (string str in ListParts)
                    {
                        if (str.Trim() != string.Empty)
                        {
                            ddl.Items.Add(str.Trim());
                        }
                    }
                    ddl.Attributes.Add("runat", "Server");
                    ddl.Attributes.Add("class", "ComboBoxClass");
                    htc.Controls.Add(ddl);
                }
                if (dr["COL_TYPE"].ToString() == "ListBox")
                {
                    ListBox lb = new ListBox();
                    //lb.ID = string.Format("ListBox_{0}", dr["ID"].ToString());
                    lb.ID = string.Format("{0}_{1}",
                        dr["JMD_COL_NAME"].ToString(),
                        dr["ID"].ToString()
                        );
                    lb.Attributes.Add("name", lb.ID);



                    string ListItems = Util.ListItems(dr["COL_EXT_DATA"].ToString());
                    string[] ListParts = ListItems.Split(new char[] { ';' });
                    foreach (string str in ListParts)
                    {
                        if (str.Trim() != string.Empty)
                        {
                            lb.Items.Add(str.Trim());
                        }
                    }

                    lb.Attributes.Add("runat", "Server");
                    lb.Attributes.Add("class", "ListBoxClass");
                    htc.Controls.Add(lb);
                }

                if (dr["COL_TYPE"].ToString() == "RadioButton")
                {
                    RadioButtonList rbl = new RadioButtonList();
                    //rbl.ID = string.Format("rbl_{0}", dr["ID"].ToString());

                    rbl.ID = string.Format("{0}_{1}",
                        dr["JMD_COL_NAME"].ToString(),
                        dr["ID"].ToString()
                        );
                    rbl.Attributes.Add("name", rbl.ID);


                    string ListItems = Util.ListItems(dr["COL_EXT_DATA"].ToString());
                    string[] ListParts = ListItems.Split(new char[] { ';' });
                    foreach (string str in ListParts)
                    {
                        if (str.Trim() != string.Empty)
                        {
                            rbl.Items.Add(str.Trim());
                        }
                    }
                    rbl.RepeatLayout = RepeatLayout.Flow;
                    rbl.Attributes.Add("runat", "Server");
                    rbl.Attributes.Add("class", "RadioButtonClass");
                    htc.Controls.Add(rbl);
                }

                if (dr["COL_TYPE"].ToString() == "Lookup")
                {
                    DropDownList Lookup = new DropDownList();
                    //Lookup.ID = string.Format("Lookup_{0}", dr["ID"].ToString());

                    Lookup.ID = string.Format("{0}_{1}",
                        dr["JMD_COL_NAME"].ToString(),
                        dr["ID"].ToString()
                        );
                    Lookup.Attributes.Add("name", Lookup.ID);


                    string LookupObjId = Util.LookupSource(dr["COL_EXT_DATA"].ToString());
                    string LookupColName = Util.LookupField(dr["COL_EXT_DATA"].ToString());

                    string Table_Name = string.Empty;
                    DataTable dtTableName;
                    dtTableName = SqlServer.JMD_GET_TABLE_NAME(
                        Util.SiteURL(Request.QueryString["Pg"].ToString()),
                        LookupObjId);
                    if (dtTableName.Rows.Count > 0)
                    {
                        Table_Name = dtTableName.Rows[0]["Table_Name"].ToString();
                    }
                    dtTableName.Dispose();

                    DataTable LookupRecords;
                    LookupRecords = SqlServer.DynamicTableSelect(Table_Name, string.Format("ID,{0}", LookupColName));
                    foreach (DataRow Lr in LookupRecords.Rows)
                    {
                        if (Lr[1].ToString().Trim() != string.Empty)
                        {
                            ListItem li = new ListItem();
                            li.Text = Lr[1].ToString();
                            li.Value = Lr[0].ToString();
                            Lookup.Items.Add(li);
                        }
                    }
                    LookupRecords.Dispose();

                    /*
                    string ListItems = Util.ListItems(dr["COL_EXT_DATA"].ToString());
                    string[] ListParts = ListItems.Split(new char[] { ';' });
                    foreach (string str in ListParts)
                    {
                        if (str.Trim() != string.Empty)
                        {
                            ddl.Items.Add(str.Trim());
                        }
                    }
                     */
                    Lookup.Attributes.Add("runat", "Server");
                    Lookup.Attributes.Add("class", "ComboBoxClass");
                    htc.Controls.Add(Lookup);
                   
                }

                if (dr["COL_TYPE"].ToString() == "DateTime")
                {
                    TextBox dateTime = new TextBox();
                    //dateTime.ID = string.Format("dateTime_{0}", dr["ID"].ToString());
                    dateTime.ID = string.Format("{0}_{1}",
                        dr["JMD_COL_NAME"].ToString(),
                        dr["ID"].ToString()
                        );
                    dateTime.Attributes.Add("name", dateTime.ID);


                    dateTime.Attributes.Add("runat", "Server");
                    dateTime.Attributes.Add("class", "DateTimeClass");
                    htc.Controls.Add(dateTime);
                }

                if (dr["COL_TYPE"].ToString() == "Money")
                {
                    TextBox money = new TextBox();
                    //money.ID = string.Format("money_{0}", dr["ID"].ToString());
                    money.ID = string.Format("{0}_{1}",
                        dr["JMD_COL_NAME"].ToString(),
                        dr["ID"].ToString()
                        );
                    money.Attributes.Add("name", money.ID);


                    money.Attributes.Add("runat", "Server");
                    money.Attributes.Add("class", "MoneyClass");
                    htc.Controls.Add(money);
                }
                if (dr["COL_TYPE"].ToString() == "MultiLine")
                {
                    TextBox MultiLine = new TextBox();

                    //MultiLine.ID = string.Format("MultiLine_{0}", dr["ID"].ToString());

                    MultiLine.ID = string.Format("{0}_{1}",
                        dr["JMD_COL_NAME"].ToString(),
                        dr["ID"].ToString()
                        );

                    MultiLine.Attributes.Add("name", MultiLine.ID);

                    string TotalLines;
                    TotalLines = Util.TextTotalLines(dr["COL_EXT_DATA"].ToString());

                    if ( TotalLines != string.Empty )
                    {
                        MultiLine.Rows = Convert.ToInt16(TotalLines);
                    }
                    MultiLine.Height = 100;
                    MultiLine.Attributes.Add("runat", "Server");
                    MultiLine.Attributes.Add("class", "MultiLineClass");
                    MultiLine.TextMode = TextBoxMode.MultiLine;
                    
                    htc.Controls.Add(MultiLine);
                }
                if (dr["COL_TYPE"].ToString() == "Number")
                {
                    TextBox Number = new TextBox();
                    //Number.ID = string.Format("Number_{0}", dr["ID"].ToString());

                    Number.ID = string.Format("{0}_{1}",
                        dr["JMD_COL_NAME"].ToString(),
                        dr["ID"].ToString()
                        );
                    Number.Attributes.Add("name", Number.ID);

                    Number.Attributes.Add("runat", "Server");
                    Number.Attributes.Add("class", "NumberClass");
                    htc.Controls.Add(Number);
                }
                if (dr["COL_TYPE"].ToString() == "SingleLine")
                {
                    TextBox tx = new TextBox();
                    tx.ID = string.Format("{0}_{1}", 
                        dr["JMD_COL_NAME"].ToString(),
                        dr["ID"].ToString()
                        );

                    tx.Attributes.Add("name", tx.ID);

                    tx .Attributes.Add("runat", "Server");
                    tx.Attributes.Add("class", "SingleLineClass");
                    htc.Controls.Add(tx);
                }

                htc.Attributes.Clear();
                htc.Attributes.Add("class", "TableFormTdRight");
                htr.Cells.Add(htc);
                ht.Rows.Add(htr);
            }
            DynamicObjects.Controls.Add(ht);
            dt.Dispose();
        }
    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        Literal1.Text = GetInsertSql();
        Save();
        /*
        Control ctl = FindControl("JMD_OBJ_NAME");
        if (ctl != null)
        {
            Literal1.Text = (ctl as Label).Text;
        }
         */ 
    }
    private void Save()
    {
        string InsertSql = string.Empty;
        InsertSql = GetInsertSql();
         
        SqlServer.ExecuteSql(InsertSql);
    }
    private string GetInsertSql()
    {
        StringBuilder sb = new StringBuilder();
         
        DataTable dt, dt1;
        string Table_Name = string.Empty;
        int ctr = 0;

        dt = SqlServer.JMD_GET_TABLE_NAME(
            Util.SiteURL(Request.QueryString["Pg"].ToString()),
            JMD_OBJ_ID.Value);

        if (dt.Rows.Count > 0)
        {
            Table_Name = dt.Rows[0]["Table_Name"].ToString();
        }
        sb.AppendFormat("Insert into {0} (", Table_Name);
        dt1 = SqlServer.JMD_COL_SELECT_COLUMNS(JMD_OBJ_ID.Value);
        

        foreach (DataRow dr in dt1.Rows)
        {
            if (ctr != 0)
            {
                sb.AppendFormat(", ");
            }
            sb.AppendFormat("{0}", 
                dr["JMD_COL_NAME"].ToString());
            ctr = 1;
        }
        sb.AppendFormat(") values (");
        ctr = 0;
        foreach (DataRow dr in dt1.Rows)
        {
            if (ctr != 0)
            {
                sb.AppendFormat(", ");
            }
            sb.AppendFormat("'{0}'",
                GetColValue(dr["JMD_COL_NAME"].ToString(),
                    dr["COL_TYPE"].ToString(),
                    dr["ID"].ToString()));
            ctr = 1;
        }
        sb.AppendFormat(")");
        
        dt1.Dispose();
        dt.Dispose();
        return sb.ToString();
        //sb.Append("Insert into 
    }
    private string GetColValue(string ColName, 
        string ColType, string ColId)
    {
        if ( (ColType == "SingleLine") || (ColType == "MultiLine") )
        {
            return GetTextBoxValue(ColName, ColId);
        }
        else if (ColType == "CheckBox")
        {
            return GetCheckBoxValue(ColName, ColId);
        }
        else if (ColType == "CheckBoxList")
        {
            return GetCheckBoxListValue(ColName, ColId);
        }
        else if ( (ColType == "ComboBox") || (ColType == "Lookup") )
        {
            return GetComboBoxValue(ColName, ColId);
        }
        else if (ColType == "ListBox")
        {
            return GetListBoxValue(ColName, ColId);
        }
        else if (ColType == "RadioButton")
        {
            return GetRadioButtonListValue(ColName, ColId);
        }
        else if (ColType == "DateTime")
        {
            return GetDateTimeValue(ColName, ColId);
        }
        else
        {
            return "Column Type is not supported!";
        }
    }
    private string GetTextBoxValue(string ColName, string ColId)
    {
        Control ctl = FindControl(string.Format("{0}_{1}",
            ColName,
            ColId));
        if (ctl != null)
        {
            return (ctl as TextBox).Text;
        }
        else
        {
            return "Object Not Found!";
        }
    }
    private string GetCheckBoxValue(string ColName, string ColId)
    {
        Control ctl = FindControl(string.Format("{0}_{1}",
            ColName,
            ColId));
        if (ctl != null)
        {
            if ((ctl as CheckBox).Checked)
            {
                return "True";
            }
            else
            {
                return "False";
            }
        }
        else
        {
            return "Object Not Found!";
        }
    }
    private string GetCheckBoxListValue(string ColName, string ColId)
    {
        Control ctl = FindControl(string.Format("{0}_{1}",
            ColName,
            ColId));
        if (ctl != null)
        {
            string ListValues = string.Empty;
            foreach (ListItem li in (ctl as CheckBoxList).Items)
            {
                if (li.Selected)
                {
                    if (ListValues != String.Empty)
                    {
                        ListValues += ";";
                    }
                    ListValues += li.Value;
                }
            }
            return ListValues;
        }
        else
        {
            return "Object Not Found!";
        }
    }
    private string GetComboBoxValue(string ColName, string ColId)
    {
        Control ctl = FindControl(string.Format("{0}_{1}",
            ColName,
            ColId));
        if (ctl != null)
        {
            string ListValues = string.Empty;
            foreach (ListItem li in (ctl as DropDownList).Items)
            {
                if (li.Selected)
                {
                    if (ListValues != String.Empty)
                    {
                        ListValues += ";";
                    }
                    ListValues += li.Value;
                }
            }
            return ListValues;
        }
        else
        {
            return "Object Not Found!";
        }
    }
    private string GetListBoxValue(string ColName, string ColId)
    {
        Control ctl = FindControl(string.Format("{0}_{1}",
            ColName,
            ColId));
        if (ctl != null)
        {
            string ListValues = string.Empty;
            foreach (ListItem li in (ctl as ListBox).Items)
            {
                if (li.Selected)
                {
                    if (ListValues != String.Empty)
                    {
                        ListValues += ";";
                    }
                    ListValues += li.Value;
                }
            }
            return ListValues;
        }
        else
        {
            return "Object Not Found!";
        }
    }
    private string GetRadioButtonListValue(string ColName, string ColId)
    {
        Control ctl = FindControl(string.Format("{0}_{1}",
            ColName,
            ColId));
        if (ctl != null)
        {
            string ListValues = string.Empty;
            foreach (ListItem li in (ctl as RadioButtonList).Items)
            {
                if (li.Selected)
                {
                    if (ListValues != String.Empty)
                    {
                        ListValues += ";";
                    }
                    ListValues += li.Value;
                }
            }
            return ListValues;
        }
        else
        {
            return "Object Not Found!";
        }
    }
    private string GetDateTimeValue(string ColName, string ColId)
    {
        Control ctl = FindControl(string.Format("{0}_{1}",
            ColName,
            ColId));
        if (ctl != null)
        {
            return (ctl as TextBox).Text;
        }
        else
        {
            return "Object Not Found!";
        }
    }


    private void ButtonHandler(object sender, CommandEventArgs e)
    {
        //lblInfo.Text = e.CommandArgument.ToString();
        //Label1.Text = "Hello, I am dynamic";
     /*
        Label1.Text = e.CommandArgument.ToString();
        Control ctl;
        ctl = FindControl(e.CommandArgument.ToString());
        if (ctl != null)
        {
            if ((ctl as Panel).Visible)
            {
                (ctl as Panel).Visible = false;
            }

            else
            {
                (ctl as Panel).Visible = true;
            }
        }
      */ 
    }
    protected void Button3_Click1(object sender, EventArgs e)
    {
        #region Some code backup
        //Label1.Text = "I am regular event";
        /*

         * TextBox lookup = new TextBox();
lookup.ID = string.Format("lookup_{0}", dr["ID"].ToString());
lookup.Attributes.Add("runat", "Server");
lookup.Attributes.Add("class", "LookupClass");
lookup.Text += "I am lookup";
htc.Controls.Add(lookup);
Button btn = new Button();
btn.UseSubmitBehavior = false;
btn.CausesValidation = false;
btn.Attributes.Add("runat", "Server");
btn.Attributes.Add("class", "LookupClassButton");
btn.Text = " . . . ";
//btn.Command +=
//btn.Attributes.Add("OnClick", "Btn_Command");
//btn.Command
btn.Command += new CommandEventHandler(ButtonHandler);
btn.CommandArgument = string.Format("Panel_{0}", dr["ID"].ToString());
htc.Controls.Add(btn);

Panel pnl = new Panel();
pnl.ID = string.Format("Panel_{0}", dr["ID"].ToString());
pnl.Attributes.Add("runat", "Server");
pnl.Attributes.Add("class", "PanelClass");
//pnl.Visible = false;
htc.Controls.Add(pnl);
*/                    

                    
/*
String JavaScript = " var strReturn; ";
JavaScript += " strReturn=window.showModalDialog('LookupDialog.aspx',null,'status:no;dialogWidth:600px;dialogHeight:500px;dialogHide:true;help:no;scroll:no'); ";
JavaScript += string.Format("if (strReturn != null) document.getElementById('{0}').value=strReturn;", lookup.ID);
                        
LinkButton btn = new LinkButton();
btn.Text = " . . . ";
btn.Attributes.Add("runat", "Server");
btn.Attributes.Add("class", "LookupClassButton");
//btn.UseSubmitBehavior = false;
btn.CausesValidation = false;
btn.Attributes.Add("OnClick", JavaScript); 
*/

        //btn.Attributes.Add("onclick", "window.showModalDialog('LookupDialog.aspx', null,'status:no;dialogWidth:600px;dialogHeight:500px;dialogHide:true;help:no;scroll:no');");
        //btnOpen.Attributes.Add("onclick", "var strReturn; strReturn=window.showModalDialog('child2.aspx',null,'status:no;dialogWidth:370px;dialogHeight:220px;dialogHide:true;help:no;scroll:no');if (strReturn != null) document.getElementById('txtValue').value=strReturn;")
        //btnOpen.Attributes.Add("onclick", "var strReturn; strReturn=window.showModalDialog('child2.aspx',null,'status:no;dialogWidth:370px;dialogHeight:220px;dialogHide:true;help:no;scroll:no');if (strReturn != null) document.getElementById('txtValue').value=strReturn;")
        //btn.Attributes.Add("onclick", "window.showModalDialog('LookupDialog.aspx', null,'status:no;dialogWidth:600px;dialogHeight:500px;dialogHide:true;help:no;scroll:no');");


        /*
        String JavaScript = " var strReturn; ";
        JavaScript += " strReturn=window.showModalDialog('LookupDialog.aspx',null,'status:no;dialogWidth:600px;dialogHeight:500px;dialogHide:true;help:no;scroll:no'); ";
        JavaScript += string.Format("if (strReturn != null) document.getElementById('{0}').value=strReturn;", lookup.ID);
        btn.Attributes.Add("onclick",JavaScript );                    
        */
        #endregion
    }


}
