// ----------------------------------------------------------------------------
// markItUp!
// ----------------------------------------------------------------------------
// Copyright (C) 2008 Jay Salvat
// http://markitup.jaysalvat.com/
// ----------------------------------------------------------------------------
// BBCode tags example
// http://en.wikipedia.org/wiki/Bbcode
// ----------------------------------------------------------------------------
// Feel free to add more tags
// ----------------------------------------------------------------------------
var myHtmlSettings = {
    nameSpace: "markItUp",
    onShiftEnter: { keepDefault: false, replaceWith: '[br]\n' },
    onCtrlEnter: { keepDefault: false, openWith: '[br]\n', closeWith: ' ' },
    onTab: { keepDefault: false, openWith: '     ' },
	previewParserPath:	'', // path to your BBCode parser
	markupSet: [
		{name:'Bold', key:'B', openWith:'[b]', closeWith:'[/b]'},
		{name:'Italic', key:'I', openWith:'[i]', closeWith:'[/i]'},
		{ name: 'Underline', key: 'U', openWith: '[u]', closeWith: '[/u]' },
		{ name: 'Paragraph', key: 'P', openWith: '[p]', closeWith: '[/p]' },
		{separator:'---------------' },
		{
		dropMenu: [
            { name: 'Picture', key: 'PC', openWith: '[img class=style1 width=100 height=100] Put Image URL Here....', closeWith: '[/img]' },
            { name: 'Picture-Left', key: 'PL', openWith: '[img class=align-left width=100 height=100] Put Image URL Here....', closeWith: '[/img] \n[p]\n Your contents here.... \n[/p]' },
            { name: 'Picture-Right', key: 'PL', openWith: '[img class=align-right width=100 height=100] Put Image URL Here....', closeWith: '[/img] \n[p]\n Your contents here.... \n[/p]' },
            { name: 'Picture-Gallary', key: 'PG', openWith: '[div class=gallery] \n[url rel=gallery0 href=Put zoom image place holder... ] [img class=style1 width=100 height=100] Put Image URL Here...', closeWith: '[/img][/url]\n[/div]' },
            { name: 'Picture-Slideshow', key: 'PS', openWith: '[slideshow class=slideshow height=450 width=450] \n[slide src=image height=450 width=450]', closeWith: '[/slide]\n[/slideshow]' },

        ]
		},
		{name:'Link', key:'L', openWith:'[url=[![Url]!]]', closeWith:'[/url]', placeHolder:'Your text to link here...'},
		{separator:'---------------' },
		{
		dropMenu: [
            { name: 'Heading 1', key: '1', openWith: '[h1(!( class="[![Class]!]")!)]', closeWith: '[/h1]', placeHolder: 'Your title here...' },
            { name: 'Heading 2', key: '2', openWith: '[h2(!( class="[![Class]!]")!)]', closeWith: '[/h2]', placeHolder: 'Your title here...' },
            { name: 'Heading 3', key: '3', openWith: '[h3(!( class="[![Class]!]")!)]', closeWith: '[/h3]', placeHolder: 'Your title here...' },
            { name: 'Heading 4', key: '4', openWith: '[h4(!( class="[![Class]!]")!)]', closeWith: '[/h4]', placeHolder: 'Your title here...' },
            { name: 'Heading 5', key: '5', openWith: '[h5(!( class="[![Class]!]")!)]', closeWith: '[/h5]', placeHolder: 'Your title here...' },
            { name: 'Heading 6', key: '6', openWith: '[h6(!( class="[![Class]!]")!)]', closeWith: '[/h6]', placeHolder: 'Your title here...' }
		]},
		{ separator: '---------------' },
		{name:'Bulleted list', openWith:'[list]\n', closeWith:'\n[/list]'},
		{name:'Numeric list', openWith:'[list=[![Starting number]!]]\n', closeWith:'\n[/list]'}, 
		{name:'List item', openWith:'[*] '},
		{separator:'---------------' },
		{name:'Quotes', openWith:'[quote]', closeWith:'[/quote]'},
		{name:'Code', openWith:'[code]', closeWith:'[/code]'}, 
		{ separator: '---------------' },
        { name: 'Tab', openWith: '[tab] \n    [TabItem href=tabname1]Tab1 Caption[/TabItem] \n    [TabItem href=tabname2]Tab2 Caption[/TabItem] \n', closeWith: '[/tab] \n[tabcontent id=tabname1]Tab1 Content here... [/tabcontent] \n[tabcontent id=tabname2]Tab2 Content here... [/tabcontent]' },
		{
		    dropMenu: [
                { name: '1 Column', key: '1', openWith: '[div class=col_12] \n  columns 1 contents here \n [/div] \n', closeWith: '[div class=clear][/div]' },
                { name: '2 Column', key: '2', openWith: '[div class=col_6] \n columns 1 contents here \n [/div] \n', closeWith: '[div class=col_6] \n columns 2 contents here \n [/div] \n[div class=clear][/div]' },
            	{ name: '3 Column', key: '3', openWith: '[div class=col_4] \n columns 1 contents here \n [/div] \n [div class=col_4]\n columns 2 contents here \n[/div] \n', closeWith: '[div class=col_4]\n columns 3 contents here \n [/div] \n[div class=clear][/div]' },
            	{ name: '4 Column', key: '4', openWith: '[div class=col_3] \n columns 1 contents here \n [/div] \n [div class=col_3] \n columns 2 contents here \n [/div] \n', closeWith: '[div class=col_3] \n columns 3 contents here \n [/div] \n[div class=col_3] \n columns 4 contents here \n [/div] \n[div class=clear][/div]' },
            	{ name: '20x80 2 Column', key: '2', openWith: '[div class=col_2] \n columns 1 contents here \n [/div] \n', closeWith: '[div class=col_10] \n columns 2 contents here \n [/div] \n[div class=clear][/div]' },
            	{ name: '30x70 2 Column', key: '2', openWith: '[div class=col_3] \n columns 1 contents here \n [/div] \n', closeWith: '[div class=col_9] \n columns 2 contents here \n [/div] \n[div class=clear][/div]' },
            	{ name: '45x65 2 Column', key: '2', openWith: '[div class=col_4] \n columns 1 contents here \n [/div] \n', closeWith: '[div class=col_8] \n columns 2 contents here \n [/div] \n[div class=clear][/div]' },
            	{ name: '65x45 2 Column', key: '2', openWith: '[div class=col_8] \n columns 1 contents here \n [/div] \n', closeWith: '[div class=col_4] \n columns 2 contents here \n [/div] \n[div class=clear][/div]' },
            	{ name: '70x30 2 Column', key: '2', openWith: '[div class=col_9] \n columns 1 contents here \n [/div] \n', closeWith: '[div class=col_3] \n columns 2 contents here \n [/div] \n[div class=clear][/div]' },
            	{ name: '80x20 2 Column', key: '2', openWith: '[div class=col_10] \n columns 1 contents here \n [/div] \n', closeWith: '[div class=col_2] \n columns 2 contents here \n [/div] \n[div class=clear][/div]' }
		    ]
        },
        { separator: '---------------' },
        {
            dropMenu: [
                { name: 'iframe', openWith: '[iframe w=600 h=600 ] your url here... ', closeWith: '[/iframe]' },
                { name: 'Youtube', openWith: '[youtube w=560 h=315 ] http://www.youtube.com/embed/yourvideoidhere... ', closeWith: '[/youtube]' },
                { name: 'facebook', openWith: '[facebook] your url here .... ', closeWith: '[/facebook]' },
                { name: 'twitter', openWith: '[twitter] data-hashtags here .... ', closeWith: '[/twitter]' },


                //{ name: 'Google Adsense', openWith: '[adsense adslot=? w=? h=? ]your google adsense ad client here..', closeWith: '[/adsense]' },
                //{ name: 'Google Analytics', openWith: '[analytics] your google analytics account id here ', closeWith: '[/analytics]' },
            ]
        }
	]
}